drop package cw_assess;

----------------------------------------------------  
create or replace package cw_assess is  
----------------------------------------------------  
procedure rm (iid in number);
function get(iid in number) return cw_assess_table%rowtype;
procedure put(iorow in out cw_assess_table%rowtype);
function new(iorow in out cw_assess_table%rowtype) return cw_assess_table.id%type;
function next(ionrow in out cw_assess_table%rowtype) return boolean;
-- procedure search_action(column_num in varchar2);  
procedure insert_action(
	cookie 		varchar2,
 	idaym		varchar2,
 	idayd		varchar2,
 	idayy		varchar2,
------------- Vital Signs ---------
	iheart		varchar2,
	irespiratory 	varchar2,
	itemperature	varchar2,
------------- History ---------
	ionset		varchar2,
	iduration	varchar2,
	ifever 		varchar2,
	irash		varchar2,
	icough		varchar2,
	irhinorrhea	varchar2,
	ihoarseness	varchar2,
	iswallowing	varchar2,
	ibreathing	varchar2,
	iabdominalpnv	varchar2,
	ihother		varchar2,
	iexposure	varchar2,
	itreated	varchar2,
	ihelped		varchar2,
------------- General Impression ---------
	iattention	varchar2,
	iactivity	varchar2,
	idistress	varchar2,
	itoxic		varchar2,
------------- Physical Examination ---------
-- eyes
	idrainage	varchar2,
	idramount	varchar2,
	idrcolor	varchar2,
	idrconsistency	varchar2,
-- ears
	iexcanal	varchar2,
	itmcolor	varchar2,
	itmtranslucency	varchar2,
	itmreflection	varchar2,
	itmfluid	varchar2,
	itmretracted	varchar2,
	itmmobility	varchar2,
	itmtympanometer	varchar2,
-- nose
	irhamount	varchar2,
	irhcolor	varchar2,
	irhconsistency	varchar2,
-- mouth
	imouth		varchar2,
-- throat
	ithcolor	varchar2,
	ironsilsize	varchar2,
	itonsilsymm	varchar2,
	iuvula		varchar2,
	iexudate	varchar2,
	iexuamount	varchar2,
	iexucolor	varchar2,
	iposdischarge	varchar2,
	iulcervesicle	varchar2,
-- neck
	isupple		varchar2,
	ianternode	varchar2,
	iposternode	varchar2,
	ioccipnode	varchar2,
	-- chest
	iabsound	varchar2,	
	icracle		varchar2,
	iwheeze		varchar2,
	irhonchi	varchar2,
	ituasound	varchar2,
	iairentry	varchar2,
	isrlocation	varchar2,
	isrnumber	varchar2,
	isrpattern	varchar2,
	isrsize		varchar2,
	isrquality	varchar2,
-- abdomen
	isoft		varchar2,
	idistention	varchar2,
	iorganomegaly	varchar2,
	iingunode	varchar2,
----- Plan -------
	iplan		varchar2
);

procedure update_action(
	cookie 		 varchar2,
 	idaym		varchar2,
 	idayd		varchar2,
 	idayy		varchar2,
--	iday		date,
------------- Vital Signs ---------
	iheart		varchar2,
	irespiratory 	varchar2,
	itemperature	varchar2,
------------- History ---------
	ionset		varchar2,
	iduration	varchar2,
	ifever 		varchar2,
	irash		varchar2,
	icough		varchar2,
	irhinorrhea	varchar2,
	ihoarseness	varchar2,
	iswallowing	varchar2,
	ibreathing	varchar2,
	iabdominalpnv	varchar2,
	ihother		varchar2,
	iexposure	varchar2,
	itreated	varchar2,
	ihelped		varchar2,
------------- General Impression ---------
	iattention	varchar2,
	iactivity	varchar2,
	idistress	varchar2,
	itoxic		varchar2,
------------- Physical Examination ---------
-- eyes
	idrainage	varchar2,
	idramount	varchar2,
	idrcolor	varchar2,
	idrconsistency	varchar2,
-- ears
	iexcanal	varchar2,
	itmcolor	varchar2,
	itmtranslucency	varchar2,
	itmreflection	varchar2,
	itmfluid	varchar2,
	itmretracted	varchar2,
	itmmobility	varchar2,
	itmtympanometer	varchar2,
-- nose
	irhamount	varchar2,
	irhcolor	varchar2,
	irhconsistency	varchar2,
-- mouth
	imouth		varchar2,
-- throat
	ithcolor	varchar2,
	ironsilsize	varchar2,
	itonsilsymm	varchar2,
	iuvula		varchar2,
	iexudate	varchar2,
	iexuamount	varchar2,
	iexucolor	varchar2,
	iposdischarge	varchar2,
	iulcervesicle	varchar2,
-- neck
	isupple		varchar2,
	ianternode	varchar2,
	iposternode	varchar2,
	ioccipnode	varchar2,
	-- chest
	iabsound	varchar2,	
	icracle		varchar2,
	iwheeze		varchar2,
	irhonchi	varchar2,
	ituasound	varchar2,
	iairentry	varchar2,
	isrlocation	varchar2,
	isrnumber	varchar2,
	isrpattern	varchar2,
	isrsize		varchar2,
	isrquality	varchar2,
-- abdomen
	isoft		varchar2,
	idistention	varchar2,
	iorganomegaly	varchar2,
	iingunode	varchar2,
----- Plan -------
	iplan		varchar2
);
procedure delete_action(cookie in varchar2, iid in varchar2); 
end;  
/
show errors;
-- /

---------------------------------------------------------  
create or replace package body cw_assess is  
---------------------------------------------------------  
  me varchar2(64);
  this cw_assess_table%type;
  lstu cw_student_table%type;
  lnur cw_nurse_table%type;
--  id_null exception;
  cursor nrow is
     select * from cw_assess_table order by day;
--
---------------------------------------------------------  
procedure rm (iid in number) is
---------------------------------------------------------  
    begin
      delete from cw_assess_table 
        where id = iid;
--      htp.p('rm:iid='||to_char(iid));
      exception
        when no_data_found then
          raise;
        when others then
	  cw_error.panic('cw_assess.rm iid=' || to_char(iid),sqlerrm);
  end;
--
---------------------------------------------------------  
function get(iid in number) return cw_assess_table%rowtype is
---------------------------------------------------------  
    cursor c (this_id number) is
      select * from cw_assess_table the
      where the.id = this_id;
  begin
    open c (iid);
    fetch c into this;
    if c%notfound then
      raise no_data_found;
    end if;
    close c;
    return this;
    exception
      when no_data_found then
        raise;
      when others then
	cw_error.panic('cw_assess.get iid=' || to_char(iid),sqlerrm);
  end;
--
---------------------------------------------------------  
  procedure put(iorow in out cw_assess_table%rowtype) is
---------------------------------------------------------  
    cursor c (this_id number) is
      select * from cw_assess_table
      where id = this_id
      for update  of day;
    begin
      if (iorow.id is null) then
	select cw_assess_seq.nextval into iorow.id
	  from dual;
        insert into cw_assess_table
	  values ( 
		iorow.id,			
		iorow.student_id,
		iorow.nurse_id,	
		iorow.day,
		------------- Vital Signs ---------
		iorow.heart,		
		iorow.respiratory, 	
		iorow.temperature,	
		------------- History ---------
		iorow.onset,	
		iorow.duration,
		iorow.fever, 		
		iorow.rash,		
		iorow.cough,		
		iorow.rhinorrhea,	
		iorow.hoarseness,	
		iorow.swallowing,	
		iorow.breathing,	
		iorow.abdominalpnv,	
		iorow.hother,		
		iorow.exposure,	
		iorow.treated,		
		iorow.helped,		
		------------- General Impression ---------
		iorow.attention,	
		iorow.activity,	
		iorow.distress,	
		iorow.toxic,		
		------------- Physical Examination ---------
		-- eyes
		iorow.drainage,	
		iorow.dramount,	
		iorow.drcolor,		
		iorow.drconsistency,	
		-- ears
		iorow.excanal,		
		iorow.tmcolor,		
		iorow.tmtranslucency,	
		iorow.tmreflection,	
		iorow.tmfluid,		
		iorow.tmretracted,	
		iorow.tmmobility,	
		iorow.tmtympanometer,	
		-- nose
		iorow.rhamount,	
		iorow.rhcolor,		
		iorow.rhconsistency,	
		-- mouth
		iorow.mouth,		
		-- throat
		iorow.thcolor,		
		iorow.ronsilsize,	
		iorow.tonsilsymm,	
		iorow.uvula,		
		iorow.exudate,		
		iorow.exuamount,	
		iorow.exucolor,	
		iorow.posdischarge,	
		iorow.ulcervesicle,	
		-- neck
		iorow.supple,		
		iorow.anternode,	
		iorow.posternode,	
		iorow.occipnode,	
		-- chest
		iorow.absound,		
		iorow.cracle,		
		iorow.wheeze,		
		iorow.rhonchi,		
		iorow.tuasound,	
		iorow.airentry,	
		iorow.srlocation,	
		iorow.srnumber,	
		iorow.srpattern,	
		iorow.srsize,		
		iorow.srquality,	
		-- abdomen
		iorow.soft,		
		iorow.distention,	
		iorow.organomegaly,	
		iorow.ingunode,	
		----- Plan -------
		iorow.plan		
	    );
      else
        open c (iorow.id);
	fetch c into this;
	if c%found then
	  update  cw_assess_table set
		id = iorow.id,			
		student_id	= iorow.student_id,	
		nurse_id 	= iorow.nurse_id,	
     	        day 		= iorow.day,
		------------- Vital Signs ---------
		heart	= iorow.heart,		
		respiratory	= iorow.respiratory, 	
		temperature	= iorow.temperature,	
		------------- History ---------
		onset		= iorow.onset,
		duration	= iorow.duration,
		fever		= iorow.fever, 		
		rash		= iorow.rash,		
		cough		= iorow.cough,		
		rhinorrhea	= iorow.rhinorrhea,	
		hoarseness	= iorow.hoarseness,	
		swallowing	= iorow.swallowing,	
		breathing	= iorow.breathing,	
		abdominalpnv	= iorow.abdominalpnv,	
		hother		= iorow.hother,		
		exposure	= iorow.exposure,	
		treated		= iorow.treated,		
		helped		= iorow.helped,		
		------------- General Impression ---------
		attention	= iorow.attention,	
		activity	= iorow.activity,	
		distress	= iorow.distress,	
		toxic		= iorow.toxic,		
		------------- Physical Examination ---------
		-- eyes
		drainage	= iorow.drainage,
		dramount	= iorow.dramount,	
		drcolor		= iorow.drcolor,		
		drconsistency	= iorow.drconsistency,	
		-- ears
		excanal		= iorow.excanal,		
		tmcolor		= iorow.tmcolor,		
		tmtranslucency	= iorow.tmtranslucency,	
		tmreflection	= iorow.tmreflection,	
		tmfluid		= iorow.tmfluid,		
		tmretracted	= iorow.tmretracted,	
		tmmobility	= iorow.tmmobility,	
		tmtympanometer	= iorow.tmtympanometer,	
		-- nose
		rhamount	= iorow.rhamount,	
		rhcolor		= iorow.rhcolor,		
		rhconsistency	= iorow.rhconsistency,	
		-- mouth
		mouth		= iorow.mouth,		
		-- throat
		thcolor		= iorow.thcolor,		
		ronsilsize	= iorow.ronsilsize,	
		tonsilsymm	= iorow.tonsilsymm,	
		uvula		= iorow.uvula,		
		exudate		= iorow.exudate,		
		exuamount	= iorow.exuamount,	
		exucolor	= iorow.exucolor,	
		posdischarge	= iorow.posdischarge,	
		ulcervesicle	= iorow.ulcervesicle,	
		-- neck
		supple		= iorow.supple,		
		anternode	= iorow.anternode,	
		posternode	= iorow.posternode,	
		occipnode	= iorow.occipnode,	
		-- chest
		absound		= iorow.absound,		
		cracle		= iorow.cracle,		
		wheeze		= iorow.wheeze,		
		rhonchi		= iorow.rhonchi,		
		tuasound	= iorow.tuasound,	
		airentry	= iorow.airentry,	
		srlocation	= iorow.srlocation,	
		srnumber	= iorow.srnumber,	
		srpattern	= iorow.srpattern,	
		srsize		= iorow.srsize,		
		srquality	= iorow.srquality,	
		-- abdomen
		soft		= iorow.soft,		
		distention	= iorow.distention,	
		organomegaly	= iorow.organomegaly,	
		ingunode	= iorow.ingunode,	
		----- Plan -------
		plan		= iorow.plan		
	  where id = iorow.id;
	else
	  raise no_data_found;
	end if;
        close c;
      end if;
    exception
      when no_data_found then
        raise;
      when others then
	cw_error.panic('cw_assess.put iorow.id=' ||iorow.id, sqlerrm);
    end;
--
---------------------------------------------------------  
function new(iorow in out cw_assess_table%rowtype) return cw_assess_table.id%type is
---------------------------------------------------------  
begin
  iorow.id := null;
  put(iorow);
  return iorow.id;
  exception
    when no_data_found then
      raise;
    when others then
      cw_error.panic('cw_assess.new iorow.id=' ||iorow.id, sqlerrm);
end;
--
---------------------------------------------------------  
function next(ionrow in out cw_assess_table%rowtype) return boolean is
---------------------------------------------------------  
begin
   if not nrow%isopen then
        open nrow;
   end if;
   fetch nrow into ionrow;
   if nrow%notfound then
        close nrow;     
        return false;
   else
        return true;
   end if;
exception
   when others then
        cw_error.panic('cw_assess.next',sqlerrm);

end;

---------------------------------------------------------  
procedure insert_action(
	cookie 		 varchar2,
 	idaym		varchar2,
 	idayd		varchar2,
 	idayy		varchar2,
------------- Vital Signs ---------
	iheart		varchar2,
	irespiratory 	varchar2,
	itemperature	varchar2,
------------- History ---------
	ionset		varchar2,
	iduration	varchar2,
	ifever 		varchar2,
	irash		varchar2,
	icough		varchar2,
	irhinorrhea	varchar2,
	ihoarseness	varchar2,
	iswallowing	varchar2,
	ibreathing	varchar2,
	iabdominalpnv	varchar2,
	ihother		varchar2,
	iexposure	varchar2,
	itreated	varchar2,
	ihelped		varchar2,
------------- General Impression ---------
	iattention	varchar2,
	iactivity	varchar2,
	idistress	varchar2,
	itoxic		varchar2,
------------- Physical Examination ---------
-- eyes
	idrainage	varchar2,
	idramount	varchar2,
	idrcolor	varchar2,
	idrconsistency	varchar2,
-- ears
	iexcanal	varchar2,
	itmcolor	varchar2,
	itmtranslucency	varchar2,
	itmreflection	varchar2,
	itmfluid	varchar2,
	itmretracted	varchar2,
	itmmobility	varchar2,
	itmtympanometer	varchar2,
-- nose
	irhamount	varchar2,
	irhcolor	varchar2,
	irhconsistency	varchar2,
-- mouth
	imouth		varchar2,
-- throat
	ithcolor	varchar2,
	ironsilsize	varchar2,
	itonsilsymm	varchar2,
	iuvula		varchar2,
	iexudate	varchar2,
	iexuamount	varchar2,
	iexucolor	varchar2,
	iposdischarge	varchar2,
	iulcervesicle	varchar2,
-- neck
	isupple		varchar2,
	ianternode	varchar2,
	iposternode	varchar2,
	ioccipnode	varchar2,
	-- chest
	iabsound	varchar2,	
	icracle		varchar2,
	iwheeze		varchar2,
	irhonchi	varchar2,
	ituasound	varchar2,
	iairentry	varchar2,
	isrlocation	varchar2,
	isrnumber	varchar2,
	isrpattern	varchar2,
	isrsize		varchar2,
	isrquality	varchar2,
-- abdomen
	isoft		varchar2,
	idistention	varchar2,
	iorganomegaly	varchar2,
	iingunode	varchar2,
----- Plan -------
	iplan		varchar2
) is
---------------------------------------------------------  
  lday date;
begin
  me := 'cw_assess.insert_action';
  cw_bridge.sync(me, cookie);
--  this := cw_bridge.get_assess;
  lstu := cw_bridge.get_student;
  lnur := cw_bridge.get_nurse;
  lday := to_date(idaym||idayd||idayy, 'MONDDYYYY');
  this.student_id := lstu.id;
  this.nurse_id := lnur.id;

     	        this.day 		:= lday;
		------------- Vital Signs ---------
		this.heart		:= iheart;		
		this.respiratory	:= irespiratory; 	
		this.temperature	:= itemperature;	
		------------- History ---------
		this.onset		:= ionset;
		this.duration		:= iduration;
		this.fever		:= ifever; 		
		this.rash		:= irash;		
		this.cough		:= icough;		
		this.rhinorrhea		:= irhinorrhea;	
		this.hoarseness		:= ihoarseness;	
		this.swallowing		:= iswallowing;	
		this.breathing		:= ibreathing;	
		this.abdominalpnv	:= iabdominalpnv;	
		this.hother		:= ihother;		
		this.exposure		:= iexposure;	
		this.treated		:= itreated;		
		this.helped		:= ihelped;		
		------------- General Impression ---------
		this.attention		:= iattention;	
		this.activity		:= iactivity;	
		this.distress		:= idistress;	
		this.toxic		:= itoxic;		
		------------- Physical Examination ---------
		-- eyes
		this.drainage		:= idrainage;	
		this.dramount		:= idramount;	
		this.drcolor		:= idrcolor;		
		this.drconsistency	:= idrconsistency;	
		-- ears
		this.excanal		:= iexcanal;		
		this.tmcolor		:= itmcolor;		
		this.tmtranslucency	:= itmtranslucency;	
		this.tmreflection	:= itmreflection;
		this.tmfluid		:= itmfluid;		
		this.tmretracted	:= itmretracted;	
		this.tmmobility		:= itmmobility;	
		this.tmtympanometer	:= itmtympanometer;	
		-- nose
		this.rhamount		:= irhamount;	
		this.rhcolor		:= irhcolor;		
		this.rhconsistency	:= irhconsistency;	
		-- mouth
		this.mouth		:= imouth;		
		-- throat
		this.thcolor		:= ithcolor;		
		this.ronsilsize		:= ironsilsize;	
		this.tonsilsymm		:= itonsilsymm;	
		this.uvula		:= iuvula;		
		this.exudate		:= iexudate;		
		this.exuamount		:= iexuamount;	
		this.exucolor		:= iexucolor;	
		this.posdischarge	:= iposdischarge;	
		this.ulcervesicle	:= iulcervesicle;	
		-- neck
		this.supple		:= isupple;		
		this.anternode		:= ianternode;	
		this.posternode		:= iposternode;	
		this.occipnode		:= ioccipnode;	
		-- chest
		this.absound		:= iabsound;		
		this.cracle		:= icracle;		
		this.wheeze		:= iwheeze;		
		this.rhonchi		:= irhonchi;		
		this.tuasound		:= ituasound;	
		this.airentry		:= iairentry;	
		this.srlocation		:= isrlocation;	
		this.srnumber		:= isrnumber;	
		this.srpattern		:= isrpattern;	
		this.srsize		:= isrsize;		
		this.srquality		:= isrquality;	
		-- abdomen
		this.soft		:= isoft;		
		this.distention		:= idistention;	
		this.organomegaly	:= iorganomegaly;	
		this.ingunode		:= iingunode;	
		----- Plan -------
		this.plan		:= iplan;		
--*/
  this.id := new(this);
  cw_bridge.set_assess(this);
  cw_assess_util.action_echo(cookie, this, 'inserted');
  exception
    when others then
      cw_error.panic(me|| ':', sqlerrm);
end;  

---------------------------------------------------------  
procedure update_action(
	cookie 		varchar2,
 	idaym		varchar2,
 	idayd		varchar2,
 	idayy		varchar2,
------------- Vital Signs ---------
	iheart		varchar2,
	irespiratory 	varchar2,
	itemperature	varchar2,
------------- History ---------
	ionset		varchar2,
	iduration	varchar2,
	ifever 		varchar2,
	irash		varchar2,
	icough		varchar2,
	irhinorrhea	varchar2,
	ihoarseness	varchar2,
	iswallowing	varchar2,
	ibreathing	varchar2,
	iabdominalpnv	varchar2,
	ihother		varchar2,
	iexposure	varchar2,
	itreated	varchar2,
	ihelped		varchar2,
------------- General Impression ---------
	iattention	varchar2,
	iactivity	varchar2,
	idistress	varchar2,
	itoxic		varchar2,
------------- Physical Examination ---------
-- eyes
	idrainage	varchar2,
	idramount	varchar2,
	idrcolor	varchar2,
	idrconsistency	varchar2,
-- ears
	iexcanal	varchar2,
	itmcolor	varchar2,
	itmtranslucency	varchar2,
	itmreflection	varchar2,
	itmfluid	varchar2,
	itmretracted	varchar2,
	itmmobility	varchar2,
	itmtympanometer	varchar2,
-- nose
	irhamount	varchar2,
	irhcolor	varchar2,
	irhconsistency	varchar2,
-- mouth
	imouth		varchar2,
-- throat
	ithcolor	varchar2,
	ironsilsize	varchar2,
	itonsilsymm	varchar2,
	iuvula		varchar2,
	iexudate	varchar2,
	iexuamount	varchar2,
	iexucolor	varchar2,
	iposdischarge	varchar2,
	iulcervesicle	varchar2,
-- neck
	isupple		varchar2,
	ianternode	varchar2,
	iposternode	varchar2,
	ioccipnode	varchar2,
	-- chest
	iabsound	varchar2,	
	icracle		varchar2,
	iwheeze		varchar2,
	irhonchi	varchar2,
	ituasound	varchar2,
	iairentry	varchar2,
	isrlocation	varchar2,
	isrnumber	varchar2,
	isrpattern	varchar2,
	isrsize		varchar2,
	isrquality	varchar2,
-- abdomen
	isoft		varchar2,
	idistention	varchar2,
	iorganomegaly	varchar2,
	iingunode	varchar2,
----- Plan -------
	iplan		varchar2
) is
---------------------------------------------------------  
  lday date;

begin  
  me := 'cw_assess.update_action';
  cw_bridge.sync(me, cookie);
  this := cw_bridge.get_assess;
--  lstu := cw_bridge.get_student;
--  lnur := cw_bridge.get_nurse;
--  if (this.id := null) then
--    insert_action(cookie, iname, igiven_num, idaym, idayd, idayy); 
--  else 
    lday := to_date(idaym||idayd||idayy, 'MONDDYYYY');
--    this.student_id := lstu.id;
--    this.nurse_id := lnur.id;
     	        this.day 		:= lday;
		------------- Vital Signs ---------
		this.heart		:= iheart;		
		this.respiratory	:= irespiratory; 	
		this.temperature	:= itemperature;	
		------------- History ---------
		this.onset		:= ionset;
		this.duration		:= iduration;
		this.fever		:= ifever; 		
		this.rash		:= irash;		
		this.cough		:= icough;		
		this.rhinorrhea		:= irhinorrhea;	
		this.hoarseness		:= ihoarseness;	
		this.swallowing		:= iswallowing;	
		this.breathing		:= ibreathing;	
		this.abdominalpnv	:= iabdominalpnv;	
		this.hother		:= ihother;		
		this.exposure		:= iexposure;	
		this.treated		:= itreated;		
		this.helped		:= ihelped;		
		------------- General Impression ---------
		this.attention		:= iattention;	
		this.activity		:= iactivity;	
		this.distress		:= idistress;	
		this.toxic		:= itoxic;		
		------------- Physical Examination ---------
		-- eyes
		this.drainage		:= idrainage;	
		this.dramount		:= idramount;	
		this.drcolor		:= idrcolor;		
		this.drconsistency	:= idrconsistency;	
		-- ears
		this.excanal		:= iexcanal;		
		this.tmcolor		:= itmcolor;		
		this.tmtranslucency	:= itmtranslucency;	
		this.tmreflection	:= itmreflection;
		this.tmfluid		:= itmfluid;		
		this.tmretracted	:= itmretracted;	
		this.tmmobility		:= itmmobility;	
		this.tmtympanometer	:= itmtympanometer;	
		-- nose
		this.rhamount		:= irhamount;	
		this.rhcolor		:= irhcolor;		
		this.rhconsistency	:= irhconsistency;	
		-- mouth
		this.mouth		:= imouth;		
		-- throat
		this.thcolor		:= ithcolor;		
		this.ronsilsize		:= ironsilsize;	
		this.tonsilsymm		:= itonsilsymm;	
		this.uvula		:= iuvula;		
		this.exudate		:= iexudate;		
		this.exuamount		:= iexuamount;	
		this.exucolor		:= iexucolor;	
		this.posdischarge	:= iposdischarge;	
		this.ulcervesicle	:= iulcervesicle;	
		-- neck
		this.supple		:= isupple;		
		this.anternode		:= ianternode;	
		this.posternode		:= iposternode;	
		this.occipnode		:= ioccipnode;	
		-- chest
		this.absound		:= iabsound;		
		this.cracle		:= icracle;		
		this.wheeze		:= iwheeze;		
		this.rhonchi		:= irhonchi;		
		this.tuasound		:= ituasound;	
		this.airentry		:= iairentry;	
		this.srlocation		:= isrlocation;	
		this.srnumber		:= isrnumber;	
		this.srpattern		:= isrpattern;	
		this.srsize		:= isrsize;		
		this.srquality		:= isrquality;	
		-- abdomen
		this.soft		:= isoft;		
		this.distention		:= idistention;	
		this.organomegaly	:= iorganomegaly;	
		this.ingunode		:= iingunode;	
		----- Plan -------
		this.plan		:= iplan;		
    put(this);
    cw_assess_util.action_echo(cookie, this, 'updated');
--  end if;
  exception
    when others then
      cw_error.panic(me|| ':', sqlerrm); 
end;  

---------------------------------------------------------  
procedure delete_action(cookie in varchar2, iid in varchar2) is
---------------------------------------------------------  
  lid varchar2(8);
begin  
  lid := iid;
  me := 'cw_assess.delete_action';
  cw_bridge.sync(me, cookie);
--  this := cw_bridge.get_assess;
--  if (this.id := null) then
--    raise id_null;
--  end if;
--  if (iid := null) then
--    raise id_null;
--  end if;
  cw_assess_util.action_echo(cookie, this, 'deleted');
  cw_bridge.unset_assess;  
--  htp.p('delete_action:iid:='||iid);
  rm(to_number(lid));
exception
--    when id_null then
--      cw_error.msg(me|| ': iid is null'); 
    when others then
      cw_error.panic(me|| ':', sqlerrm); 
end;  

---------------------------------------------------------  
-- begin
--	this.id := 0;
-- end;
---------------------------------------------------------  

---------------------------------------------------------  
end;  
---------------------------------------------------------  

/
show errors;
-- /

