-------------------------------------------------------
-- The cw_assess_table contains assessization information.
-------------------------------------------------------

drop sequence cw_assess_seq;
drop table cw_assess_table;

create table cw_assess_table (		
id		number(8) constraint assess_pkey primary key,
student_id	number(8),
-- constraint assess_fkey 
-- references cw_student_table(id),
nurse_id	number(8),
day		date,
------------- Vital Signs ---------
heart		varchar2(32),
respiratory 	varchar2(32),
temperature	varchar2(32),
------------- History ---------
onset		varchar2(16),
duration	varchar2(16),
fever 		varchar2(4),
rash		varchar2(4),
cough		varchar2(4),
rhinorrhea	varchar2(4),
hoarseness	varchar2(4),
swallowing	varchar2(4),
breathing	varchar2(4),
abdominalpnv	varchar2(4),
hother		varchar2(1024),
exposure	varchar2(4),
treated		varchar2(32),
helped		varchar2(4),
------------- General Impression ---------
attention	varchar2(32),
activity	varchar2(32),
distress	varchar2(32),
toxic		varchar2(4),
------------- Physical Examination ---------
-- eyes
drainage	varchar2(4),
dramount	varchar2(16),
drcolor		varchar2(16),
drconsistency	varchar2(16),
-- ears
excanal		varchar2(16),
tmcolor		varchar2(16),
tmtranslucency	varchar2(16),
tmreflection	varchar2(16),
tmfluid		varchar2(4),
tmretracted	varchar2(4),
tmmobility	varchar2(16),
tmtympanometer	varchar2(16),
-- nose
rhamount	varchar2(16),
rhcolor		varchar2(16),
rhconsistency	varchar2(16),
-- mouth
mouth		varchar2(64),
-- throat
thcolor		varchar2(16),
ronsilsize	varchar2(4),
tonsilsymm	varchar2(4),
uvula		varchar2(16),
exudate		varchar2(4),
exuamount	varchar2(16),
exucolor	varchar2(16),
posdischarge	varchar2(4),
ulcervesicle	varchar2(16),
-- neck
supple		varchar2(4),
anternode	varchar2(4),
posternode	varchar2(4),
occipnode	varchar2(4),
-- chest
absound		varchar2(4),
cracle		varchar2(4),
wheeze		varchar2(4),
rhonchi		varchar2(4),
tuasound	varchar2(4),
airentry	varchar2(16),
srlocation	varchar2(16),
srnumber	varchar2(32),
srpattern	varchar2(16),
srsize		varchar2(16),
srquality	varchar2(32),
-- abdomen
soft		varchar2(4),
distention	varchar2(4),
organomegaly	varchar2(4),
ingunode	varchar2(4),
----- Plan -------
plan		varchar2(128)
);

create sequence cw_assess_seq;

/
show errors

