------------------------------------------------------------
create or replace package cw_asthma_util is
procedure create_form;
procedure show_form(r in cw_asthma_table%rowtype);
procedure modify_form(r in cw_asthma_table%rowtype);

end;
/
show errors

------------------------------------------------------------

create or replace package body cw_asthma_util is

procedure create_form is
begin
   htp.tableOpen('BORDER',cattributes=>'CELLSPACING=1 CELLPADDING=1 WIDTH=90%');
       htp.tableRowOpen('CENTER','MIDDLE');
           htp.tableHeader('History',cattributes=>'WIDTH="10%"');
           htp.p('<TD WIDTH="40%">');
             htp.formSelectOpen('h_onset');
             htp.formSelectOption('Onset',null,'value=');
             htp.formSelectOption('Within the last hour',null,
                                    'value="within the last hour"');
             htp.formSelectOption('Within the previous 12 hours',null,
                                     'value="within the previous 12 hours"');
             htp.formSelectOption('Within the previous 24 hours',null,
                                      'value="within the previous 24 hours"');
             htp.formSelectOption('More than 24 hours ago',null,
                                       'value="more than 24 hours ago"');
             htp.formSelectClose;
           htp.p('</TD>');
           htp.tableHeader('Short of Breath',cattributes=>'WIDTH="15%"');
           htp.tableData(cw_tom_util.select_check('h_breath'),cattributes=>'WIDTH="10%"');                         
           htp.tableHeader('Chest tight',cattributes=>'WIDTH="15%"'); 
           htp.tableData(cw_tom_util.select_check('h_chest'),cattributes=>'WIDTH="10%"');           
   htp.tableClose;
   htp.para;
   htp.tableOpen('BORDER',cattributes=>'CELLSPACING=1 CELLPADDING=1 WIDTH=90%');
       htp.tableCaption('<H3>The following criteria are used to evaluate the severity of the asthma exacerbation </H3>','CENTER');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Objective',cattributes=>'WIDTH="20%"');
         htp.tableHeader('Mild',cattributes=>'WIDTH="26%"');         
         htp.tableHeader('Moderate',cattributes=>'WIDTH="27%"');
         htp.tableHeader('Severe',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('PEFR (predicted best)',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('pefr','70-90%','CHECKED')||' '||'70-90%',cattributes=>'WIDTH="26%"'); 
         htp.tableData(htf.formRadio('pefr','50-70%')||' '||'50-70%',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('pefr','<50%')||' '||'<50%',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('RR'||'<BR>'||htf.formRadio('ayear','4-6yo','CHECKED')||' '||'4-6yo'||'<BR>'||
                               htf.formRadio('ayear','6-8yo')||' '||'6-8yo'||'<BR>'||
                               htf.formRadio('ayear','>8yo')||' '||'>8yo',calign=>'LEFT',
                                                         cattributes=>'WIDTH="20%" VALIGN="TOP"');
         htp.tableData(htf.formRadio('rr','19-34','CHECKED')||' '||'19-34'||'<BR>'||
                       htf.formRadio('rr','15-30')||' '||'15-30'||'<BR>'|| 
                       htf.formRadio('rr','14-26')||' '||'14-26',cattributes=>'WIDTH="26%"'); 
         htp.tableData(htf.formRadio('rr','34-40')||' '||'34-40'||'<BR>'||
                       htf.formRadio('rr','31-34')||' '||'31-34'||'<BR>'|| 
                       htf.formRadio('rr','27-30')||' '||'27-30',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('rr','>40')||' '||'>40'||'<BR>'||
                       htf.formRadio('rr','>34')||' '||'>34'||'<BR>'|| 
                       htf.formRadio('rr','>30')||' '||'>30',cattributes=>'WIDTH="27%"');   
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Alertness',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('alert','Normal','CHECKED')||' '||'Normal',calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('alert','normal')||' '||'Normal',calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('alert','Decreased')||' '||'Decreased',calign=>'LEFT',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Dyspnea',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('dyspnea','Speaks in complete sentences','CHECKED')||' '||'Speaks in complete sentences',
                                                                    calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('dyspnea','Speaks in phrases ')||' '||'Speaks in phrases',
                                                                    calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('dyspnea','Speaks only in single words')||' '||'Speaks only in single words',
                                                                    calign=>'LEFT',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Accessory Muscle Use',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('muscle ','No intercostal or mild intercostal','CHECKED')||' '||'No intercostal or mild intercostal',
                                                    calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('muscle ',' Moderate intercostal with tracheosternal retractions and use of
                                                   sternomastoid muscles ')||' '||'Moderate intercostal with tracheosternal retractions and use of
                                                              sternomastoid muscles',calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('muscle ','Severe intercostal with tracheosternal retractions and nasal flaring during inspiration')
                                                ||' '||'Severe intercostal with tracheosternal retractions and nasal flaring during inspiration',
                                                calign=>'LEFT',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Color',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('color','Good','CHECKED')||' '||' Good',calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('color','Pale')||' '||'Pale ',calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('color','Cyanotic')||' '||'Cyanotic ',calign=>'LEFT',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Auscultation',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('auscultation','End expiratory wheezing only','CHECKED')||' '||'End expiratory wheezing only',
                                                 calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('auscultation','Wheezing during inspiration and expiration')||' '||'Wheezing during inspiration and expiration',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('auscultation','Breath sounds becoming inaudible')||' '||' Breath sounds becoming inaudible',
                                                  calign=>'LEFT',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');        
         htp.tableHeader('SO2',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('so2','>95%','CHECKED')||' '||' >95%',calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('so2','90-95%')||' '||' 90-95% ',calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('so2','<90%')||' '||'< 90% ',calign=>'LEFT',cattributes=>'WIDTH="27%"');
         
htp.tableClose;
       
end;

procedure show_form(r in cw_asthma_table%rowtype) is
begin
  htp.header(2,'Assesment Process','CENTER');
  htp.header(2,'Evaluating the Severity of an Acute Asthma Exacerbation','CENTER',null,'NOWRAP');
  htp.para;
  htp.tableOpen('BORDER',cattributes=>'CELLSPACING=1 CELLPADDING=1 WIDTH=90%');
     htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('History',cattributes=>'WIDTH="10%"');
         htp.tableHeader('Onset',cattributes=>'WIDTH="10%"');
         htp.tableData(r.h_onset,cattributes=>'WIDTH="20%"');
         htp.tableHeader('Short of Breath',cattributes=>'WIDTH="15%"');
         htp.tableData(r.h_breath,cattributes=>'WIDTH="15%"');
         htp.tableHeader('Chest tight',cattributes=>'WIDTH="15%"'); 
         htp.tableData(r.h_chest,cattributes=>'WIDTH="15%"'); 
  htp.tableClose;
  htp.para;
  htp.tableOpen('BORDER',cattributes=>'CELLSPACING=1 CELLPADDING=1 WIDTH=90%');
  htp.tableCaption('<H3>The following criteria are used to evaluate the severity of the asthma exacerbation </H3>','CENTER');
     htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Objective',cattributes=>'WIDTH="20%"');
         htp.tableHeader('Mild',cattributes=>'WIDTH="26%"');         
         htp.tableHeader('Moderate',cattributes=>'WIDTH="27%"');
         htp.tableHeader('Severe',cattributes=>'WIDTH="27%"');
     htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('PEFR (predicted best)',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(cw_tom_util.show_tick(r.pefr,'70-90%'),cattributes=>'WIDTH="26%"'); 
         htp.tableData(cw_tom_util.show_tick(r.pefr,'50-70%'),cattributes=>'WIDTH="27%"');
         htp.tableData(cw_tom_util.show_tick(r.pefr,'<50%'),cattributes=>'WIDTH="27%"'); 
   htp.tableClose;
   htp.tableOpen('BORDER',cattributes=>'CELLSPACING=1 CELLPADDING=1 WIDTH=90%');           
     htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('RR',crowspan=>3,calign=>'LEFT',cattributes=>'WIDTH="10%"');
         htp.tableData(cw_tom_util.show_tick(r.ayear,'4-6yo'),cattributes=>'WIDTH="10%"');
         htp.tableData(cw_tom_util.show_tick(r.rr,'19-34'),cattributes=>'WIDTH="26%"'); 
         htp.tableData(cw_tom_util.show_tick(r.rr,'34-40'),cattributes=>'WIDTH="27%"'); 
         htp.tableData(cw_tom_util.show_tick(r.rr,'>40'),cattributes=>'WIDTH="27%"'); 
     htp.tableRowOpen('CENTER','MIDDLE');   
         htp.tableData(cw_tom_util.show_tick(r.ayear,'6-8yo'),cattributes=>'WIDTH="10%"');
         htp.tableData(cw_tom_util.show_tick(r.rr,'15-30'),cattributes=>'WIDTH="26%"');
         htp.tableData(cw_tom_util.show_tick(r.rr,'31-34'),cattributes=>'WIDTH="27%"');
         htp.tableData(cw_tom_util.show_tick(r.rr,'>34'),cattributes=>'WIDTH="27%"'); 
     htp.tableRowOpen('CENTER','MIDDLE'); 
         htp.tableData(cw_tom_util.show_tick(r.ayear,'>8yo'),cattributes=>'WIDTH="10%"');
         htp.tableData(cw_tom_util.show_tick(r.rr,'14-26'),cattributes=>'WIDTH="26%"');
         htp.tableData(cw_tom_util.show_tick(r.rr,'27-30'),cattributes=>'WIDTH="27%"'); 
         htp.tableData(cw_tom_util.show_tick(r.rr,'>30'),cattributes=>'WIDTH="27%"');
   htp.tableClose;
   htp.tableOpen('BORDER',cattributes=>'CELLSPACING=1 CELLPADDING=1 WIDTH=90%'); 
     htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Alertness',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(cw_tom_util.show_tick(r.alert,'Normal'),cattributes=>'WIDTH="26%"');
         htp.tableData(cw_tom_util.show_tick(r.alert,'normal'),cattributes=>'WIDTH="27%"');  
         htp.tableData(cw_tom_util.show_tick(r.alert,'Decreased'),cattributes=>'WIDTH="27%"'); 
     htp.tableRowOpen('CENTER','MIDDLE');               
         htp.tableHeader('Dyspnea',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(cw_tom_util.show_tick(r.dyspnea,'Speaks in complete sentences'),cattributes=>'WIDTH="26%"');
         htp.tableData(cw_tom_util.show_tick(r.dyspnea,'Speaks in phrases'),cattributes=>'WIDTH="27%"');  
         htp.tableData(cw_tom_util.show_tick(r.dyspnea,'Speaks only in single words'),cattributes=>'WIDTH="27%"'); 
     htp.tableRowOpen('CENTER','MIDDLE');               
         htp.tableHeader('Accessory Muscle Use',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(cw_tom_util.show_tick(r.muscle,'No intercostal or mild intercostal'),cattributes=>'WIDTH="26%"');
         htp.tableData(cw_tom_util.show_tick(r.muscle,'Moderate intercostal with tracheosternal retractions and use of
                                                         sternomastoid muscles '),cattributes=>'WIDTH="27%"');  
         htp.tableData(cw_tom_util.show_tick(r.muscle,'Severe intercostal with tracheosternal retractions and nasal flaring during inspiration')
                                          ,cattributes=>'WIDTH="27%"'); 
     htp.tableRowOpen('CENTER','MIDDLE'); 
         htp.tableHeader('Color',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(cw_tom_util.show_tick(r.color,'Good'),cattributes=>'WIDTH="26%"');
         htp.tableData(cw_tom_util.show_tick(r.color,'Pale'),cattributes=>'WIDTH="27%"');  
         htp.tableData(cw_tom_util.show_tick(r.color,'Cyanotic'),cattributes=>'WIDTH="27%"');
     htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Auscultation',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(cw_tom_util.show_tick(r.auscultation,'End expiratory wheezing only'),cattributes=>'WIDTH="26%"');
         htp.tableData(cw_tom_util.show_tick(r.auscultation,'Wheezing during inspiration and expiration'),cattributes=>'WIDTH="27%"');  
         htp.tableData(cw_tom_util.show_tick(r.auscultation,'Breath sounds becoming inaudible'),cattributes=>'WIDTH="27%"');
     htp.tableRowOpen('CENTER','MIDDLE');  
         htp.tableHeader('SO2',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(cw_tom_util.show_tick(r.so2,'>95%') ,calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(cw_tom_util.show_tick(r.so2,'90-95%'),calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(cw_tom_util.show_tick(r.so2,'<90%'),calign=>'LEFT',cattributes=>'WIDTH="26%"');  
htp.tableClose;  
end;

procedure modify_form(r in cw_asthma_table%rowtype) is
begin

   htp.tableOpen('BORDER',cattributes=>'CELLSPACING=1 CELLPADDING=1 WIDTH=90%');
       htp.tableRowOpen('CENTER','MIDDLE');
           htp.tableHeader('History',cattributes=>'WIDTH="10%"');
           htp.p('<TD WIDTH="40%">');
           htp.formSelectOpen('h_onset');
           htp.formSelectOption(cw_tom_util.select_onset(r.h_onset,'Within the last hour'),
                                'value="within the last hour"');
           htp.formSelectOption(cw_tom_util.select_onset(r.h_onset,'Within the previous 12 hours'),
                                'value="within the previous 12 hours"');
           htp.formSelectOption(cw_tom_util.select_onset(r.h_onset,'Within the previous 24 hours'),
                                'value="within the previous 24 hours"');
           htp.formSelectOption(cw_tom_util.select_onset(r.h_onset,'More than 24 hours ago'),
                                   'value="more than 24 hours ago"');
           htp.formSelectClose;
           htp.p('</TD>');
           htp.tableHeader('Short of Breath',cattributes=>'WIDTH="15%"');
           htp.tableData(cw_tom_util.select_check('h_breath',r.h_breath),cattributes=>'WIDTH="10%"');                         
           htp.tableHeader('Chest tight',cattributes=>'WIDTH="15%"'); 
           htp.tableData(cw_tom_util.select_check('h_chest',r.h_chest),cattributes=>'WIDTH="10%"');           
   htp.tableClose;
   htp.tableOpen('BORDER',cattributes=>'CELLSPACING=1 CELLPADDING=1 WIDTH=90%');
       htp.tableCaption('The following criteria are used to evaluate the severity of the asthma exacerbation','CENTER');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Objective',cattributes=>'WIDTH="20%"');
         htp.tableHeader('Mild',cattributes=>'WIDTH="26%"');         
         htp.tableHeader('Moderate',cattributes=>'WIDTH="27%"');
         htp.tableHeader('Severe',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('PEFR (predicted best)',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('pefr',r.pefr,cw_tom_util.radio_check(r.pefr,'70-90%'))||'70-90%',cattributes=>'WIDTH="26%"'); 
         htp.tableData(htf.formRadio('pefr',r.pefr,cw_tom_util.radio_check(r.pefr,'50-70%'))||'50-70%',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('pefr',r.pefr,cw_tom_util.radio_check(r.pefr,'<50%'))||'<50%',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('RR'||'<BR>'||htf.formRadio('ayear',r.ayear,cw_tom_util.radio_check(r.ayear,'4-6yo'))
                                                              ||' '||'4-6yo' ||'<BR>'||
                               htf.formRadio('ayear',r.ayear,cw_tom_util.radio_check(r.ayear,'6-8yo'))
                                                              ||' '||'6-8yo'||'<BR>'||
                               htf.formRadio('ayear',r.ayear,cw_tom_util.radio_check(r.ayear,'>8yo'))||' '||'>8yo',calign=>'LEFT',
                                                         cattributes=>'WIDTH="20%" VALIGN="TOP"');
         htp.tableData(htf.formRadio('rr',r.rr,cw_tom_util.radio_check(r.rr,'19-34'))||' '||'19-34'||'<BR>'||
                       htf.formRadio('rr',r.rr,cw_tom_util.radio_check(r.rr,'15-30'))||' '||'15-30'||'<BR>'|| 
                       htf.formRadio('rr',r.rr,cw_tom_util.radio_check(r.rr,'14-26'))||' '||'14-26',cattributes=>'WIDTH="26%"'); 
         htp.tableData(htf.formRadio('rr',r.rr,cw_tom_util.radio_check(r.rr,'34-40'))||' '||'34-40'||'<BR>'||
                       htf.formRadio('rr',r.rr,cw_tom_util.radio_check(r.rr,'31-34'))||' '||'31-34'||'<BR>'|| 
                       htf.formRadio('rr',r.rr,cw_tom_util.radio_check(r.rr,'27-30'))||' '||'27-30',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('rr',r.rr,cw_tom_util.radio_check(r.rr,'>40'))||' '||'>40'||'<BR>'||
                       htf.formRadio('rr',r.rr,cw_tom_util.radio_check(r.rr,'>34'))||' '||'>34'||'<BR>'|| 
                       htf.formRadio('rr',r.rr,cw_tom_util.radio_check(r.rr,'>30'))||' '||'>30',cattributes=>'WIDTH="27%"');   
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Alertness',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('alert',r.alert,cw_tom_util.radio_check(r.alert,'Normal'))||' '||'Normal',calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('alert',r.alert,cw_tom_util.radio_check(r.alert,'normal'))||' '||'Normal',calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('alert',r.alert,cw_tom_util.radio_check(r.alert,'Decreased'))||' '||'Decreased',calign=>'LEFT',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Dyspnea',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('dyspnea',r.dyspnea,cw_tom_util.radio_check(r.dyspnea,'Speaks in complete sentences'))||' '||'Speaks in complete sentences',
                                                                    calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('dyspnea',r.dyspnea,cw_tom_util.radio_check(r.dyspnea,'Speaks in phrases'))||' '||'Speaks in phrases',
                                                                    calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('dyspnea',r.dyspnea,cw_tom_util.radio_check(r.dyspnea,'Speaks only in single words'))||' '||'Speaks only in single words',
                                                                    calign=>'LEFT',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Accessory Muscle Use',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('muscle',r.muscle,cw_tom_util.radio_check(r.muscle,
                      'No intercostal or mild intercostal'))
                       ||' '||'No intercostal or mild intercostal',
                                                    calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('muscle',r.muscle,cw_tom_util.radio_check(r.muscle,
                    'Moderate intercostal with tracheosternal retractions and use of                                   sternomastoid muscles '))
                ||' '||'Moderate intercostal with tracheosternal retractions and use of
                                sternomastoid muscles',calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('muscle',r.muscle,cw_tom_util.radio_check(r.muscle,
                           'Severe intercostal with tracheosternal retractions and nasal flaring during inspiration'))
                    ||' '||'Severe intercostal with tracheosternal retractions and nasal flaring during inspiration',
                                                calign=>'LEFT',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Color',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('color',r.color,cw_tom_util.radio_check(r.color,'Good'))||' '||' Good',calign=>'CENTER',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('color',r.color,cw_tom_util.radio_check(r.color,'Pale'))||' '||'Pale ',calign=>'CENTER',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('color',r.color,cw_tom_util.radio_check(r.color,'Cyanotic'))||' '||'Cyanotic ',calign=>'CENTER',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');
         htp.tableHeader('Auscultation',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('auscultation',r.auscultation,
             cw_tom_util.radio_check(r.auscultation,'End expiratory wheezing only'))
                                                  ||' '||'End expiratory wheezing only',
                                                 calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('auscultation',r.auscultation,
              cw_tom_util.radio_check(r.auscultation,'Wheezing during inspiration and expiration'))
                  ||' '||'Wheezing during inspiration and expiration',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('auscultation',r.auscultation,
                  cw_tom_util.radio_check(r.auscultation,'Breath sounds becoming inaudible'))
                           ||' '||'Breath sounds becoming inaudible',
                                                  calign=>'LEFT',cattributes=>'WIDTH="27%"');
       htp.tableRowOpen('CENTER','MIDDLE');        
         htp.tableHeader('so2',calign=>'LEFT',cattributes=>'WIDTH="20%"');
         htp.tableData(htf.formRadio('so2',r.so2,cw_tom_util.radio_check(r.so2,'>95%'))
                      ||' '||' >95%',calign=>'LEFT',cattributes=>'WIDTH="26%"');
         htp.tableData(htf.formRadio('so2',r.so2,cw_tom_util.radio_check(r.so2,'90-95%'))
                    ||' '||' 90-95% ',calign=>'LEFT',cattributes=>'WIDTH="27%"');
         htp.tableData(htf.formRadio('so2',r.so2,cw_tom_util.radio_check(r.so2,'<90%'))
                    ||' '||'< 90% ',calign=>'LEFT',cattributes=>'WIDTH="27%"');
         
htp.tableClose; 
                 
--htp.header(1,'Not implemented yet','CENTER');
end;

end;
/
show errors


