--------------------------------------------------------------------------
create or replace package cw_bridge is
--------------------------------------------------------------------------
function get_person return cw_person_table%rowtype;
function get_nurse return cw_nurse_table%rowtype;
function get_npract return cw_npract_table%rowtype;
function get_doctor return cw_doctor_table%rowtype;
function get_student return cw_student_table%rowtype;
function get_school return cw_school_table%rowtype;
function get_careinfo return cw_careinfo_table%rowtype;
function get_immun return cw_immun_table%rowtype;
function get_develscr return cw_develscr_table%rowtype;
function get_visit return cw_visit_table%rowtype;
function get_assess return cw_assess_table%rowtype;
function get_asthma return cw_asthma_table%rowtype;
function get_medicat return cw_medicat_table%rowtype;
/*
function get_npract return cw_npract_table%rowtype;
function get_doctor return cw_doctor_table%rowtype;

function get_careinfo return cw_careinfo_table%rowtype;
function get_immun return cw_immun_table%rowtype;
function get_basescr return cw_basescr_table%rowtype;
function get_physscr return cw_physscr_table%rowtype;
function get_develscr return cw_develscr_table%rowtype;
function get_hhistory return cw_hhistory_table%rowtype;
function get_visit return cw_visit_table%rowtype;
function get_assess return cw_assess_table%rowtype;
function get_prognote return cw_prognote_table%rowtype;
function get_growth return cw_growth_table%rowtype;
function get_hplan return cw_hplan_table%rowtype;
function get_medicat return cw_medicat_table%rowtype;
*/

procedure set_person(iperson in cw_person_table%rowtype);
procedure set_student(istudent in cw_student_table%rowtype);
procedure set_nurse(inurse in cw_nurse_table%rowtype);
procedure set_npract(inpract in cw_npract_table%rowtype);
procedure set_doctor(idoctor in cw_doctor_table%rowtype);
procedure set_school(ischool in cw_school_table%rowtype);
procedure set_careinfo(icareinfo in cw_careinfo_table%rowtype);
procedure set_immun(iimmun in cw_immun_table%rowtype);
procedure set_develscr(idevelscr in cw_develscr_table%rowtype);
procedure set_visit(ivisit in cw_visit_table%rowtype);
procedure set_assess(iassess in cw_assess_table%rowtype);
procedure set_asthma(iasthma in cw_asthma_table%rowtype);
procedure set_medicat(imedicat in cw_medicat_table%rowtype);
/*
procedure set_npract(inpract in cw_npract_table%rowtype);
procedure set_doctor(idoctor in cw_doctor_table%rowtype);

procedure set_careinfo(icareinfo in cw_careinfo_table%rowtype);
procedure set_immun(iimmun in cw_immun_table%rowtype);
procedure set_basescr(ibasescr in cw_basescr_table%rowtype);
procedure set_develscr(idevelscr in cw_develscr_table%rowtype);
procedure set_physscr(iphysscr in cw_physscr_table%rowtype);
procedure set_hhistory(ihhistory in cw_hhistory_table%rowtype);
procedure set_visit(ivisit in cw_visit_table%rowtype);
procedure set_assess(iassess in cw_assess_table%rowtype);
procedure set_prognote(iprognote in cw_prognote_table%rowtype);
procedure set_growth(igrowth in cw_growth_table%rowtype);
procedure set_hplan(ihplan in cw_hplan_table%rowtype);
procedure set_medicat(imedicat in cw_medicat_table%rowtype);
*/

procedure unset_person;
procedure unset_student;
procedure unset_nurse;
procedure unset_npract;
procedure unset_doctor;
procedure unset_school;
procedure unset_careinfo;
procedure unset_immun;
procedure unset_develscr;
procedure unset_visit;
procedure unset_assess;
procedure unset_asthma;
procedure unset_medicat;
/*
procedure unset_npract;
procedure unset_doctor;

procedure unset_careinfo;
procedure unset_immun;
procedure unset_basescr;
procedure unset_physscr;
procedure unset_develscr;
procedure unset_hhistory;
procedure unset_visit;
procedure unset_assess;
procedure unset_prognote;
procedure unset_growth;
procedure unset_hplan;
procedure unset_medicat;
*/

procedure conn;
procedure conn(cookie in varchar2);
procedure auth(cookie in varchar2, iuser in varchar2,
   ipasswd in varchar2, iaction in varchar2);
procedure personal(cookie in varchar2);
procedure home(cookie in varchar2);
procedure admin(cookie in varchar2);

procedure save_state;
procedure restore_state(cookie in varchar2);
procedure sync(proc in varchar2,cookie in varchar2);
procedure tx_save(itarget in number, iaction in number);

procedure err_invalid_user;
procedure err_duplicate_user(usr in varchar2);

end;
/
show errors
--------------------------------------------------------------------------
create or replace package body cw_bridge is
--------------------------------------------------------------------------
me varchar2(64);
st cw_state_table%rowtype;
cu cw_customer_table%rowtype;
xx cw_tx_table%rowtype;

per cw_person_table%rowtype;
stu cw_student_table%rowtype;
nur cw_nurse_table%rowtype;
npr cw_npract_table%rowtype;
doc cw_doctor_table%rowtype;
sch cw_school_table%rowtype;
car cw_careinfo_table%rowtype;
imm cw_immun_table%rowtype;
dev cw_develscr_table%rowtype;
vis cw_visit_table%rowtype;
ass cw_assess_table%rowtype;
ast cw_asthma_table%rowtype;
med cw_medicat_table%rowtype;
/*
npr cw_npract_table%rowtype;
doc cw_doctor_table%rowtype;

car cw_careinfo_table%rowtype;
imm cw_immun_table%rowtype;
bas cw_basescr_table%rowtype;
phy cw_physscr_table%rowtype;
dev cw_develscr_table%rowtype;
hhi cw_hhistory_table%rowtype;
vis cw_visit_table%rowtype;
ass cw_assess_table%rowtype;
pro cw_prognote_table%rowtype;
gro cw_growth_table%rowtype;
hpl cw_hplan_table%rowtype;
med cw_medicat_table%rowtype;
*/
--------------------------------------------------------------------------
invalid_user exception;
invalid_input exception;
--------------------------------------------------------------------------
function get_person return cw_person_table%rowtype is
begin
   return per;
end;
--------------------------------------------------------------------------
function get_student return cw_student_table%rowtype is
begin
   return stu;
end;
--------------------------------------------------------------------------
function get_nurse return cw_nurse_table%rowtype is
begin
   return nur;
end;
--------------------------------------------------------------------------
function get_npract return cw_npract_table%rowtype is
begin
  return npr;
end;
--------------------------------------------------------------------------
function get_doctor return cw_doctor_table%rowtype is
begin
  return doc ;
end;
--------------------------------------------------------------------------
function get_school return cw_school_table%rowtype is
begin
   return sch;
end;
--------------------------------------------------------------------------
function get_careinfo return cw_careinfo_table%rowtype is
begin
   return car;
end;
---------------------------------------------------------------------------
function get_immun return cw_immun_table%rowtype is
begin
   return imm;
end;
---------------------------------------------------------------------------
function get_develscr return cw_develscr_table%rowtype is
begin
   return dev;
end;
--------------------------------------------------------------------------
function get_visit return cw_visit_table%rowtype is
begin
   return vis;
end;
--------------------------------------------------------------------------
function get_assess return cw_assess_table%rowtype is
begin
   return ass;
end;
--------------------------------------------------------------------------
function get_asthma return cw_asthma_table%rowtype is
begin
   return ast;
end;
--------------------------------------------------------------------------
function get_medicat return cw_medicat_table%rowtype is
begin
   return med;
end;
--------------------------------------------------------------------------
/*
--------------------------------------------------------------------------
function get_npract return cw_npract_table%rowtype is
begin
  return npr;
end;
--------------------------------------------------------------------------
function get_doctor return cw_doctor_table%rowtype is
begin
  return doc ;
end;
--------------------------------------------------------------------------
function get_careinfo return cw_careinfo_table%rowtype is
begin
   return car;
end;
---------------------------------------------------------------------------
function get_immun return cw_immun_table%rowtype is
begin
   return imm;
end;
---------------------------------------------------------------------------
function get_basescr return cw_basescr_table%rowtype is
begin
   return bas;
end;
--------------------------------------------------------------------------
function get_physscr return cw_physscr_table%rowtype is
begin
   return phy;
end;
--------------------------------------------------------------------------
function get_develscr return cw_develscr_table%rowtype is
begin
   return dev;
end;
--------------------------------------------------------------------------
function get_hhistory return cw_hhistory_table%rowtype is
begin
   return hhi;
end;
--------------------------------------------------------------------------
function get_visit return cw_visit_table%rowtype is
begin
   return vis;
end;
--------------------------------------------------------------------------
function get_assess return cw_assess_table%rowtype is
begin
   return ass;
end;
--------------------------------------------------------------------------
function get_prognote return cw_prognote_table%rowtype is
begin
   return pro;
end;
--------------------------------------------------------------------------
function get_growth return cw_growth_table%rowtype is
begin
   return gro;
end;
--------------------------------------------------------------------------
function get_hplan return cw_hplan_table%rowtype is
begin
   return hpl;
end;
--------------------------------------------------------------------------
function get_medicat return cw_medicat_table%rowtype is
begin
   return med;
end;
--------------------------------------------------------------------------
*/
procedure set_person(iperson in cw_person_table%rowtype) is
begin
   if iperson.id is not null then
	per := iperson;
	st.person_id := iperson.id;
   	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_student(istudent in cw_student_table%rowtype) is
begin
   if istudent.id is not null then
	stu := istudent;
	st.student_id := istudent.id;
	save_state;   
   end if;
end;
--------------------------------------------------------------------------
procedure set_nurse(inurse in cw_nurse_table%rowtype) is
begin
   if inurse.id is not null then
	nur := inurse;
	st.nurse_id := inurse.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_npract(inpract in cw_npract_table%rowtype) is
begin
   if inpract.id is not null then
	npr := inpract;
	st.npract_id := inpract.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_doctor(idoctor in cw_doctor_table%rowtype) is
begin
   if idoctor.id is not null then
	doc := idoctor;
	st.doctor_id := idoctor.id;
  	save_state;
   end if;
end;
-------------------------------------------------------------------------
procedure set_school(ischool in cw_school_table%rowtype) is
begin
   if ischool.id is not null then
	sch := ischool;
	st.school_id := ischool.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_careinfo(icareinfo in cw_careinfo_table%rowtype) is
begin
   if icareinfo.id is not null then
	car := icareinfo;
	st.careinfo_id := icareinfo.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_immun(iimmun in cw_immun_table%rowtype) is
begin
   if iimmun.id is not null then
	imm := iimmun;
	st.immun_id := iimmun.id;
  	save_state;
   end if;
end;
------------------------------------------------------------------------
procedure set_develscr(idevelscr in cw_develscr_table%rowtype) is
begin
   if idevelscr.id is not null then
	dev := idevelscr;
	st.develscr_id := idevelscr.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_visit(ivisit in cw_visit_table%rowtype) is
begin
   if ivisit.id is not null then
	vis := ivisit;
	st.visit_id := ivisit.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_assess(iassess in cw_assess_table%rowtype) is
begin
   if iassess.id is not null then
	ass := iassess;
	st.assess_id := iassess.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_asthma(iasthma in cw_asthma_table%rowtype) is
begin
   if iasthma.id is not null then
	ast := iasthma;
	st.asthma_id := iasthma.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_medicat(imedicat in cw_medicat_table%rowtype) is
begin
   if imedicat.id is not null then
	med := imedicat;
	st.medicat_id := imedicat.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
/*
procedure set_npract(inpract in cw_npract_table%rowtype) is
begin
   if inpract.id is not null then
	npr := inpract;
	st.npract_id := inpract.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_doctor(idoctor in cw_doctor_table%rowtype) is
begin
   if idoctor.id is not null then
	doc := idoctor;
	st.doctor_id := idoctor.id;
  	save_state;
   end if;
end;
-------------------------------------------------------------------------
procedure set_careinfo(icareinfo in cw_careinfo_table%rowtype) is
begin
   if icareinfo.id is not null then
	car := icareinfo;
	st.careinfo_id := icareinfo.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_immun(iimmun in cw_immun_table%rowtype) is
begin
   if iimmun.id is not null then
	imm := iimmun;
	st.immun_id := iimmun.id;
  	save_state;
   end if;
end;
------------------------------------------------------------------------
procedure set_basescr(ibasescr in cw_basescr_table%rowtype) is
begin
   if ibasescr.id is not null then
	bas := ibasescr;
	st.basescr_id := ibasescr.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_physscr(iphysscr in cw_physscr_table%rowtype) is
begin
   if iphysscr.id is not null then
	phy := iphysscr;
	st.physscr_id := iphysscr.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_develscr(idevelscr in cw_develscr_table%rowtype) is
begin
   if idevelscr.id is not null then
	dev := idevelscr;
	st.develscr_id := idevelscr.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_hhistory(ihhistory in cw_hhistory_table%rowtype) is
begin
   if ihhistory.id is not null then
	hhi := ihhistory;
	st.hhistory_id := ihhistory.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_visit(ivisit in cw_visit_table%rowtype) is
begin
   if ivisit.id is not null then
	vis := ivisit;
	st.visit_id := ivisit.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_assess(iassess in cw_assess_table%rowtype) is
begin
   if iassess.id is not null then
	ass := iassess;
	st.assess_id := iassess.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_prognote(iprognote in cw_prognote_table%rowtype) is
begin
   if iprognote.id is not null then
	pro := iprognote;
	st.prognote_id := iprognote.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_growth(igrowth in cw_growth_table%rowtype) is
begin
   if igrowth.id is not null then
	gro := igrowth;
	st.growth_id := igrowth.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_hplan(ihplan in cw_hplan_table%rowtype) is
begin
   if ihplan.id is not null then
	hpl := ihplan;
	st.hplan_id := ihplan.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_medicat(imedicat in cw_medicat_table%rowtype) is
begin
   if imedicat.id is not null then
	med := imedicat;
	st.medicat_id := imedicat.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
*/
procedure unset_person is
begin
   per.id := null;
   st.person_id := null;
   save_state;
end;
--------------------------------------------------------------------------
procedure unset_student is
begin
   stu.id := null;
   st.student_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_nurse is
begin
   nur.id := null;
   st.nurse_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_npract is
begin
   npr.id := null;
   st.npract_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_doctor is
begin
   doc.id := null;
   st.doctor_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_school is
begin
   nur.id := null;
   st.school_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_careinfo is
begin
   car.id := null;
   st.careinfo_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_immun is
begin
   imm.id := null;
   st.immun_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_develscr is
begin
   dev.id := null;
   st.develscr_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_visit is
begin
   vis.id := null;
   st.visit_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_assess is
begin
   ass.id := null;
   st.assess_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_asthma is
begin
   ast.id := null;
   st.asthma_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_medicat is
begin
   med.id := null;
   st.medicat_id := null;
   save_state;
end;
---------------------------------------------------------------------------
/*
procedure unset_npract is
begin
   npr.id := null;
   st.npract_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_doctor is
begin
   doc.id := null;
   st.doctor_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_careinfo is
begin
   car.id := null;
   st.careinfo_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_immun is
begin
   imm.id := null;
   st.immun_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_basescr is
begin
   .id := null;
   st._id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_physscr is
begin
   .id := null;
   st._id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_develscr is
begin
   dev.id := null;
   st.develscr_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_hhistory is
begin
   hhi.id := null;
   st.hhistory_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_visit is
begin
   vis.id := null;
   st.visit_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_assess is
begin
   ass.id := null;
   st.assess_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_prognote is
begin
   pro.id := null;
   st.prognote_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_growth is
begin
   gro.id := null;
   st.growth_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_hplan is
begin
   hpl.id := null;
   st.hplan_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_medicat is
begin
   med.id := null;
   st.medicat_id := null;
   save_state;
end;
---------------------------------------------------------------------------
*/
procedure conn is
demo_url varchar2(128);
icon_url varchar2(128);
begin
   me := 'cw_bridge.conn';
   st := cw_state.new;
   st.counter := 1;
   save_state;

--   demo_url := 'http://king.syr.edu:2006/WebMed/Demos/CareWeb/';
   demo_url := cw_util.getDemoURL;
   icon_url := 'http://www.npac.syr.edu/users/sangeeta/media_url/';
--   cw_util.pageOpen('Connect to the CareWeb Bridge');
   htp.p('<script language="JavaScript">');
   htp.p('top.frames["cmd"].location = "'||demo_url||'cmd/Login.html";');
   htp.p('top.frames["list"].location = "'||demo_url||'List.html";');
   htp.p('top.frames["cntl"].location = "'||demo_url||'Bridge.html";');
   htp.p('</script>');
   cw_util.iconPageOpen('CareWeb Connection Manager:',
	'Connect to The CareWeb Bridge',icon_url||'keys.gif');
   cw_util.login_form(to_char(st.id));
   cw_util.pageClose;
end;
--------------------------------------------------------------------------
procedure conn(cookie in varchar2) is
begin
   conn;
end;
---------------------------------------------------------------------------
procedure auth(cookie in varchar2, iuser in varchar2,
   ipasswd in varchar2, iaction in varchar2) is
usr varchar2(32);
passwd varchar2(32);
cu_passwd varchar2(32);
action varchar2(32);
duplicate_user exception;
invalid_user exception;
dba_check exception;
begin
   me := 'cw_bridge.auth';
   restore_state(cookie);
   save_state;
   cw_state.cleanup;

   action := ltrim(rtrim(iaction));
   if iuser is null then 
	usr := '';
   else
	usr := iuser;
   end if;
   if ipasswd is null then
	passwd := '';
   else
	passwd := ipasswd;
   end if;


   if action = 'Login' then
	begin
	   cu := cw_customer.get(usr);
	   cu_passwd := cu.password;

	   if passwd is null then
		raise invalid_user;
	   end if;
	   if passwd = '' then
		raise invalid_user;
 	   end if;
	   if passwd != cu_passwd then
		raise invalid_user;
	   end if;
	   st.cust_id := cu.id;
	   save_state;
	   tx_save(cw_tx.t_login,cw_tx.a_accept);
	   home(cookie);
	exception
	   when no_data_found then
		raise invalid_user;
	   when others then
		raise;
	end;
   elsif action = 'Register' then
	begin
		cu := cw_customer.get(usr);
		raise duplicate_user;
	exception
		when no_data_found then
		   null;
		when others then
		   raise;
	end;
	cu.username := usr;
	cu.password := passwd;
	cw_customer.new(cu);
	st.cust_id := cu.id;
	save_state;
	tx_save(cw_tx.t_guest,cw_tx.a_create);
	personal(cookie);
   elsif action = 'Visit' then
	begin
	   usr := 'guest@'||st.remote_host;
	   passwd := '';
	   cu := cw_customer.get(usr);
	   st.cust_id := cu.id;
	   save_state;
	   tx_save(cw_tx.t_login, cw_tx.a_accept);
	exception
	   when no_data_found then
		null;
	   when others then
		raise;
	end;
	cu.username := usr;
	cu.password := passwd;
	cw_customer.new(cu);
	st.cust_id := cu.id;
	save_state;
	tx_save(cw_tx.t_guest,cw_tx.a_create);
	home(cookie);
   else
	cw_error.panic(me,'Invalid action='||action||'.');
   end if;
exception
   when invalid_user then
	err_invalid_user;
   when duplicate_user then
	err_duplicate_user(usr);
   when dba_check then
	cw_error.die(me||'('||cookie||')',sqlerrm);
   when others then
	cw_error.die(me,sqlerrm);
end;
--------------------------------------------------------------------------
procedure personal(cookie in varchar2) is
begin
   cw_util.pageOpen('CareWeb Guest Registration Page');
   cw_util.pageClose;
end;
--------------------------------------------------------------------------
procedure home(cookie in varchar2) is
begin
   if cu.password = 'cwdba' then
	cw_table_mgr.home_cmd(cookie);
   else
      cw_util.pageOpen('CareWeb Home Page');
      cw_util.pageClose;
   end if;
exception
   when others then
	cw_error.panic('cw_bridge.home',sqlerrm);
end;
--------------------------------------------------------------------------
procedure save_state is
begin
   st.module := me;
   st.timestamp := sysdate;
   cw_state.put(st);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
---------------------------------------------------------------------------
procedure restore_state(cookie in varchar2) is
begin
   cw_tx.open;
   st := cw_state.get(cookie);
   if st.cust_id is not null then
	cu := cw_customer.get(st.cust_id);
   end if;
   if st.person_id is not null then
	per := cw_person.get(st.person_id);
   end if;
   if st.nurse_id is not null then
	nur := cw_nurse.get(st.nurse_id);
   end if;
   if st.npract_id is not null then
	npr := cw_npract.get(st.npract_id);
   end if;
   if st.doctor_id is not null then
	doc := cw_doctor.get(st.doctor_id);
   end if;
   if st.student_id is not null then
	stu := cw_student.get(st.student_id);
   end if;	
   if st.school_id is not null then
	sch := cw_school.get(st.school_id);
   end if;
   if st.careinfo_id is not null then
	car := cw_careinfo.get(st.careinfo_id);
   end if;
   if st.immun_id is not null then
	imm := cw_immun.get(st.immun_id);
   end if;
   if st.develscr_id is not null then
	dev := cw_develscr.get(st.develscr_id);
   end if;
 if st.visit_id is not null then
	vis := cw_visit.get(st.visit_id);
   end if;
 if st.assess_id is not null then
	ass := cw_assess.get(st.assess_id);
   end if;
 if st.asthma_id is not null then
	ast := cw_asthma.get(st.asthma_id);
   end if;
 if st.medicat_id is not null then
	med := cw_medicat.get(st.medicat_id);
   end if;
end;
---------------------------------------------------------------------------
procedure sync(proc in varchar2, cookie in varchar2) is
begin
   me := proc;
   restore_state(cookie);
   save_state;
   cw_state.cleanup;
end;
----------------------------------------------------------------------------
procedure tx_save(itarget in number, iaction in number) is
begin
   xx.auth_type		:= st.auth_type;
   xx.gateway_interf	:= st.gateway_interf;
   xx.http_user_agent	:= st.http_user_agent;
   xx.remote_host	:= st.remote_host;
   xx.remote_addr	:= st.remote_addr;
   xx.remote_user	:= st.remote_user;
   xx.remote_ident	:= st.remote_ident;
   xx.server_software	:= st.server_software;
   xx.server_name	:= st.server_name;
   xx.server_port	:= st.server_port;

   xx.id 	:= null;
   xx.target	:= itarget;
   xx.action	:= iaction;
   xx.cust_id	:= cu.id;
   xx.url	:= me;
   cw_tx.put(xx);
exception
   when others then
	cw_error.die('cw_bridge.tx_save called from '||me,sqlerrm);
end;
---------------------------------------------------------------------------
procedure admin(cookie in varchar2) is
begin
   sync('cw_bridge.admin',cookie);

   cw_util.pageOpen('CareWeb DBA: Customer List');
   htp.anchor('cw_root_world.home?cookie='||cookie,'Root Home Page');
   cw_list.customers;
   cw_util.pageClose;
end;
---------------------------------------------------------------------------
procedure err_invalid_user is
begin

   cw_util.pageOpen('CareWeb Connection Manager: ERROR','ivory','crimson',7);
   htp.p('<font size=7 color="yellow"><center><p>');
   htp.p('You specified invalid username or password. ');
   htp.para;
   htp.p('Please correct and connect again.');
   htp.p('</center></font>');
   cw_util.pageClose;

end;
-----------------------------------------------------------------------------
procedure err_duplicate_user(usr in varchar2) is
begin

   cw_util.pageOpen('CareWeb Connection Manager: ERROR','ivory','crimson',7);
   htp.p('<font size=7 color="yellow"><center><p>');
   htp.p('Username "'||usr||'" already exists. ');
   htp.para;
   htp.p('Please select some other username and register again.');
   htp.p('</center></font>');
   cw_util.pageClose;

end;
-----------------------------------------------------------------------------
end;
/
show errors 

