--------------------------------------------------------------------------
create or replace package cw_bridge_jguo is
--------------------------------------------------------------------------
function get_medicat return cw_medicat_table%rowtype;
function get_immun return cw_immun_table%rowtype;
/*
function get_npract return cw_npract_table%rowtype;
function get_doctor return cw_doctor_table%rowtype;
function get_basescr return cw_basescr_table%rowtype;
function get_physscr return cw_physscr_table%rowtype;
function get_hhistory return cw_hhistory_table%rowtype;
function get_visit return cw_visit_table%rowtype;
function get_assess return cw_assess_table%rowtype;
function get_prognote return cw_prognote_table%rowtype;
function get_growth return cw_growth_table%rowtype;
function get_hplan return cw_hplan_table%rowtype;
*/

procedure set_immun(iimmun in cw_immun_table%rowtype);
procedure set_medicat(imedicat in cw_medicat_table%rowtype);
/*
procedure set_develscr(idevelscr in cw_develscr_table%rowtype);
procedure set_person(iperson in cw_person_table%rowtype);
procedure set_student(istudent in cw_student_table%rowtype);
procedure set_nurse(inurse in cw_nurse_table%rowtype);
procedure set_school(ischool in cw_school_table%rowtype);
procedure set_careinfo(icareinfo in cw_careinfo_table%rowtype);
procedure set_npract(inpract in cw_npract_table%rowtype);
procedure set_doctor(idoctor in cw_doctor_table%rowtype);
procedure set_basescr(ibasescr in cw_basescr_table%rowtype);
procedure set_physscr(iphysscr in cw_physscr_table%rowtype);
procedure set_hhistory(ihhistory in cw_hhistory_table%rowtype);
procedure set_visit(ivisit in cw_visit_table%rowtype);
procedure set_assess(iassess in cw_assess_table%rowtype);
procedure set_prognote(iprognote in cw_prognote_table%rowtype);
procedure set_growth(igrowth in cw_growth_table%rowtype);
procedure set_hplan(ihplan in cw_hplan_table%rowtype);
*/

procedure unset_immun;
procedure unset_medicat;
/*
procedure unset_develscr;
procedure unset_person;
procedure unset_student;
procedure unset_nurse;
procedure unset_school;
procedure unset_careinfo;
procedure unset_npract;
procedure unset_doctor;
procedure unset_basescr;
procedure unset_physscr;
procedure unset_hhistory;
procedure unset_visit;
procedure unset_assess;
procedure unset_prognote;
procedure unset_growth;
procedure unset_hplan;
*/

procedure conn;
procedure auth(cookie in varchar2, iuser in varchar2,
   ipasswd in varchar2, iaction in varchar2);
procedure personal(cookie in varchar2);
procedure home(cookie in varchar2);
procedure admin(cookie in varchar2);

procedure save_state;
procedure restore_state(cookie in varchar2);
procedure sync(proc in varchar2,cookie in varchar2);
procedure tx_save(itarget in number, iaction in number);

me varchar2(64);
st cw_state_table%rowtype;
cu cw_customer_table%rowtype;
xx cw_tx_table%rowtype;

imm cw_immun_table%rowtype;
med cw_medicat_table%rowtype;
dev cw_develscr_table%rowtype;
per cw_person_table%rowtype;
stu cw_student_table%rowtype;
nur cw_nurse_table%rowtype;
sch cw_school_table%rowtype;
car cw_careinfo_table%rowtype;
/*
dev cw_develscr_table%rowtype;
per cw_person_table%rowtype;
stu cw_student_table%rowtype;
nur cw_nurse_table%rowtype;
npr cw_npract_table%rowtype;
sch cw_school_table%rowtype;
car cw_careinfo_table%rowtype;
doc cw_doctor_table%rowtype;
bas cw_basescr_table%rowtype;
phy cw_physscr_table%rowtype;
hhi cw_hhistory_table%rowtype;
vis cw_visit_table%rowtype;
ass cw_assess_table%rowtype;
pro cw_prognote_table%rowtype;
gro cw_growth_table%rowtype;
hpl cw_hplan_table%rowtype;
*/


end;
/
show errors
--------------------------------------------------------------------------
create or replace package body cw_bridge_jguo is
--------------------------------------------------------------------------
--------------------------------------------------------------------------
invalid_user exception;
invalid_input exception;
--------------------------------------------------------------------------
---------------------------------------------------------------------------
function get_immun return cw_immun_table%rowtype is
begin
   return imm;
end;
--------------------------------------------------------------------------
function get_medicat return cw_medicat_table%rowtype is
begin
   return med;
end;
--------------------------------------------------------------------------
/*
--------------------------------------------------------------------------
function get_develscr return cw_develscr_table%rowtype is
begin
   return dev;
end;
--------------------------------------------------------------------------
function get_visit return cw_visit_table%rowtype is
begin
   return vis;
end;
--------------------------------------------------------------------------
function get_assess return cw_assess_table%rowtype is
begin
   return ass;
end;
--------------------------------------------------------------------------
*/
--------------------------------------------------------------------------
procedure set_immun(iimmun in cw_immun_table%rowtype) is
begin
   if iimmun.id is not null then
	imm := iimmun;
	st.immun_id := iimmun.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_medicat(imedicat in cw_medicat_table%rowtype) is
begin
   if imedicat.id is not null then
	med := imedicat;
	st.medicat_id := imedicat.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
/*
--------------------------------------------------------------------------
procedure set_visit(ivisit in cw_visit_table%rowtype) is
begin
   if ivisit.id is not null then
	vis := ivisit;
	st.visit_id := ivisit.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
procedure set_assess(iassess in cw_assess_table%rowtype) is
begin
   if iassess.id is not null then
	ass := iassess;
	st.assess_id := iassess.id;
  	save_state;
   end if;
end;
--------------------------------------------------------------------------
*/
---------------------------------------------------------------------------
procedure unset_immun is
begin
   imm.id := null;
   st.immun_id := null;
   save_state;
end;
---------------------------------------------------------------------------
procedure unset_medicat is
begin
   med.id := null;
   st.medicat_id := null;
   save_state;
end;
---------------------------------------------------------------------------
/*
--------------------------------------------------------------------------
procedure unset_visit is
begin
   vis.id := null;
   st.visit_id := null;
   save_state;
end;
--------------------------------------------------------------------------
procedure unset_assess is
begin
   ass.id := null;
   st.assess_id := null;
   save_state;
end;
---------------------------------------------------------------------------
*/
---------------------------------------------------------------------------
procedure conn is
begin
   me := 'cw_bridge_jguo.conn';
   st := cw_state.new;
   st.counter := 1;
   save_state;
	   
   cw_util.pageOpen('Connect to the CareWeb Bridge');
   htp.p('<script language="JavaScript">');
   htp.p('top.frames["cmd"].location =
	"http://king.syr.edu:2006/WebMed/Demos/CareWeb/cmd/Login.html";');
   htp.p('</script>');
   cw_util.login_form(to_char(st.id));
   cw_util.pageClose;
end;
--------------------------------------------------------------------------
procedure auth(cookie in varchar2, iuser in varchar2,
   ipasswd in varchar2, iaction in varchar2) is
usr varchar2(32);
passwd varchar2(32);
cu_passwd varchar2(32);
action varchar2(32);
duplicate_user exception;
invalid_user exception;
dba_check exception;
begin
   me := 'cw_bridge_jguo.auth';
   restore_state(cookie);
   save_state;
   cw_state.cleanup;

   action := ltrim(rtrim(iaction));
   if iuser is null then 
	usr := '';
   else
	usr := iuser;
   end if;
   if ipasswd is null then
	passwd := '';
   else
	passwd := ipasswd;
   end if;


   if action = 'Login' then
	begin
	   cu := cw_customer.get(usr);
	   cu_passwd := cu.password;
	   if cu_passwd is null then
		cu_passwd := '';
	   end if;
	   if cu_passwd = '' then
		if passwd != '' then
		   raise invalid_user;
		end if;
	   elsif passwd = '' then
		   raise invalid_user;
	   elsif passwd != cu_passwd then
		   raise invalid_user;
	   end if;
	   st.cust_id := cu.id;
	   save_state;
	   tx_save(cw_tx.t_login,cw_tx.a_accept);
	   home(cookie);
	exception
	   when no_data_found then
		raise invalid_user;
	   when others then
		raise;
	end;
   elsif action = 'Register' then
	begin
		cu := cw_customer.get(usr);
		raise duplicate_user;
	exception
		when no_data_found then
		   null;
		when others then
		   raise;
	end;
	cu.username := usr;
	cu.password := passwd;
	cw_customer.new(cu);
	st.cust_id := cu.id;
	save_state;
	tx_save(cw_tx.t_guest,cw_tx.a_create);
	personal(cookie);
   elsif action = 'Visit' then
	begin
	   usr := 'guest@'||st.remote_host;
	   passwd := '';
	   cu := cw_customer.get(usr);
	   st.cust_id := cu.id;
	   save_state;
	   tx_save(cw_tx.t_login, cw_tx.a_accept);
	exception
	   when no_data_found then
		null;
	   when others then
		raise;
	end;
	cu.username := usr;
	cu.password := passwd;
	cw_customer.new(cu);
	st.cust_id := cu.id;
	save_state;
	tx_save(cw_tx.t_guest,cw_tx.a_create);
	home(cookie);
   else
	cw_error.panic(me,'Invalid action='||action||'.');
   end if;
exception
   when invalid_user then
	cw_error.msg('Invalid username = '||usr);
   when duplicate_user then
	cw_error.msg('Duplicate username = '||usr);
   when dba_check then
	cw_error.die(me||'('||cookie||')',sqlerrm);
   when others then
	cw_error.die(me,sqlerrm);
end;
--------------------------------------------------------------------------
procedure personal(cookie in varchar2) is
begin
   cw_util.pageOpen('CareWeb Guest Registration Page');
   cw_util.pageClose;
end;
--------------------------------------------------------------------------
procedure home(cookie in varchar2) is
begin
   if cu.password = 'cwdba' then
	cw_table_mgr.home_cmd(cookie);
   else
      cw_util.pageOpen('CareWeb Home Page');
      cw_util.pageClose;
   end if;
exception
   when others then
	cw_error.panic('cw_bridge_jguo.home',sqlerrm);
end;
--------------------------------------------------------------------------
procedure save_state is
begin
   st.module := me;
   st.timestamp := sysdate;
   cw_state.put(st);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
---------------------------------------------------------------------------
procedure restore_state(cookie in varchar2) is
begin
   cw_tx.open;
   st := cw_state.get(cookie);
   if st.cust_id is not null then
	cu := cw_customer.get(st.cust_id);
   end if;
   if st.person_id is not null then
	per := cw_person.get(st.person_id);
   end if;
   if st.nurse_id is not null then
	nur := cw_nurse.get(st.nurse_id);
   end if;
   if st.student_id is not null then
	stu := cw_student.get(st.student_id);
   end if;	
   if st.school_id is not null then
	sch := cw_school.get(st.school_id);
   end if;
   if st.careinfo_id is not null then
	car := cw_careinfo.get(st.careinfo_id);
   end if;
   if st.immun_id is not null then
	imm := cw_immun.get(st.immun_id);
   end if;
   if st.develscr_id is not null then
	dev := cw_develscr.get(st.develscr_id);
   end if;
end;
---------------------------------------------------------------------------
procedure sync(proc in varchar2, cookie in varchar2) is
begin
   me := proc;
   restore_state(cookie);
   save_state;
   cw_state.cleanup;
end;
----------------------------------------------------------------------------
procedure tx_save(itarget in number, iaction in number) is
begin
   xx.auth_type		:= st.auth_type;
   xx.gateway_interf	:= st.gateway_interf;
   xx.http_user_agent	:= st.http_user_agent;
   xx.remote_host	:= st.remote_host;
   xx.remote_addr	:= st.remote_addr;
   xx.remote_user	:= st.remote_user;
   xx.remote_ident	:= st.remote_ident;
   xx.server_software	:= st.server_software;
   xx.server_name	:= st.server_name;
   xx.server_port	:= st.server_port;

   xx.id 	:= null;
   xx.target	:= itarget;
   xx.action	:= iaction;
   xx.cust_id	:= cu.id;
   xx.url	:= me;
   cw_tx.put(xx);
exception
   when others then
	cw_error.die('cw_bridge_jguo.tx_save called from '||me,sqlerrm);
end;
---------------------------------------------------------------------------
procedure admin(cookie in varchar2) is
begin
   sync('cw_bridge_jguo.admin',cookie);

   cw_util.pageOpen('CareWeb DBA: Customer List');
   htp.anchor('cw_root_world.home?cookie='||cookie,'Root Home Page');
   cw_list.customers;
   cw_util.pageClose;
end;
---------------------------------------------------------------------------
end;
/
show errors 

