-----------------------------------------------------------------------------
create or replace package cw_careinfo_util is
-----------------------------------------------------------------------------
procedure create_form;
procedure modify_form(r in cw_careinfo_table%rowtype);
procedure show_form(r in cw_careinfo_table%rowtype);
end;
/
show errors
------------------------------------------------------------------------------
create or replace package body cw_careinfo_util is
------------------------------------------------------------------------------
procedure create_form is
begin
         htp.tableOpen('BORDER',null,null,null,'CELLSPACING=4 CELLPADDING=5');

            htp.tableRowOpen('CENTER','MIDDLE');
                htp.tableHeader('Health','CENTER');
                htp.tableHeader('Health Care Provider','CENTER','NOWRAP');
                htp.tableHeader('Health Insurance','CENTER','NOWRAP');
                htp.tableHeader('Medicaid #','CENTER','NOWRAP');                 
                htp.tableHeader('Permission To Treat','CENTER','NOWRAP');
	    htp.tableRowClose;

            htp.tableRowOpen('CENTER','MIDDLE');
                htp.tableData;
                htp.tableData(htf.formText('health_provider',15));
                htp.tableData(htf.formText('health_insur',15));                 
                htp.tableData(htf.formText('medicaid',7));                              
                htp.tableData(htf.formText('treat_permission',6));
	    htp.tableRowClose;

            htp.tableRowOpen('RIGHT','MIDDLE');
                htp.tableHeader;   
                htp.tableHeader('Do Not Release To','CENTER','NOWRAP');
                htp.tableHeader('Emergency Contact ','CENTER','NOWRAP');
                htp.tableHeader('Emergency Protocol','CENTER','NOWRAP');
	    htp.tableRowClose;

              htp.tableRowOpen('CENTER','MIDDLE');
                htp.tableData;          
                htp.tableData(htf.formText('not_releaseto',15));                              
                htp.tableData(htf.formText('emergency_contact',15));                 
                htp.tableData(htf.formText('emergency_protocol',15));
	    htp.tableRowClose;
       
            htp.tableRowOpen('RIGHT','MIDDLE');
                htp.tableHeader; 
                htp.tableHeader('Allergy Type','CENTER','NOWRAP');
                htp.tableHeader('Allergy Reaction','CENTER','NOWRAP');
	    htp.tableRowClose;

            htp.tableRowOpen('CENTER','MIDDLE');
                htp.tableData; 
                htp.tableData(htf.formText('allergy_type',15));
                htp.tableData(htf.formText('allergy_reaction',15));
	    htp.tableRowClose;
         
         htp.tableClose;
end;
-------------------------------------------------------------------------------
procedure modify_form(r in cw_careinfo_table%rowtype) is
begin
         htp.tableOpen('BORDER',null,null,null,'CELLSPACING=4 CELLPADDING=5');

            htp.tableRowOpen('CENTER','MIDDLE');
                htp.tableHeader('Health Care Provider','CENTER','NOWRAP');
                htp.tableHeader('Health Insurance','CENTER','NOWRAP');
                htp.tableHeader('Medicaid #','CENTER','NOWRAP');
                htp.tableHeader('Permission To Treat','CENTER','NOWRAP');
	   htp.tableRowClose;

           htp.tableRowOpen('CENTER','MIDDLE');
                htp.tableData;
                htp.tableData(htf.formText('health_provider',10,null,
			r.health_provider));                              
                htp.tableData(htf.formText('health_insur',10,null,
			r.health_insur));
                htp.tableData(htf.formText('medicaid',6,null,
			r.medicaid));
                htp.tableData(htf.formText('treat_permission',4,null,
			r.treat_permission)); 
	   htp.tableRowClose;
      
           htp.tableRowOpen('LEFT','MIDDLE');
                htp.tableHeader('Not To Release To','CENTER','NOWRAP'); 
                htp.tableHeader('Emergency Contact ','CENTER','NOWRAP');
                htp.tableHeader('Emergency Protocol','CENTER','NOWRAP');
	   htp.tableRowClose;

           htp.tableRowOpen('LEFT','MIDDLE');
                htp.tableData;                        
                htp.tableData(htf.formText('not_releaseto',10,null,
			r.not_releaseto));             
                htp.tableData(htf.formText('emergency_contact',10,null,
			r.emergency_contact));                 
                htp.tableData(htf.formText('emergency_protocol',10,null,
			r.emergency_protocol));
 	   htp.tableRowClose;
                      
            htp.tableRowOpen('LEFT','MIDDLE');
               htp.tableHeader;
                htp.tableHeader('Allergy Type','CENTER','NOWRAP');                 
                htp.tableHeader('Allergy Reaction','CENTER','NOWRAP');
 	   htp.tableRowClose;

           htp.tableRowOpen('LEFT','MIDDLE');
                htp.tableData; 
                htp.tableData(htf.formText('allergy_type',10,null,
			r.allergy_type));
                htp.tableData(htf.formText('allergy_reaction',10,null,
			r.allergy_reaction));
 		htp.tableRowClose;  
            htp.tableClose;  
      
         htp.tableClose;
end;
-------------------------------------------------------------------------------

procedure show_form(r in cw_careinfo_table%rowtype) is
begin
   htp.tableOpen('BORDER',null,null,null,'CELLSPACING=6 CELLPADDING=10');

       htp.tableRowOpen('CENTER','MIDDLE');
           htp.tableHeader('Health Care Provider','CENTER',null,'midnightblue');
           htp.tableData(r.health_provider,null,null,'maroon');
           htp.tableHeader('Health Insurance','CENTER',null,'midnightblue');
           htp.tableData(r.health_insur,null,null,'maroon');
	htp.tableRowClose;  

	htp.tableRowOpen('CENTER','MIDDLE');
           htp.tableHeader('Medicaid #','CENTER',null,'midnightblue');
           htp.tableData(r.medicaid,null,null,'maroon');
           htp.tableHeader('       ','CENTER');
           htp.tableData('         ');
	htp.tableRowClose; 
 
	htp.tableRowOpen('CENTER','MIDDLE');        
           htp.tableHeader('Do Not Release To','CENTER',null,'midnightblue');
           htp.tableData(r.not_releaseto,null,null,'maroon');
           htp.tableHeader('Permission To Treat','CENTER',null,'midnightblue');
           htp.tableData(r.treat_permission,null,null,'maroon');
	htp.tableRowClose; 

        htp.tableRowOpen('CENTER','MIDDLE');
           htp.tableHeader('Emergency Contact','CENTER',null,'midnightblue');
           htp.tableData(r.emergency_contact,null,null,'maroon');
           htp.tableHeader('Emergency Protocol','CENTER',null,'midnightblue');      
           htp.tableData(r.emergency_protocol,null,null,'maroon');
	htp.tableRowClose; 

        htp.tableRowOpen('CENTER','MIDDLE');
           htp.tableHeader('Allergy Type','CENTER',null,'midnightblue');
           htp.tableData(r.allergy_type,null,null,'maroon');
           htp.tableHeader('Allergy Reaction','CENTER',null,'midnightblue');       
           htp.tableData(r.allergy_reaction,null,null,'maroon');
       htp.tableClose;  
   
   htp.tableClose;
end;   
------------------------------------------------------------------------------   
end;
/
show errors
