-----------------------------------------------------------------------------
create or replace package cw_develscr_mgr is
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number);
procedure bar_page(cookie in varchar2);
procedure bar_action(cookie in varchar2, cmd in varchar2);

procedure out_cmd(cookie in varchar2);
procedure home_cmd(cookie in varchar2);
procedure all_cmd(cookie in varchar2);
procedure select_cmd(cookie in varchar2);
procedure filter_cmd(cookie in varchar2);
procedure create_cmd(cookie in varchar2);
procedure create_action(cookie in varchar2, r in cw_develscr_table%rowtype);
procedure modify_cmd(cookie in varchar2);
procedure modify_action(cookie in varchar2, r in cw_develscr_table%rowtype);
procedure delete_cmd(cookie in varchar2);
procedure save_cmd(cookie in varchar2);
procedure load_cmd(cookie in varchar2);
procedure help_cmd(cookie in varchar2);

procedure err_notimpl(cookie in varchar2);

invalid_command exception;
no_current_person exception;
no_current_nurse exception; 
no_current_student exception;  
end;
/
show errors
-----------------------------------------------------------------------------
create or replace package body cw_develscr_mgr is
-----------------------------------------------------------------------------
me varchar2(64);
url varchar2(64) := cw_util.getURL;
curr_cmd varchar2(32);
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number) is
p cw_person_table%rowtype;
st cw_student_table%rowtype;
de cw_develscr_table%rowtype;
begin
   me := 'cw_develscr_mgr.show_cmd';
   cw_bridge.sync(me,cookie);

   de := cw_develscr.get(iid);
   st := cw_student.get(de.student_id);
   p   := cw_person.get(st.person_id);
   cw_bridge.set_develscr(de);
   cw_bridge.set_student(st);
   cw_bridge.set_person(p);
   cw_util.pageOpen('CareWeb Developmental Form Manager: '||
	p.first_name||' '||p.middle_name||' '||p.last_name);
   htp.p('<CENTER>');
   cw_develscr_util.show_form(de);
   htp.p('</CENTER>');
   cw_util.pageClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_page(cookie in varchar2) is
begin
   me := 'cw_develscr_mgr.bar_page';
   --url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('cmd');
   cw_util.docWrite('cmd',
	'<html><body bgcolor="darkgreen"><font size=5 color="ivory"><center>');
   cw_util.docWrite('cmd',
	'<form action= "'||url||'cw_develscr_mgr.bar_action" target="view">');
   cw_util.docWrite('cmd',
	'<input type="hidden" name="cookie" value="'||cookie||'">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Out">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Home">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="All">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Select">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Filter">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Create">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Modify">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Delete">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Save">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Load">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Help">');
    cw_util.docWrite('cmd',
	'</form></center></font></body></html>');
   cw_util.docClose('cmd');
   cw_util.jsClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_action(cookie in varchar2, cmd in varchar2) is
begin
   me := 'cw_develscr_mgr.bar_action';
   cw_bridge.sync(me,cookie);

   curr_cmd := cmd;

   if cmd = 'Out' then
	out_cmd(cookie);
   elsif cmd = 'Home' then
	home_cmd(cookie);
   elsif cmd = 'All' then
	all_cmd(cookie);
   elsif cmd = 'Select' then
	select_cmd(cookie);
   elsif cmd = 'Filter' then
	filter_cmd(cookie);
   elsif cmd = 'Create' then
	create_cmd(cookie);
   elsif cmd = 'Modify' then
	modify_cmd(cookie);
   elsif cmd = 'Delete' then
	delete_cmd(cookie);
   elsif cmd = 'Save' then
     save_cmd(cookie);
   elsif cmd = 'Load' then
	load_cmd(cookie);
   elsif cmd = 'Help' then
	help_cmd(cookie);
   else 
	raise invalid_command;
   end if;
exception
   when invalid_command then
	cw_error.die(me,'Invalid command = '||cmd||'.');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure out_cmd(cookie in varchar2) is
begin
   me := 'cw_develscr_mgr.out_cmd';
   cw_bridge.sync(me,cookie);
   
   cw_bridge.unset_school;
   cw_bridge.unset_student;
   cw_bridge.unset_nurse;
   cw_bridge.unset_develscr;
   cw_table_mgr.home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure home_cmd(cookie in varchar2) is
stu cw_student_table%rowtype;
per cw_person_table%rowtype;
icon_url varchar2(128);
icon_action varchar2(128);
per_photo varchar2(128);
begin
   me := 'cw_develscr_mgr.home_cmd';
   cw_bridge.sync(me,cookie);

   stu := cw_bridge.get_student;
 
   if stu.id is null then
          icon_url := 
      'http://www.npac.syr.edu/users/sangeeta/media_url/database.gif';
       icon_action := 'cw_table_mgr.home_cmd';
       cw_table_mgr.all_list(cookie);
   else
       per := cw_person.get(stu.person_id);
       if per.media_url is null then
       icon_url := 
'/careweb/images/shrideep.jpg';
        else 
        per_photo := per.media_url||'/photo.gif';
    icon_url :=
'http://www.npac.syr.edu/users/sangeeta/media_url/'||per_photo;
    end if;
    icon_action := 'cw_student_mgr.show_cmd';
    cw_student_mgr.dir_list(cookie);
    
     end if;
     cw_util.cntl_putimg(cookie,icon_url,icon_action);

   bar_page(cookie);
   all_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_cmd(cookie in varchar2) is
cnt number(6);
ncol number(2) := 3;
i number(2);
r cw_develscr_table%rowtype;
st cw_student_table%rowtype;
p cw_person_table%rowtype;
id number;
begin
   me := 'cw_develscr_mgr.all_cmd';
   cw_bridge.sync(me,cookie);

--   cw_util.pageOpen('CareWeb Developmental Page  Manager: All Students');
     cw_util.iconPageOpen('CareWeb Developmental Page Manager: ','All Students','http://www.npac.syr.edu/users/sangeeta/media_url/develscr.gif');
   htp.p('<center>');

   htp.tableOpen(cattributes=>'border=5');
   htp.tableRowOpen;
   for j in 1..ncol loop
   htp.tableHeader('Name');
   htp.tableHeader('Age');
   htp.tableHeader('Date');
   if j < ncol then
	htp.tableHeader('   ');
   end if;
   end loop;
   htp.tableRowClose;

   htp.tableRowOpen;
   i := 1; 
   while(cw_develscr.next(r)) loop
	if i = 1 then
		htp.tableRowOpen;
	end if;
       --  htp.p('THe student id is ');
       --  htp.p(r.student_id);
         st := cw_student.get(r.student_id); 
         p  := cw_person.get(st.person_id);
	htp.tableData(htf.anchor('cw_develscr_mgr.show_cmd?cookie='
		||cookie||chr(ascii('&'))||'iid='||r.id,p.first_name||' '||p.middle_name||' '||p.last_name));
	htp.tableData(r.age);
	htp.tableData(r.tdate);
	if i < ncol then
		htp.tableData('');
		i := i + 1;
	else
		htp.tableRowOpen;
		i := 1;
	end if;     
   end loop; 
   htp.tableClose;
	
   htp.p('</center>');
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure select_cmd(cookie in varchar2) is
begin
   me := 'cw_develscr_mgr.select_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure filter_cmd(cookie in varchar2) is
begin
   me := 'cw_develscr_mgr.filter_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_cmd(cookie in varchar2) is
stu cw_student_table%rowtype;
begin
   me := 'cw_develscr_mgr.create_cmd';
   cw_bridge.sync(me,cookie);


   htp.formOpen('cw_develscr.make');
   cw_util.editPageOpen(' CareWeb Developmental Manager: Create ');
   htp.formHidden('cookie',cookie);
   htp.formHidden('handler','cw_develscr_mgr.create_action');
   stu := cw_bridge.get_student;
   
--   cw_bridge.set_student(stu);
   
   htp.formHidden('student_id',stu.id); ---###student_id  is hardwired now---
   htp.p('<CENTER>');
   cw_develscr_util.create_form;
   htp.p('</CENTER>');
   htp.formClose;
   cw_util.pageClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_action(cookie in varchar2, r in cw_develscr_table%rowtype) is
de cw_develscr_table%rowtype;
p cw_person_table%rowtype;
begin
   me := 'cw_develscr_mgr.create_action';
   cw_bridge.sync(me,cookie);

   de := r;
   de.id := null;
   cw_develscr.put(de);
   p := cw_bridge.get_person;
   cw_util.pageOpen('CareWeb Developmental Manager: '||p.last_name);
   htp.p('<CENTER>');
   cw_develscr_util.show_form(de);
   htp.p('</CENTER>');
   cw_bridge.set_develscr(de);
   cw_bridge.set_person(p);
   cw_util.pageClose;
end;
-----------------------------------------------------------------------------
procedure modify_cmd(cookie in varchar2) is
p cw_person_table%rowtype;
stu cw_student_table%rowtype;
de cw_develscr_table%rowtype;
begin
   me := 'cw_develscr_mgr.modify_cmd';
   cw_bridge.sync(me,cookie);

   p := cw_bridge.get_person;
   stu := cw_bridge.get_student;
   if p.id is null then
        raise no_current_person;
   end if;
   htp.formOpen('cw_develscr.make');
   cw_util.editPageOpen(' CareWeb Developmental Form Manager: Modify '|| p.last_name||' '||
                                                        p.middle_name||' '||p.last_name);
   htp.formHidden('cookie',cookie);
   htp.formHidden('handler','cw_develscr_mgr.modify_action');
   htp.formHidden('student_id',stu.id);
   htp.p('<CENTER>');
   de := cw_bridge.get_develscr;
   cw_develscr_util.modify_form(de);
   htp.p('</CENTER>');
   cw_bridge.set_develscr(de);
   cw_bridge.set_person(p);
   cw_bridge.set_student(stu);
   htp.formClose;
   cw_util.pageClose;
exception
   when no_current_person then
        cw_error.die(me,'No current person');
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure modify_action(cookie in varchar2, r in cw_develscr_table%rowtype) is
new_dev cw_develscr_table%rowtype;
old_dev cw_develscr_table%rowtype;
p cw_person_table%rowtype;

begin
   me := 'cw_develscr_mgr.modify_action';
   cw_bridge.sync(me,cookie);

   new_dev := r;
   p := cw_bridge.get_person;
   old_dev := cw_bridge.get_develscr;
   new_dev.id := old_dev.id;
   cw_develscr.put(new_dev);  
   cw_util.pageOpen('Careweb Developmental Form Manager:'||
                          p.last_name||' '||p.middle_name||' '||p.last_name);     
   htp.p('<CENTER>');
   cw_develscr_util.show_form(new_dev);
   htp.p('</CENTER>');
   cw_bridge.set_develscr(new_dev);
   cw_bridge.set_person(p);
   cw_util.pageClose;
end;
-----------------------------------------------------------------------------
procedure delete_cmd(cookie in varchar2) is
stu cw_student_table%rowtype;
per cw_person_table%rowtype;
nur cw_nurse_table%rowtype; 
de cw_develscr_table%rowtype;
begin
   me := 'cw_develscr_mgr.delete_cmd';
   cw_bridge.sync(me,cookie);

   stu := cw_bridge.get_student;
   if stu.id is null then
       raise no_current_student;
   end if;
   nur := cw_bridge.get_nurse;
   if nur.id is null then
       raise no_current_nurse;
   end if;
   per := cw_person.get(stu.person_id);
   de := cw_bridge.get_develscr;
   if de.id is null then 
         raise no_data_found;
   end if;
   cw_util.pageOpen('CareWeb Developmental Form :'||
            per.first_name||' '||per.middle_name||' '||per.last_name);
   htp.p('<CENTER>');
   cw_develscr_util.show_form(de);
   htp.para;
   htp.p('<FONT SIZE=7 color="firebrick"> DELETED </FONT>');
   htp.p('</CENTER>');
   
   cw_develscr.rm(de.id);
   cw_bridge.unset_develscr;   
    
exception
   when no_current_nurse then
   cw_error.die(me,'No current nurse');
   when no_current_student then
   cw_error.die(me,'No current student');
   when no_data_found then
   cw_error.die(me,'No developmental form present');
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure save_cmd(cookie in varchar2) is
begin
   me := 'cw_develscr_mgr.save_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure load_cmd(cookie in varchar2) is
begin
   me := 'cw_develscr_mgr.load_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure help_cmd(cookie in varchar2) is
begin
   me := 'cw_develscr_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Person Manager: Help','crimson','ivory',7);

   htp.tableOpen(cattributes=>'border=5');

   htp.tableRowOpen;
	htp.tableHeader('Command','center');
	htp.tableHeader('Description','center');
	htp.tableheader('Access','center');
	htp.tableHeader('Status','center');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Out');
	htp.tableData('Exit the current space and move one step up');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Home');
	htp.tableData('Home Page for the CareWeb Person Manager');
	htp.tableData('DBA');
	htp.tableData('Now the same as [All]. Soon to include description '||
		'of the overall organization of the CareWeb database');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('All');
	htp.tableData('List all tables in CareWeb database '||
		'with hyperlinks to individual table spaces');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Select');
	htp.tableData('List all tables with the multiple choice '||
		'selection support');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Filter');
	htp.tableData('Restrict the list of analyzed records in terms '||
		'of a user-provided filter or query');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Create');
	htp.tableData('Create new record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Modify');
	htp.tableData('Modify current record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Delete');
	htp.tableData('Delete current selection (record or group).');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Save');
	htp.tableData('Save/dump the current selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Load');
	htp.tableData('Fetch the previously daved/dumped selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Help');
	htp.tableData('This page - includes short description of all commands');
	htp.tableData('DBA');
	htp.tabledata('Implemented');
   htp.tableRowClose;
   htp.tableClose;

   cw_util.pageClose;
exception

   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure err_notimpl(cookie in varchar2) is
begin
   me := 'cw_develscr_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Developmental Manager: ERROR','ivory','crimson',7);
   htp.p('<font size=5 color="ivory">');
   htp.para;
   htp.p('Command ['||curr_cmd||'] is not yet implemented for this space. '||
	'Click [Help] to get '||
	' the functionality, access rights and the implementation status '||
	' Not of the individual Developmental Manager commands.'); 
  exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
end;
/
show errors
