-----------------------------------------------------------------------------
create or replace package cw_doctor_mgr is
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number);
procedure bar_page(cookie in varchar2);
procedure bar_action(cookie in varchar2, cmd in varchar2);

procedure out_cmd(cookie in varchar2);
procedure home_cmd(cookie in varchar2);
procedure all_cmd(cookie in varchar2);
procedure select_cmd(cookie in varchar2);
procedure filter_cmd(cookie in varchar2);
procedure create_cmd(cookie in varchar2);
procedure create_action(cookie in varchar2, r in cw_person_table%rowtype);
procedure modify_cmd(cookie in varchar2);
procedure modify_action(cookie in varchar2, r in cw_person_table%rowtype);
procedure delete_cmd(cookie in varchar2);
procedure save_cmd(cookie in varchar2);
procedure load_cmd(cookie in varchar2);
procedure help_cmd(cookie in varchar2);
procedure consult_action(cookie in varchar2, consult in varchar2);
procedure err_notimpl(cookie in varchar2);

invalid_command exception;
no_current_doctor exception;


end;
/
show errors
-----------------------------------------------------------------------------
create or replace package body cw_doctor_mgr is
-----------------------------------------------------------------------------
me varchar2(64);
url varchar2(64) := cw_util.getURL;
curr_cmd varchar2(32);
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number) is
doc cw_doctor_table%rowtype;
per cw_person_table%rowtype;
sch cw_school_table%rowtype;
nur cw_nurse_table%rowtype;
begin
   me := 'cw_doctor_mgr.show_cmd';
   cw_bridge.sync(me,cookie);

   
   doc := cw_doctor.get(iid);
   cw_bridge.set_doctor(doc);
   per := cw_person.get(doc.person_id);
--- hack begin
   sch := cw_bridge.get_school;
   if sch.id is null then
	sch := cw_school.get(1);
	cw_bridge.set_school(sch);
   end if;
   nur := cw_bridge.get_nurse;
   if nur.id is null then
	nur := cw_nurse.get(1);
	cw_bridge.set_nurse(nur);
   end if;
--- hack end
   cw_util.pageOpen('CareWeb Pediatrician Manager: '||
	per.first_name||' '||per.middle_name||' '||per.last_name);
   htp.p('<CENTER>');
   cw_person_util.show_form(per);
   htp.formOpen('cw_doctor_mgr.consult_action');
   htp.formHidden('cookie',cookie);
   cw_doctor_util.consult_form(cookie,doc);
   htp.formClose;
   cw_doctor_util.directory_table(cookie,doc);
  
   htp.p('</CENTER>');
   cw_util.pageClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_page(cookie in varchar2) is
begin
   me := 'cw_doctor_mgr.bar_page';
  -- url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('cmd');
   cw_util.docWrite('cmd',
	'<html><body bgcolor="darkgreen"><font size=5 color="ivory"><center>');
   cw_util.docWrite('cmd',
	'<form action= "'||url||'cw_doctor_mgr.bar_action" target="view">');
   cw_util.docWrite('cmd',
	'<input type="hidden" name="cookie" value="'||cookie||'">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Out">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Home">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="All">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Select">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Filter">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Create">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Modify">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Delete">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Save">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Load">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Help">');
    cw_util.docWrite('cmd',
	'</form></center></font></body></html>');
   cw_util.docClose('cmd');
   cw_util.jsClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_action(cookie in varchar2, cmd in varchar2) is
begin
   me := 'cw_doctor_mgr.bar_action';
   cw_bridge.sync(me,cookie);

   curr_cmd := cmd;

   if cmd = 'Out' then
	out_cmd(cookie);
   elsif cmd = 'Home' then
	home_cmd(cookie);
   elsif cmd = 'All' then
	all_cmd(cookie);
   elsif cmd = 'Select' then
	select_cmd(cookie);
   elsif cmd = 'Filter' then
	filter_cmd(cookie);
   elsif cmd = 'Create' then
	create_cmd(cookie);
   elsif cmd = 'Modify' then
	modify_cmd(cookie);
   elsif cmd = 'Delete' then
	delete_cmd(cookie);
   elsif cmd = 'Save' then
	save_cmd(cookie);
   elsif cmd = 'Load' then
	load_cmd(cookie);
   elsif cmd = 'Help' then
	help_cmd(cookie);
   else 
	raise invalid_command;
   end if;
exception
   when invalid_command then
	cw_error.die(me,'Invalid command = '||cmd||'.');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure out_cmd(cookie in varchar2) is
begin
   me := 'cw_doctor_mgr.out_cmd';
   cw_bridge.sync(me,cookie);

   cw_bridge.unset_school;
   cw_bridge.unset_doctor;
   cw_table_mgr.home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure home_cmd(cookie in varchar2) is
icon_url varchar2(128);
icon_action varchar2(128);
begin
   me := 'cw_doctor_mgr.home_cmd';
   cw_bridge.sync(me,cookie);

   icon_url := 
   'http://www.npac.syr.edu/users/sangeeta/media_url/database.gif';
   icon_action := 'cw_table_mgr.home_cmd';
   cw_table_mgr.all_list(cookie);
   cw_util.cntl_putimg(cookie,icon_url,icon_action);
   bar_page(cookie);
   all_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_cmd(cookie in varchar2) is
doc cw_doctor_table%rowtype;
per cw_person_table%rowtype;

cnt number(6);
ncol number(2) := 3;
i number(2);

id number;
begin
   me := 'cw_doctor_mgr.all_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Pediatrician Manager: All Pediatricians');
   htp.p('<center>');

   htp.tableOpen(cattributes=>'border=5');
   htp.tableRowOpen;
   for j in 1..ncol loop
   htp.tableHeader('Name');
   htp.tableHeader('Affiliation');
   if j < ncol then
	htp.tableHeader('   ');
   end if;
   end loop;
   htp.tableRowClose;

   htp.tableRowOpen;
   i := 1; 
   while(cw_doctor.next(doc)) loop
	per := cw_person.get(doc.person_id);
	if i = 1 then
		htp.tableRowOpen;
	end if;
	htp.tableData(htf.anchor('cw_doctor_mgr.show_cmd?cookie='
		||cookie||chr(ascii('&'))||'iid='||doc.id,
		per.first_name||' '||per.middle_name||' '||per.last_name));
	htp.tableData(per.affiliation);
	if i < ncol then
		htp.tableData('');
		i := i + 1;
	else
		htp.tableRowOpen;
		i := 1;
	end if;
   end loop;
   htp.tableClose;
	
   htp.p('</center>');
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure select_cmd(cookie in varchar2) is
begin
   me := 'cw_doctor_mgr.select_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure filter_cmd(cookie in varchar2) is
begin
   me := 'cw_doctor_mgr.filter_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_cmd(cookie in varchar2) is
begin
   me := 'cw_doctor_mgr.create_cmd';
   cw_bridge.sync(me,cookie);

   htp.formOpen('cw_person.make');
   cw_util.editPageOpen(' CareWeb Pediatrician Manager: Create ');
   htp.formHidden('cookie',cookie);
   htp.formHidden('handler','cw_doctor_mgr.create_action');
   htp.p('<CENTER>');
   cw_person_util.create_form;
   htp.p('</CENTER>');
   htp.formClose;
   cw_util.pageClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_action(cookie in varchar2, r in cw_person_table%rowtype) is
doc cw_doctor_table%rowtype;
per cw_person_table%rowtype;
begin
   me := 'cw_doctor_mgr.create_action';
   cw_bridge.sync(me,cookie);

   per := r;
   per.id := null;
   cw_person.put(per);
   doc.person_id := per.id;
   doc.id := null;
   cw_doctor.put(doc);
   cw_bridge.set_doctor(doc);
   cw_util.pageOpen('CareWeb Pediatrician Manager: '||
	per.first_name||' '||per.middle_name||' '||per.last_name);
   htp.p('<CENTER>');
   cw_person_util.show_form(per);
   htp.formOpen('cw_doctor_mgr.consult_action?cookie='||cookie);
   cw_doctor_util.consult_form(cookie,doc);
   htp.formClose;
   cw_doctor_util.directory_table(cookie,doc);

   htp.p('</CENTER>');
   cw_util.pageClose;
end;
-----------------------------------------------------------------------------
procedure modify_cmd(cookie in varchar2) is
doc cw_doctor_table%rowtype;
per cw_person_table%rowtype;
begin
   me := 'cw_doctor_mgr.modify_cmd';
   cw_bridge.sync(me,cookie);

   doc := cw_bridge.get_doctor;
   if doc.id is null then 
	raise no_current_doctor;
   end if;
   per := cw_person.get(doc.person_id);

   htp.formOpen('cw_person.make');
   cw_util.editPageOpen(' CareWeb Pediatrician Manager: Modify ');
   htp.formHidden('cookie',cookie);
   htp.formHidden('handler','cw_doctor_mgr.modify_action');
   htp.p('<CENTER>');
   cw_person_util.modify_form(per);
   htp.p('</CENTER>');
   htp.formClose;
   cw_util.pageClose;
exception
   when no_current_doctor then
	cw_error.die(me,'No current doctor');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure modify_action(cookie in varchar2, r in cw_person_table%rowtype) is
new_per cw_person_table%rowtype;
old_per cw_person_table%rowtype;
doc cw_doctor_table%rowtype;
begin
   me := 'cw_doctor_mgr.modify_action';
   cw_bridge.sync(me,cookie);
 
   new_per := r;
   doc := cw_bridge.get_doctor;
   old_per := cw_person.get(doc.person_id);
   new_per.id := old_per.id;
   cw_person.put(new_per);
   cw_util.pageOpen('CareWeb Pediatrician: '||
	new_per.first_name||' '||new_per.middle_name||' '||new_per.last_name);
   htp.p('<CENTER>');
   cw_person_util.show_form(new_per);
   htp.formOpen('cw_doctor_mgr.consult_action?cookie='||cookie);
   cw_doctor_util.consult_form(cookie,doc);
   htp.formClose;
   cw_doctor_util.directory_table(cookie,doc);

   htp.p('</CENTER>');
   cw_util.pageClose;
end;
-----------------------------------------------------------------------------
procedure delete_cmd(cookie in varchar2) is
doc cw_doctor_table%rowtype;
per cw_person_table%rowtype;
begin
   me := 'cw_doctor_mgr.delete_cmd';
   cw_bridge.sync(me,cookie);

   doc := cw_bridge.get_doctor;
   if doc.id is null then 
	raise no_current_doctor;
   end if;
   per := cw_person.get(doc.person_id);

   cw_util.pageOpen('CareWeb Pediatrician: '||
        per.first_name||' '||per.middle_name||' '||per.last_name);
   htp.p('<CENTER>');
   cw_person_util.show_form(per);
   cw_doctor_util.directory_table(cookie,doc);
   htp.para;
   htp.p('<font size=7 color="firebrick">DELETED</a>');
   htp.p('</CENTER>');

   cw_person.rm(per.id);
   cw_doctor.rm(doc.id);
   cw_bridge.unset_doctor;
   
exception
   when no_current_doctor then
	cw_error.die(me,'No current doctor');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure save_cmd(cookie in varchar2) is
begin
   me := 'cw_doctor_mgr.save_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure load_cmd(cookie in varchar2) is
begin
   me := 'cw_doctor_mgr.load_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure help_cmd(cookie in varchar2) is
begin
   me := 'cw_doctor_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Pediatrician Manager: Help','crimson','ivory',7);

   htp.tableOpen(cattributes=>'border=5');

   htp.tableRowOpen;
	htp.tableHeader('Command','center');
	htp.tableHeader('Description','center');
	htp.tableheader('Access','center');
	htp.tableHeader('Status','center');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Out');
	htp.tableData('Exit the current space and move one step up');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Home');
	htp.tableData('Home Page for the CareWeb Pediatrician Manager');
	htp.tableData('DBA');
	htp.tableData('Now the same as [All]. Soon to include description '||
		'of the overall organization of the CareWeb database');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('All');
	htp.tableData('List all tables in CareWeb database '||
		'with hyperlinks to individual table spaces');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Select');
	htp.tableData('List all tables with the multiple choice '||
		'selection support');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Filter');
	htp.tableData('Restrict the list of analyzed records in terms '||
		'of a user-provided filter or query');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Create');
	htp.tableData('Create new record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Modify');
	htp.tableData('Modify current record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Delete');
	htp.tableData('Delete current selection (record or group).');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Save');
	htp.tableData('Save/dump the current selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Load');
	htp.tableData('Fetch the previously daved/dumped selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Help');
	htp.tableData('This page - includes short description of all commands');
	htp.tableData('DBA');
	htp.tabledata('Implemented');
   htp.tableRowClose;
   htp.tableClose;

   cw_util.pageClose;
exception

   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure err_notimpl(cookie in varchar2) is
begin
   me := 'cw_doctor_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Pediatrician Manager: ERROR','ivory','crimson',7);
   htp.p('<font size=5 color="ivory">');
   htp.para;
   htp.p('Command ['||curr_cmd||'] is not yet implemented for this space. '||
	'Click [Help] to get '||
	' the functionality, access rights and the implementation status '||
	' Not of the individual Pediatrician Manager commands.'); 
  exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure consult_action(cookie in varchar2, consult in varchar2) is
begin

   if consult = ' Video ' then
	cw_util.iconPageOpen('CareWeb Interactive Consulting: ',
	   'Video Channel',
	   'http://www.npac.syr.edu/users/sangeeta/media_url/video.gif');
	htp.para;
	htp.ulistOpen;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/roman',
	   '<font size=5>Start Video Tool of the VIC/VAC 
	    Teleconferencing</font>'));
	htp.para;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/roman',
	   '<font size=5>Help</font>'));
	htp.ulistClose;
   elsif consult = ' Audio ' then
	cw_util.iconPageOpen('CareWeb Interactive Consulting: ',
	   'Audio Channel',
	   'http://www.npac.syr.edu/users/sangeeta/media_url/audio.gif');
	htp.para;
	htp.ulistOpen;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/roman',
	   '<font size=5>Start Audio Tool of the VIC/VAC 
	    Teleconferencing</font>'));
	htp.para;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/roman',
	   '<font size=5>Help</font>'));
	htp.ulistClose;
   elsif consult = ' White Board ' then
	cw_util.iconPageOpen('CareWeb Interactive Consulting: ',
	   'White Board Channel',
	   'http://www.npac.syr.edu/users/sangeeta/media_url/whiteboard.gif');
	htp.para;
	htp.ulistOpen;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/roman',
	   '<font size=5>Start Whiteboard Tool of the VIC/VAC 
	    Teleconferencing</font>'));
	htp.para;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/roman',
	   '<font size=5>Help</font>'));
	htp.ulistClose;
   elsif consult = ' Web Chat ' then
	cw_util.iconPageOpen('CareWeb Interactive Consulting: ',
	   'White Board Channel',
	   'http://www.npac.syr.edu/users/sangeeta/media_url/chat.gif');
	htp.para;
	htp.ulistOpen;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/roman',
	   '<font size=5>Start WebChat/WebCast Tool</font>'));
	htp.para;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/roman',
	   '<font size=5>Help</font>'));
	htp.ulistClose;
   end if;
end;
-----------------------------------------------------------------------------
end;
/
show errors
