--------------------------------------------------------------------
create or replace package cw_error is
--------------------------------------------------------------------
procedure panic(imsg in varchar2, ierrmsg in varchar2);
procedure msg(imsg in varchar2);
procedure die(txt in varchar2,errmsg in varchar2);
end;
/
show errors
---------------------------------------------------------------------
create or replace package body cw_error is
---------------------------------------------------------------------
procedure panic(imsg in varchar2, ierrmsg in varchar2) is
begin
   htp.hr;
   htp.header(1,'FATAL ERROR');
   htp.strong('CareWeb Database detected an unexpected fatal error. ');
   htp.strong('Please press [Logout] button in the navigation bar ');
   htp.strong('to logout, then press [Home] home button and connect ');
   htp.strong('to CareWeb again. Thank you!');
   htp.header(2,'Error Stack: ');
   htp.preOpen;
   htp.p(imsg);
   htp.p(ierrmsg);
   htp.preClose;
   htp.hr;
end;
---------------------------------------------------------------------
procedure msg(imsg in varchar2) is
begin
   htp.p('<font size=6>');
   htp.bold('ERROR: '||imsg);
   htp.p('</font>');
   htp.nl;
end;
---------------------------------------------------------------------
procedure die(txt in varchar2,errmsg in varchar2) is
begin
   msg('Lost control in module = '||htf.bold(txt)||'. Processing halted.');
   htp.code(errmsg);
   htp.hr;
   htp.anchor('cw_bridge.conn', htf.header(1,'Please restart'));
end;
----------------------------------------------------------------------
end;
/
show errors
