-----------------------------------------------------------------------------
create or replace package cw_immun_mgr is
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number);
procedure bar_page(cookie in varchar2);
procedure bar_action(cookie in varchar2, cmd in varchar2);

procedure out_cmd(cookie in varchar2);
procedure home_cmd(cookie in varchar2);
procedure all_cmd(cookie in varchar2);
procedure select_cmd(cookie in varchar2);
procedure filter_cmd(cookie in varchar2);
procedure create_cmd(cookie in varchar2);
-- procedure create_action(cookie in varchar2, r in cw_immun_table%rowtype);
procedure modify_cmd(cookie in varchar2);
procedure modify_action(cookie in varchar2, r in cw_immun_table%rowtype);
procedure delete_cmd(cookie in varchar2);
procedure save_cmd(cookie in varchar2);
procedure load_cmd(cookie in varchar2);
procedure help_cmd(cookie in varchar2);

procedure err_notimpl(cookie in varchar2);

invalid_command exception;

end;
/
show errors
-----------------------------------------------------------------------------
create or replace package body cw_immun_mgr is
-----------------------------------------------------------------------------
me varchar2(64);
this cw_immun_table%rowtype;
url varchar2(64) := cw_util.getURL;
curr_cmd varchar2(32);
lst cw_state_table%type;

stu cw_student_table%rowtype;
per cw_person_table%rowtype;
icon_url varchar2(128);
icon_action varchar2(128);
per_photo varchar2(128);
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number) is
begin
   me := 'cw_immun_mgr.show_cmd';
--   this.id := iid;
   lst := cw_state.get(cookie);
   lst.immun_id := iid;
   cw_state.put(lst);
--   cw_bridge.set_immun(this);
   cw_bridge.sync(me,cookie);
   this := cw_bridge.get_immun;
   cw_util.pageOpen('Immunization Record'); 
   cw_immun_util.search_page(cookie, this);
   cw_util.pageClose;  
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_page(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.bar_page';
  -- url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('cmd');
   cw_util.docWrite('cmd',
	'<html><body bgcolor="darkgreen"><font size=5 color="ivory"><center>');
   cw_util.docWrite('cmd',
	'<form action= "'||url||'cw_immun_mgr.bar_action" target="view">');
   cw_util.docWrite('cmd',
	'<input type="hidden" name="cookie" value="'||cookie||'">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Out">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Home">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="All">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Select">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Filter">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Create">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Modify">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Delete">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Save">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Load">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Help">');
    cw_util.docWrite('cmd',
	'</form></center></font></body></html>');
   cw_util.docClose('cmd');
   cw_util.jsClose;
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_action(cookie in varchar2, cmd in varchar2) is
begin
   me := 'cw_immun_mgr.bar_action';
   cw_bridge.sync(me, cookie);

   curr_cmd := cmd;

   if cmd = 'Out' then
	out_cmd(cookie);
   elsif cmd = 'Home' then
	home_cmd(cookie);
   elsif cmd = 'All' then
	all_cmd(cookie);
   elsif cmd = 'Select' then
	select_cmd(cookie);
   elsif cmd = 'Filter' then
	filter_cmd(cookie);
   elsif cmd = 'Create' then
	create_cmd(cookie);
   elsif cmd = 'Modify' then
	modify_cmd(cookie);
   elsif cmd = 'Delete' then
	delete_cmd(cookie);
   elsif cmd = 'Save' then
	save_cmd(cookie);
   elsif cmd = 'Load' then
	load_cmd(cookie);
   elsif cmd = 'Help' then
	help_cmd(cookie);
   else 
	raise invalid_command;
   end if;
exception
   when invalid_command then
	cw_error.panic(me,'Invalid command = '||cmd||'.');
   when others then
	cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure out_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.out_cmd';
   cw_bridge.sync(me, cookie);
   cw_table_mgr.home_cmd(cookie);
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure home_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.home_cmd';
   cw_bridge.sync(me,cookie);

   stu := cw_bridge.get_student;
   if stu.id is null then
	icon_url := 
	'http://www.npac.syr.edu/users/sangeeta/media_url/database.gif';
   	icon_action := 'cw_table_mgr.home_cmd';
	cw_table_mgr.all_list(cookie);
  else
	per := cw_person.get(stu.person_id);
	if per.media_url is null then
	icon_url := 
	'/careweb/images/shrideep.jpg'; 
	else
	per_photo := per.media_url||'/photo.gif';
	icon_url := 
	'http://www.npac.syr.edu/users/sangeeta/media_url/'||per_photo;
	end if;
	icon_action := 'cw_student_mgr.show_cmd';
	cw_student_mgr.dir_list(cookie);	
   end if;	
   cw_util.cntl_putimg(cookie,icon_url,icon_action);       

   bar_page(cookie);
   all_cmd(cookie);
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_cmd(cookie in varchar2) is
cnt number(6);
ncol number(2) := 2;
i number(2);
id number;
begin
   me := 'cw_immun_mgr.all_cmd';
   cw_bridge.sync(me,cookie);
   cw_bridge.unset_immun;
--   cw_util.pageOpen('CareWeb Immunization Manager: All Immunizations');
   cw_util.iconPageOpen('CareWeb Immunization Manager: ',
	'All Records',
--	'http://www.npac.syr.edu/users/sangeeta/media_url/base_care.gif');
	'http://www.npac.syr.edu/users/sangeeta/media_url/immun.gif');
   htp.p('<center>');
   htp.tableOpen(cattributes=>'border=5');
   htp.tableRowOpen;
   for j in 1..ncol loop
   htp.tableHeader('Student');
   htp.tableHeader('Type');
   htp.tableHeader('Date');
--   htp.tableHeader('');
   if j < ncol then
	htp.tableHeader('   ');
   end if;
   end loop;
   htp.tableRowClose;
   htp.tableRowOpen;
   i := 1; 
   while(cw_immun.next(this)) loop
	if i = 1 then
		htp.tableRowOpen;
	end if;
	htp.tableData(htf.anchor('cw_immun_mgr.show_cmd?cookie='
		||cookie||chr(ascii('&'))||'iid='||this.id, this.id));
	htp.tableData(this.name);
	htp.tableData(this.day);
--	htp.tableData(this.student_id);
	if i < ncol then
		htp.tableData('');
		i := i + 1;
	else
		htp.tableRowOpen;
		i := 1;
	end if;
   end loop;
   htp.tableClose;
   htp.p('</center>');
exception
   when others then
     cw_error.panic(me||': ', sqlerrm);
end;
-----------------------------------------------------------------------------
procedure select_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.select_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure filter_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.filter_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.create_cmd';
   cw_bridge.sync(me,cookie);
   cw_immun_util.insert_page(cookie);
--   htp.formOpen('cw_immun.make');
--   cw_util.editPageOpen(' CareWeb Immunization Manager: Create ');
--   htp.formHidden('cookie',cookie);
--   htp.formHidden('handler','cw_immun_mgr.create_action');
--   htp.p('<CENTER>');
--   htp.p('</CENTER>');
--   htp.formClose;
--   cw_util.pageClose;
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
/*-----------------------------------------------------------------------------
procedure create_action(cookie in varchar2, r in cw_immun_table%rowtype) is
this cw_immun_table%rowtype;
begin
   me := 'cw_immun_mgr.create_cmd';
   cw_bridge.sync(me,cookie);
   this := r;
   p.id := null;
   cw_immun.put(p);
   cw_util.pageOpen('CareWeb Immunization Manager: '||
	p.first_name||' '||p.middle_name||' '||p.last_name);
   htp.p('<CENTER>');
   cw_immun_util.show_form(p);
   htp.p('</CENTER>');
   cw_util.pageClose;
end;
*/
-----------------------------------------------------------------------------
procedure modify_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.modify_cmd';
   cw_bridge.sync(me,cookie);
   this := cw_bridge.get_immun;
   cw_immun_util.update_page(cookie, this.id);
--   err_notimpl(cookie);
exception
   when others then
   cw_error.panic(me, sqlerrm);
end;
-----------------------------------------------------------------------------
procedure modify_action(cookie in varchar2, r in cw_immun_table%rowtype) is
begin
	null;
end;
-----------------------------------------------------------------------------
procedure delete_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.delete_cmd';
   cw_bridge.sync(me,cookie);
   this := cw_bridge.get_immun;
   cw_immun_util.delete_page(cookie, this.id);
--   err_notimpl(cookie);
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure save_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.save_cmd';
   cw_bridge.sync(me,cookie);
   me := 'cw_immun_mgr.save_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure load_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.load_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure help_cmd(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.help_cmd';
   cw_bridge.sync(me,cookie);
   cw_util.pageOpen('CareWeb Immunization Manager: Help','crimson','ivory',7);

   htp.tableOpen(cattributes=>'border=5');

   htp.tableRowOpen;
	htp.tableHeader('Command','center');
	htp.tableHeader('Description','center');
	htp.tableheader('Access','center');
	htp.tableHeader('Status','center');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Out');
	htp.tableData('Exit the current space and move one stethis up');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Home');
	htp.tableData('Home Page for the CareWeb Immunization Manager');
	htp.tableData('DBA');
	htp.tableData('Now the same as [All]. Soon to include description '||
		'of the overall organization of the CareWeb database');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('All');
	htp.tableData('List all tables in CareWeb database '||
		'with hyperlinks to individual table spaces');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Select');
	htp.tableData('List all tables with the multiple choice '||
		'selection support');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Filter');
	htp.tableData('Restrict the list of analyzed records in terms '||
		'of a user-provided filter or query');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Create');
	htp.tableData('Create new record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Modify');
	htp.tableData('Modify current record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Delete');
	htp.tableData('Delete current selection (record or group).');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Save');
	htp.tableData('Save/dump the current selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Load');
	htp.tableData('Fetch the previously daved/dumped selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Help');
	htp.tableData('This page - includes short description of all commands');
	htp.tableData('DBA');
	htp.tabledata('Implemented');
   htp.tableRowClose;
   htp.tableClose;

   cw_util.pageClose;
exception

   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure err_notimpl(cookie in varchar2) is
begin
   me := 'cw_immun_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Immunization Manager: ERROR','ivory','crimson',7);
   htp.p('<font size=5 color="ivory">');
   htp.para;
   htp.p('Command ['||curr_cmd||'] is not yet implemented for this space. '||
	'Click [Help] to get '||
	' the functionality, access rights and the implementation status '||
	' Not of the individual Immunization Manager commands.'); 
  exception
   when others then
   cw_error.panic(me,sqlerrm);
end;
-----------------------------------------------------------------------------
end;
/
show errors
