drop package cw_immun_util;

----------------------------------------------------  
create or replace package cw_immun_util is  
----------------------------------------------------  
procedure insert_page(cookie in varchar2);  
procedure update_page(cookie in varchar2, iid in number);  
procedure delete_page(cookie in varchar2, iid in number);  
procedure search_page(cookie in varchar2, irow in cw_immun_table%type);  
procedure action_echo(cookie in varchar2, irow in cw_immun_table%type, iaction in varchar2);  
end;  
/
show errors;
-- /

---------------------------------------------------------  
create or replace package body cw_immun_util is  
---------------------------------------------------------  
  me varchar2(64);
  this cw_immun_table%type;
  id_null exception;
--
---------------------------------------------------------  
procedure insert_page(cookie in varchar2) is  
---------------------------------------------------------  
   today date;
begin  
   me := 'cw_immun_util.insert_page';
   cw_bridge.sync(me,cookie);
   cw_bridge.unset_immun;
   htp.formOpen('/cgi-bin/wow/cw_immun.insert_action', 'POST');
   cw_util_jguo.editpageOpen('Insert Immunization Record', 'Reset', 'Create'); 
   htp.headOpen;
   htp.headClose;
   htp.bodyOpen;
   today := sysdate;
   htp.br;
   htp.tableOpen(1,'top','NOWRAP','','');
   htp.formHidden('cookie', cookie);
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Immunization Type', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Immunization No.', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Immunization Date', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.p('<td>');
   htp.formSelectOpen('iname', '', 1, 'onChange=""');
   htp.formSelectOption('----', 1, 'value = "----"');
   htp.formSelectOption('DPT', 1, 'value = "DPT"');
   htp.formSelectOption('DTaP', 1, 'value = "DTaP"');
   htp.formSelectOption('dT', 1, 'value = "dT"');
   htp.formSelectOption('OPV', 1, 'value = "OPV"');
   htp.formSelectOption('IPV', 1, 'value = "IPV"');
   htp.formSelectOption('HIB', 1, 'value = "HIB"');
   htp.formSelectOption('HBV', 1, 'value = "HBV"');
   htp.formSelectOption('MMR', 1, 'value = "MMR"');
   htp.formSelectOption('Varicella', 1, 'value = "Varicella"');
   htp.formSelectOption('Pneumococcal', 1, 'value = "Pneumococcal"');
   htp.formSelectOption('Influenza', 1, 'value = "Influenza"');
   htp.formSelectOption('PPD', 1, 'value = "PPD"');
   htp.formSelectClose;
   htp.p('</td>');
   htp.p('<td>');
   htp.formSelectOpen('igiven_num', '', 1, 'onChange=""');
   htp.formSelectOption('--', 1, 'value = "--"');
   for i in 1..5 loop
     htp.formSelectOption(i, '', 'value='||i);
   end loop;
   htp.formSelectClose;
   htp.p('</td>');
   htp.p('<td>');
   cw_util_jguo.select_date('iday', today, '1980', '2010');
   htp.p('</td>');
   htp.tableRowClose;
   htp.tableClose;
--   htp.formSubmit(null, 'Insert', null); 
--   htp.formReset('Reset', null); 
   htp.formClose;
   cw_util_jguo.pageClose;  
   exception
     when others then
       cw_error.panic(me||': ', sqlerrm);
end;  

---------------------------------------------------------  
procedure update_page(cookie in varchar2, iid in number) is  
---------------------------------------------------------  
begin  
   me := 'cw_immun_util.update_page';
   cw_bridge.sync(me, cookie);
   htp.formOpen('/cgi-bin/wow/cw_immun.update_action', 'POST');
   cw_util_jguo.editpageOpen('Update Immunization Record', 'Reset', 'Modify'); 
   htp.headOpen;
   htp.headClose;
   htp.bodyOpen;
   select * into this from cw_immun_table 
     where id = iid;
   htp.tableOpen(1,'top','NOWRAP','','');
   htp.formHidden('cookie', cookie);
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Immunization Name', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Immunization No.', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Immunization Date', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.p('<td>');
   htp.formSelectOpen('iname', '', 1, 'onChange=""');
   htp.formSelectOption('DPT', cw_util_jguo.equalto('DPT',this.name), 'value = DPT');
   htp.formSelectOption('DTaP', cw_util_jguo.equalto('DTaP',this.name), 'value = DTaP');
   htp.formSelectOption('dT', cw_util_jguo.equalto('dT',this.name), 'value = dT');
   htp.formSelectOption('OPV', cw_util_jguo.equalto('OPV',this.name), 'value = OPV');
   htp.formSelectOption('IPV', cw_util_jguo.equalto('IPV',this.name), 'value = IPV');
   htp.formSelectOption('HIB', cw_util_jguo.equalto('HIB',this.name), 'value = HIB');
   htp.formSelectOption('HBV', cw_util_jguo.equalto('HBV',this.name), 'value = null');
   htp.formSelectOption('MMR', cw_util_jguo.equalto('MMR',this.name), 'value = null');
   htp.formSelectOption('Varicella', cw_util_jguo.equalto('Varicella',this.name), 'value = null');
   htp.formSelectOption('Pneumococcal', cw_util_jguo.equalto('Pneumococcal',this.name), 'value = null');
   htp.formSelectOption('Influenza', cw_util_jguo.equalto('Influenza',this.name), 'value = null');
   htp.formSelectOption('PPD', cw_util_jguo.equalto('PPD',this.name), 'value = null');
   htp.formSelectClose;
   htp.p('</td>');
   htp.p('<td>');
   htp.formSelectOpen('igiven_num', '', 1, 'onChange=""');
   for i in 1..5 loop
     htp.formSelectOption(i, cw_util_jguo.equalto(to_char(i),to_char(this.given_num)), 'value='||i);
   end loop;
   htp.formSelectClose;
   htp.p('</td>');
   htp.p('<td>');
   cw_util_jguo.select_date('iday', this.day, '1980', '2010');
   htp.p('</td>');
   htp.tableRowClose;
   htp.tableClose;
--   htp.formSubmit('Update', 'Update', null); 
--   htp.formReset('Reset', null); 
   htp.formClose;
   cw_util_jguo.pageClose;  
   exception
     when others then
       cw_error.panic(me||': ', sqlerrm);
end;  

---------------------------------------------------------  
procedure delete_page(cookie in varchar2, iid in number) is   
---------------------------------------------------------  
begin  
   me := 'cw_immun_util.update_page';
   cw_bridge.sync(me, cookie);
   this := cw_immun.get(iid);
   htp.formOpen('/cgi-bin/wow/cw_immun.delete_action', 'POST');
   cw_util_jguo.pageOpen('Are you sure to delete this record?'
     ||htf.formSubmit(null, 'Delete')); 
   htp.headOpen;
   htp.headClose;
   htp.bodyOpen;
   htp.formHidden('cookie', cookie);
   htp.formHidden('iid', iid);
   cw_immun_util.search_page(cookie, this);
   htp.formClose;
   cw_util_jguo.pageClose;  

end;  

---------------------------------------------------------  
procedure search_page(cookie in varchar2, irow in cw_immun_table%type) is 
---------------------------------------------------------  
begin  
   me := 'cw_immun_util.insert_page';
   cw_bridge.sync(me, cookie);
   htp.tableOpen(1,'top','NOWRAP','','');
   htp.tableOpen(1,'top','NOWRAP','','');
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('ID', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Student ID', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Type', 'center', '',  '', 1, 1, '');
   htp.tableHeader('No.', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Date', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Nurse ID', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableData(irow.id);
   htp.tableData(irow.student_id);
   htp.tableData(irow.name);
   htp.tableData(irow.given_num);
   htp.tableData(irow.day);
   htp.tableData(irow.nurse_id);
   htp.tableRowClose;
   htp.tableClose;
   exception
     when others then
       cw_error.panic(me||': ', sqlerrm);
end;  

---------------------------------------------------------  
procedure action_echo(cookie in varchar2, irow in cw_immun_table%type, iaction in varchar2) is  
---------------------------------------------------------  
begin  
   me := 'cw_immun_util.action_echo';
   cw_bridge.sync(me, cookie);
   cw_util_jguo.pageOpen('The following immunization has been '||iaction); 
   htp.headOpen;
   htp.headClose;
   htp.bodyOpen;
   htp.formOpen('/cgi-bin/wow/cw_immun_util.action', 'POST');
   cw_immun_util.search_page(cookie, irow);
   htp.formClose;
   cw_util_jguo.pageClose;  
   exception
     when others then
       cw_error.panic(me|| ': ', sqlerrm);
end;  


---------------------------------------------------------  
-- begin
--	this.id := 0;
-- end;
---------------------------------------------------------  

---------------------------------------------------------  
end;  
---------------------------------------------------------  

/
show errors;
-- /

