drop package cw_medicat_util;

----------------------------------------------------  
create or replace package cw_medicat_util is  
----------------------------------------------------  
procedure insert_page(cookie in varchar2);  
procedure update_page(cookie in varchar2, iid in number);  
procedure delete_page(cookie in varchar2, iid in number);  
procedure search_page(cookie in varchar2, irow in cw_medicat_table%type);  
procedure action_echo(cookie in varchar2, irow in cw_medicat_table%type, iaction in varchar2);  
end;  
/
show errors;
-- /

---------------------------------------------------------  
create or replace package body cw_medicat_util is  
---------------------------------------------------------  
  me varchar2(64);
  this cw_medicat_table%type;
  id_null exception;
--
---------------------------------------------------------  
procedure insert_page(cookie in varchar2) is  
---------------------------------------------------------  
   today date;
begin  
   me := 'cw_medicat_util.insert_page';
   cw_bridge.sync(me, cookie);
   cw_bridge.unset_medicat;
   htp.formOpen('/owa_careweb/owa/cw_medicat.insert_action', 'POST');
   cw_util_jguo.editpageOpen('Insert Medication Record', 'Reset', 'Create'); 
   today := sysdate;
   htp.tableOpen('BORDER','top','NOWRAP','','');
   htp.formHidden('cookie', cookie);
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Medication Name', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Medication Reason', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Medication Dosage', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableData(htf.formText('iname', 10, null));
   htp.tableData(htf.formText('ireason', 10, null));
   htp.tableData(htf.formText('idosage', 10, null));
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Medication Date', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Doctor Order', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Parent Permission', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.p('<td>');
   cw_util_jguo.select_date('iday', today, '1980', '2010');
   htp.p('</td>');
   htp.tableData(htf.formText('idoctor_order', 10, null));
   htp.tableData(htf.formText('iparent_permission', 10, null));
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Doctor Signature', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Signature Date', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Nurse Title', 'center', '',  '', 1, 1, '');
  htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableData(htf.formText('isignature', 10, null));
   htp.p('<td>');
   cw_util_jguo.select_date('isignature_day', today, '1980', '2010');
   htp.p('</td>');
   htp.tableData(htf.formText('ititle', 10, null));
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Nurse Initial', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableData(htf.formText('idoctor_initial', 10, null));
   htp.tableRowClose;
   htp.tableClose;
--   htp.formSubmit(null, 'Insert', null); 
--   htp.formReset('Reset', null); 
   htp.formClose;
   cw_util_jguo.pageClose;  
   exception
     when others then
       cw_error.panic(me||': ', sqlerrm);
end;  

---------------------------------------------------------  
procedure update_page(cookie in varchar2, iid in number) is  
---------------------------------------------------------  
begin  
   me := 'cw_medicat_util.update_page';
   cw_bridge.sync(me, cookie);
   htp.formOpen('/owa_careweb/owa/cw_medicat.update_action', 'POST');
   cw_util_jguo.editpageOpen('Update Medication Record', 'Reset', 'Modify'); 
   select * into this from cw_medicat_table 
     where id = iid;
   htp.tableOpen('BORDER','top','NOWRAP','','');
   htp.formHidden('cookie', cookie);
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Medication Name', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableData(htf.formText('iname', 10, 10, this.name));
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Medication Reason', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Medication Dosage', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Medication Date', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableData(htf.formText('ireason', 10, 10, this.reason));
   htp.tableData(htf.formText('idosage', 10, 10, this.dosage));
   htp.p('<td>');
   cw_util_jguo.select_date('iday', this.day, '1980', '2010');
   htp.p('</td>');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Parent Permission', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Doctor Order', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Doctor Signature', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableData(htf.formText('idoctor_order', 10, 10, this.doctor_order));
   htp.tableData(htf.formText('iparent_permission', 10, 10, this.parent_permission));
   htp.tableData(htf.formText('isignature', 10, 10, this.signature));
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Signature Date', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Title', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Initial', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.p('<td>');
   cw_util_jguo.select_date('isignature_day', this.signature_day, '1980', '2010');
   htp.p('</td>');
   htp.tableData(htf.formText('idoctor_initial', 10, 10, this.doctor_initial));
   htp.tableData(htf.formText('ititle', 10, 10, this.title));
   htp.tableRowClose;
   htp.tableRowClose;
   htp.tableClose;
   htp.formClose;
   cw_util_jguo.pageClose;  
end;  

---------------------------------------------------------  
procedure delete_page(cookie in varchar2, iid in number) is   
---------------------------------------------------------  
begin  
   me := 'cw_medicat_util.update_page';
   cw_bridge.sync(me, cookie);
   this := cw_medicat.get(iid);
   htp.formOpen('/owa_careweb/owa/cw_medicat.delete_action', 'POST');
   cw_util_jguo.pageOpen('Are you sure to delete this record?'
     ||htf.formSubmit(null, 'Delete')); 
   htp.formHidden('cookie', cookie);
   htp.formHidden('iid', iid);
   cw_medicat_util.search_page(cookie, this);
   htp.formClose;
   cw_util_jguo.pageClose;  

end;  

---------------------------------------------------------  
procedure search_page(cookie in varchar2, irow in cw_medicat_table%type) is 
---------------------------------------------------------  
begin  
   me := 'cw_medicat_util.insert_page';
   cw_bridge.sync(me, cookie);
   htp.tableOpen('BORDER','top','NOWRAP','','');
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('ID', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Student ID', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Type', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Reason', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Dosage', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Medication Date', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableData(irow.id);
   htp.tableData(irow.student_id);
   htp.tableData(irow.name);
   htp.tableData(irow.reason);
   htp.tableData(irow.dosage);
   htp.tableData(irow.day);
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableHeader('Doctor Order', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Parent Permission', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Doctor Signature', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Signature Date', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Title', 'center', '',  '', 1, 1, '');
   htp.tableHeader('Initial', 'center', '',  '', 1, 1, '');
   htp.tableRowClose;
   htp.tableRowOpen('center','center','','NOWRAP','');
   htp.tableData(irow.doctor_order);
   htp.tableData(irow.parent_permission);
   htp.tableData(irow.signature);
   htp.tableData(irow.signature_day);
   htp.tableData(irow.title);
   htp.tableData(irow.doctor_initial);
   htp.tableRowClose;
  htp.tableClose;
   htp.formClose;
--   cw_util_jguo.pageClose;  
   exception
     when others then
       cw_error.panic(me||': ', sqlerrm);
end;  

---------------------------------------------------------  
procedure action_echo(cookie in varchar2, irow in cw_medicat_table%type, iaction in varchar2) is  
---------------------------------------------------------  
begin  
   me := 'cw_medicat_util.action_echo';
   cw_bridge.sync(me, cookie);
   cw_util_jguo.pageOpen('The following medication has been '||iaction); 
   htp.headOpen;
   htp.headClose;
   htp.bodyOpen;
   cw_medicat_util.search_page(cookie, irow);
   cw_util_jguo.pageClose;  
   exception
     when others then
       cw_error.panic(me|| ': ', sqlerrm);
end;  


---------------------------------------------------------  
-- begin
--	this.id := 0;
-- end;
---------------------------------------------------------  

---------------------------------------------------------  
end;  
---------------------------------------------------------  

/
show errors;
-- /

