-----------------------------------------------------------------------------
create or replace package cw_school_mgr is
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number);
procedure bar_page(cookie in varchar2);
procedure bar_action(cookie in varchar2, cmd in varchar2);

procedure out_cmd(cookie in varchar2);
procedure home_cmd(cookie in varchar2);
procedure all_cmd(cookie in varchar2);
procedure all_list(cookie in varchar2);
procedure dir_list(cookie in varchar2);
procedure select_cmd(cookie in varchar2);
procedure filter_cmd(cookie in varchar2);
procedure create_cmd(cookie in varchar2);
procedure create_action(cookie in varchar2, r in cw_school_table%rowtype);
procedure modify_cmd(cookie in varchar2);
procedure modify_action(cookie in varchar2, r in cw_school_table%rowtype);
procedure delete_cmd(cookie in varchar2);
procedure save_cmd(cookie in varchar2);
procedure load_cmd(cookie in varchar2);
procedure help_cmd(cookie in varchar2);

procedure err_notimpl(cookie in varchar2);

invalid_command exception;
no_current_school exception;

end;
/
show errors
-----------------------------------------------------------------------------
create or replace package body cw_school_mgr is
-----------------------------------------------------------------------------
me varchar2(64);
url varchar2(64) := cw_util.getURL;
curr_cmd varchar2(32);
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number) is
s cw_school_table%rowtype;

begin
   me := 'cw_school_mgr.show_cmd';
   cw_bridge.sync(me,cookie);

   
   s := cw_school.get(iid);
   cw_bridge.set_school(s);
--   bar_page(cookie);
   cw_util.pageOpen('CareWeb School: '||
	s.name||' '||s.lev);
   bar_page(cookie);
   htp.p('<CENTER>');
   cw_util.cntl_putimg(cookie,
	'/careweb/images/scsd.gif','cw_school_mgr.home_cmd');

   all_list(cookie);

   cw_school_util.show_form(s);

   cw_school_util.directory_table(cookie,s);
   htp.p('</CENTER>');

   cw_util.pageClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_page(cookie in varchar2) is
begin
   me := 'cw_school_mgr.bar_page';
  -- url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('cmd');
   cw_util.docWrite('cmd',
	'<html><body bgcolor="darkgreen"><font size=5 color="ivory"><center>');
   cw_util.docWrite('cmd',
	'<form action= "'||url||'cw_school_mgr.bar_action" target="view">');
   cw_util.docWrite('cmd',
	'<input type="hidden" name="cookie" value="'||cookie||'">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Out">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Home">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="All">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Select">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Filter">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Create">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Modify">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Delete">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Save">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Load">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Help">');
    cw_util.docWrite('cmd',
	'</form></center></font></body></html>');
   cw_util.docClose('cmd');
   cw_util.jsClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_action(cookie in varchar2, cmd in varchar2) is
begin
   me := 'cw_school_mgr.bar_action';
   cw_bridge.sync(me,cookie);

   curr_cmd := cmd;

   if cmd = 'Out' then
	out_cmd(cookie);
   elsif cmd = 'Home' then
	home_cmd(cookie);
   elsif cmd = 'All' then
	all_cmd(cookie);
   elsif cmd = 'Select' then
	select_cmd(cookie);
   elsif cmd = 'Filter' then
	filter_cmd(cookie);
   elsif cmd = 'Create' then
	create_cmd(cookie);
   elsif cmd = 'Modify' then
	modify_cmd(cookie);
   elsif cmd = 'Delete' then
	delete_cmd(cookie);
   elsif cmd = 'Save' then
	save_cmd(cookie);
   elsif cmd = 'Load' then
	load_cmd(cookie);
   elsif cmd = 'Help' then
	help_cmd(cookie);
   else 
	raise invalid_command;
   end if;
exception
   when invalid_command then
	cw_error.die(me,'Invalid command = '||cmd||'.');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure out_cmd(cookie in varchar2) is
begin
   me := 'cw_school_mgr.out_cmd';
   cw_bridge.sync(me,cookie);

   cw_table_mgr.home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure home_cmd(cookie in varchar2) is
begin
   me := 'cw_school_mgr.home_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.cntl_putimg(cookie,
	'http://www.npac.syr.edu/users/sangeeta/media_url/database.gif',
	'cw_table_mgr.home_cmd');
   cw_table_mgr.all_list(cookie);
   bar_page(cookie);
   all_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_cmd(cookie in varchar2) is
cnt number(6);
ncol number(2) := 3;
i number(2);
r cw_school_table%rowtype;
id number;
begin
   me := 'cw_school_mgr.all_cmd';
   cw_bridge.sync(me,cookie);

--   cw_util.pageOpen('CareWeb School Manager: All Schools');
   cw_util.iconPageOpen('CareWeb School Manager: ',
	'All Schools in the Syracuse City School District',
	'http://www.npac.syr.edu/users/sangeeta/media_url/scsd.gif');
   htp.p('<center>');

   htp.tableOpen(cattributes=>'border=5');
   htp.tableRowOpen;
   for j in 1..ncol loop
   htp.tableHeader('Name');
   htp.tableHeader('Level');
   if j < ncol then
	htp.tableHeader(' ');
	htp.tableHeader(' ');
   end if;
   end loop;
   htp.tableRowClose;

   htp.tableRowOpen;
   i := 1; 
   while(cw_school.next(r)) loop
	if i = 1 then
		htp.tableRowOpen;
	end if;
	htp.tableData(htf.anchor('cw_school_mgr.show_cmd?cookie='
		||cookie||chr(ascii('&'))||'iid='||r.id,
		'<font size=4>'||r.name||'</font>'));
	htp.tableData('<font size=4>'||r.lev||'</font>');
	if i < ncol then
		htp.tableData(' ');
		htp.tableData(' ');
		i := i + 1;
	else
		htp.tableRowOpen;
		i := 1;
	end if;
   end loop;
   htp.tableClose;
	
   htp.p('</center>');
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_list(cookie in varchar2) is
sch cw_school_table%rowtype;
begin
  -- url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('list');
   cw_util.docWrite('list','<html><body bgcolor="cyan">');
   while(cw_school.next(sch)) loop
	cw_util.docWrite('list',
	'<a href="'||url||'cw_school_mgr.show_cmd?cookie='
	||cookie||chr(ascii('&'))||'iid='||sch.id||'" target="view">'||
	sch.name||'</a><br>');
   end loop;
   cw_util.docClose('list');
   cw_util.jsClose;
end;
------------------------------------------------------------------------------
procedure dir_list(cookie in varchar2) is
sch cw_school_table%rowtype;
begin
  --url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('list');
   cw_util.docWrite('list','<html><body bgcolor="cyan">');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_student_mgr.home_cmd?cookie='
	||cookie||'" target="view">Students</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_nurse_mgr.home_cmd?cookie='
	||cookie||'" target="view">Nurses</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_teacher_mgr.home_cmd?cookie='
	||cookie||'" target="view">Teachers</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_parent_mgr.home_cmd?cookie='
	||cookie||'" target="view">Parents</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_eduworld_mgr.home_cmd?cookie='
	||cookie||'" target="view">Health Education</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_stat_mgr.home_cmd?cookie='
	||cookie||'" target="view">Health Statistics</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_hservice_mgr.home_cmd?cookie='
	||cookie||'" target="view">Health Services</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_consult_mgr.home_cmd?cookie='
	||cookie||'" target="view">CareWeb Connection</a><br>');

   cw_util.docWrite('list','</body></html>');  
   cw_util.docClose('list');
   cw_util.jsClose;
end;
-----------------------------------------------------------------------------
procedure select_cmd(cookie in varchar2) is
begin
   me := 'cw_school_mgr.select_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure filter_cmd(cookie in varchar2) is
begin
   me := 'cw_school_mgr.filter_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_cmd(cookie in varchar2) is
begin
   me := 'cw_school_mgr.create_cmd';
   cw_bridge.sync(me,cookie);


   htp.formOpen('cw_school.make');
   cw_util.editPageOpen(' CareWeb School Manager: Create ');
   htp.formHidden('cookie',cookie);
   htp.formHidden('handler','cw_school_mgr.create_action');
   htp.p('<CENTER>');
   cw_school_util.create_form;
   htp.p('</CENTER>');
   htp.formClose;
   cw_util.pageClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_action(cookie in varchar2, r in cw_school_table%rowtype) is
p cw_school_table%rowtype;
begin
   me := 'cw_school_mgr.create_action';
   cw_bridge.sync(me,cookie);

   p := r;
   p.id := null;
   cw_school.put(p);
   cw_bridge.set_school(p);
   cw_util.pageOpen('CareWeb School Manager: '||
	p.name||' '||p.lev);
   htp.p('<CENTER>');
   cw_school_util.show_form(p);
   cw_school_util.directory_table(cookie,p);
   htp.p('</CENTER>');
   cw_util.pageClose;
end;
-----------------------------------------------------------------------------
procedure modify_cmd(cookie in varchar2) is
s cw_school_table%rowtype;
begin
   me := 'cw_school_mgr.modify_cmd';
   cw_bridge.sync(me,cookie);

   s := cw_bridge.get_school;
   if s.id is null then 
	raise no_current_school;
   end if;
   htp.formOpen('cw_school.make');
   cw_util.editPageOpen(' CareWeb School Manager: Modify ');
   htp.formHidden('cookie',cookie);
   htp.formHidden('handler','cw_school_mgr.modify_action');
   htp.p('<CENTER>');
   cw_school_util.modify_form(s);
   htp.p('</CENTER>');
   htp.formClose;
   cw_util.pageClose;
exception
   when no_current_school then
	cw_error.die(me,'No current school');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure modify_action(cookie in varchar2, r in cw_school_table%rowtype) is
ns cw_school_table%rowtype;
os cw_school_table%rowtype;
begin
   me := 'cw_school_mgr.modify_action';
   cw_bridge.sync(me,cookie);
   
   ns := r;
   os := cw_bridge.get_school;
   ns.id := os.id;
   cw_school.put(ns);
   cw_bridge.set_school(ns);
   cw_util.pageOpen('CareWeb School: '||
	ns.name||' '||ns.lev);
   htp.p('<CENTER>');
   cw_school_util.show_form(ns);
   cw_school_util.directory_table(cookie,ns);
   htp.p('</CENTER>');
   cw_util.pageClose;
end;
-----------------------------------------------------------------------------
procedure delete_cmd(cookie in varchar2) is
s cw_school_table%rowtype;
begin
   me := 'cw_school_mgr.delete_cmd';
   cw_bridge.sync(me,cookie);

   s := cw_bridge.get_school;
   if s.id is null then 
	raise no_current_school;
   end if;

   cw_util.pageOpen('CareWeb School Manager: '||
        s.name||' '||s.lev);
   htp.p('<CENTER>');
   cw_school_util.show_form(s);
   cw_school_util.directory_table(cookie,s);
   htp.para;
   htp.p('<font size=7 color="firebrick">DELETED</a>');
   htp.p('</CENTER>');

   cw_school.rm(s.id);
   cw_bridge.unset_school;
   
exception
   when no_current_school then
	cw_error.die(me,'No current school');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure delete_fast_cmd(cookie in varchar2) is
p cw_school_table%rowtype;
begin
   me := 'cw_school_mgr.delete_cmd';
   cw_bridge.sync(me,cookie);

   p := cw_bridge.get_school;
   if p.id is null then 
	raise no_current_school;
   end if;

   cw_school.rm(p.id);
   cw_bridge.unset_school;
   home_cmd(cookie);
   
exception
   when no_current_school then
	cw_error.die(me,'No current school');
   when others then
	cw_error.die(me,'No current school');
end;
-----------------------------------------------------------------------------
procedure save_cmd(cookie in varchar2) is
begin
   me := 'cw_school_mgr.save_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure load_cmd(cookie in varchar2) is
begin
   me := 'cw_school_mgr.load_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure help_cmd(cookie in varchar2) is
begin
   me := 'cw_school_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb School Manager: Help','crimson','ivory',7);

   htp.tableOpen(cattributes=>'border=5');

   htp.tableRowOpen;
	htp.tableHeader('Command','center');
	htp.tableHeader('Description','center');
	htp.tableheader('Access','center');
	htp.tableHeader('Status','center');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Out');
	htp.tableData('Exit the current space and move one step up');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Home');
	htp.tableData('Home Page for the CareWeb Person Manager');
	htp.tableData('DBA');
	htp.tableData('Now the same as [All]. Soon to include description '||
		'of the overall organization of the CareWeb database');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('All');
	htp.tableData('List all tables in CareWeb database '||
		'with hyperlinks to individual table spaces');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Select');
	htp.tableData('List all tables with the multiple choice '||
		'selection support');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Filter');
	htp.tableData('Restrict the list of analyzed records in terms '||
		'of a user-provided filter or query');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Create');
	htp.tableData('Create new record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Modify');
	htp.tableData('Modify current record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Delete');
	htp.tableData('Delete current selection (record or group).');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Save');
	htp.tableData('Save/dump the current selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Load');
	htp.tableData('Fetch the previously daved/dumped selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Help');
	htp.tableData('This page - includes short description of all commands');
	htp.tableData('DBA');
	htp.tabledata('Implemented');
   htp.tableRowClose;
   htp.tableClose;

   cw_util.pageClose;
exception

   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure err_notimpl(cookie in varchar2) is
begin
   me := 'cw_school_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Person Manager: ERROR','ivory','crimson',7);
   htp.p('<font size=5 color="ivory">');
   htp.para;
   htp.p('Command ['||curr_cmd||'] is not yet implemented for this space. '||
	'Click [Help] to get '||
	' the functionality, access rights and the implementation status '||
	' Not of the individual Person Manager commands.'); 
  exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
end;
/
show errors
