-------------------------------------------------------
-- currently active connections with the state info
-------------------------------------------------------

drop sequence cw_state_seq;
drop table cw_state_table;

create table cw_state_table (
--------------------------------General information
id              number(9)       primary key,
timestamp       date,           -- creation time
cust_id         number(6),      -- customer (foreign) key
counter         number(3),      -- number of pages visited?
module          varchar2(64),   -- current PL/SQL procedure
------------------------------- CGI env variables
auth_type       varchar2(32),   -- AUTH_TYPE
gateway_interf	varchar2(32),   -- GATEWAY_INTERFACE
http_user_agent varchar2(255),  -- USER_AGENT
path_info       varchar2(255),  -- PATH_INFO
path_translated varchar2(255),  -- PATH_TRANSLATED
remote_host     varchar2(80),   -- REMOTE_HOST
remote_addr     varchar2(16),   -- REMOTE_ADDR
remote_user     varchar2(32),   -- REMOTE_USER
remote_ident    varchar2(32),   -- REMOTE_IDENT
remote_protocol varchar2(32),   -- REMOTE_PROTOCOL
server_software varchar2(64),   -- SERVER_SOFTWARE
server_name     varchar2(64),   -- SERVER_NAME
server_port     varchar2(8),    -- SERVER_PORT
--------------------------------CareWeb community information
person_id	number(6),	-- person (foreign) key
nurse_id        number(6),      -- nurse (foreign) key
student_id      number(6),      -- student (foreign) key
school_id	number(6),	-- school (foreign) key
npract_id       number(6),      -- nurse practitioner (foreign) key
doctor_id       number(6),      -- pediatrician (foreign) key
infopage_id	number(6),	-- information page (foreign) key
--------------------------------Student record components
careinfo_id	number(6),	-- base care info (foreign) key
immun_id	number(6),	-- Immunization (foreign) key
basescr_id	number(6),	-- base screening  (foreign) key
physscr_id	number(6),	-- physical screening (foreign) key
develscr_id	number(6),	-- developmental screening (foreign) key
hhistory_id	number(6),	-- health history (foreign) key
visit_id	number(6),	-- visit log (foreign) key
assess_id	number(6),	-- assessment form (foreign) key
asthma_id	number(6),	-- asthma asessment form (foreign) key
pharyn_id	number(6),	-- pharyngitis asessment form (foreign) key
labrep_id	number(6),	-- laboratory report (foreign) key
prognote_id	number(6),	-- progress note (foreign) key
growth_id	number(6),	-- growthchart (foreign) key
hplan_id	number(6),	-- health plan (foreign) key
medicat_id	number(6),	-- medication (foreign) id
--------------------------------Navigation control (not implemented yet)
pagemode        number(2),      -- page handling mode (view, edit, new etc.)
reccomp         number(2),      -- record component
page_id         number(4)       -- page (foreign) key
);

create sequence cw_state_seq;
