 -----------------------------------------------------------------------------
create or replace package cw_student_mgr is
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number);
procedure bar_page(cookie in varchar2);
procedure bar_action(cookie in varchar2, cmd in varchar2);

procedure out_cmd(cookie in varchar2);
procedure home_cmd(cookie in varchar2);
procedure all_cmd(cookie in varchar2);
procedure all_list(cookie in varchar2);
procedure dir_list(cookie in varchar2);
procedure select_cmd(cookie in varchar2);
procedure filter_cmd(cookie in varchar2);
procedure create_cmd(cookie in varchar2);
procedure create_action(cookie in varchar2, r in cw_person_table%rowtype);
procedure modify_cmd(cookie in varchar2);
procedure modify_action(cookie in varchar2, r in cw_person_table%rowtype);
procedure delete_cmd(cookie in varchar2);
procedure save_cmd(cookie in varchar2);
procedure load_cmd(cookie in varchar2);
procedure help_cmd(cookie in varchar2);

procedure err_notimpl(cookie in varchar2);

invalid_command exception;
no_current_student exception;
no_current_school exception;


end;
/
show errors
-----------------------------------------------------------------------------
create or replace package body cw_student_mgr is
-----------------------------------------------------------------------------
me varchar2(64);
url varchar2(64) := cw_util.getURL;
curr_cmd varchar2(32);
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2, iid in number) is
stu cw_student_table%rowtype;
per cw_person_table%rowtype;
begin
   me := 'cw_student_mgr.show_cmd';
   cw_bridge.sync(me,cookie);
  
   stu := cw_student.get(iid);
   cw_bridge.set_student(stu);
   bar_page(cookie);
   per := cw_person.get(stu.person_id);
   cw_util.pageOpen('CareWeb Student Manager: '||
	per.first_name||' '||per.middle_name||' '||per.last_name);
   htp.p('<CENTER>');
   cw_util.cntl_putimg(cookie,
   'http://www.npac.syr.edu/users/sangeeta/media_url/student.gif',
   'cw_student_mgr.home_cmd');
   all_list(cookie);
   cw_person_util.show_form(per);
   cw_student_util.record_table(cookie,stu);
   htp.p('</CENTER>');
   cw_util.pageClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_page(cookie in varchar2) is
begin
   me := 'cw_student_mgr.bar_page';
 --  url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('cmd');
   cw_util.docWrite('cmd',
	'<html><body bgcolor="darkgreen"><font size=5 color="ivory"><center>');
   cw_util.docWrite('cmd',
	'<form action= "'||url||'cw_student_mgr.bar_action" target="view">');
   cw_util.docWrite('cmd',
	'<input type="hidden" name="cookie" value="'||cookie||'">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Out">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Home">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="All">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Select">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Filter">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Create">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Modify">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Delete">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Save">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Load">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Help">');
    cw_util.docWrite('cmd',
	'</form></center></font></body></html>');
   cw_util.docClose('cmd');
   cw_util.jsClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_action(cookie in varchar2, cmd in varchar2) is
begin
   me := 'cw_student_mgr.bar_action';
   cw_bridge.sync(me,cookie);

   curr_cmd := cmd;

   if cmd = 'Out' then
	out_cmd(cookie);
   elsif cmd = 'Home' then
	home_cmd(cookie);
   elsif cmd = 'All' then
	all_cmd(cookie);
   elsif cmd = 'Select' then
	select_cmd(cookie);
   elsif cmd = 'Filter' then
	filter_cmd(cookie);
   elsif cmd = 'Create' then
	create_cmd(cookie);
   elsif cmd = 'Modify' then
	modify_cmd(cookie);
   elsif cmd = 'Delete' then
	delete_cmd(cookie);
   elsif cmd = 'Save' then
	save_cmd(cookie);
   elsif cmd = 'Load' then
	load_cmd(cookie);
   elsif cmd = 'Help' then
	help_cmd(cookie);
   else 
	raise invalid_command;
   end if;
exception
   when invalid_command then
	cw_error.die(me,'Invalid command = '||cmd||'.');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure out_cmd(cookie in varchar2) is
begin
   me := 'cw_student_mgr.out_cmd';
   cw_bridge.sync(me,cookie);

   cw_table_mgr.home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure home_cmd(cookie in varchar2) is
sch cw_school_table%rowtype;
nur cw_nurse_table%rowtype;
per cw_person_table%rowtype;
icon_url varchar2(128);
icon_action varchar2(128);
nur_photo varchar2(128);
begin
   me := 'cw_student_mgr.home_cmd';
   cw_bridge.sync(me,cookie);

   sch := cw_bridge.get_school;
   nur := cw_bridge.get_nurse;

   if sch.id is null and sch.id is null then
	icon_url := 
	'http://www.npac.syr.edu/users/sangeeta/media_url/';
   	icon_action := 'cw_table_mgr.home_cmd';
	cw_table_mgr.all_list(cookie);
   elsif nur.id is null and sch.id is not null then
	icon_url := 
	'/careweb/images/school.gif';
	icon_action := 'cw_school_mgr.home_cmd';
	cw_school_mgr.dir_list(cookie);
   elsif nur.id is not null and sch.id is not null then
	per := cw_person.get(nur.person_id);
	nur_photo := per.media_url||'/photo.gif';
	icon_url := 
	'http://www.npac.syr.edu/users/sangeeta/media_url/'||nur_photo;
	icon_action := 'cw_nurse_mgr.show_cmd';
	cw_nurse_mgr.dir_list(cookie);	
   end if;
   cw_util.cntl_putimg(cookie,icon_url,icon_action);
   bar_page(cookie);
   all_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_cmd(cookie in varchar2) is
stu cw_student_table%rowtype;
per cw_person_table%rowtype;
sch cw_school_table%rowtype;
nur cw_nurse_table%rowtype;
scope varchar2(32);

cnt number(6);
ncol number(2) := 3;
i number(2);

id number;
begin
   me := 'cw_student_mgr.all_cmd';
   cw_bridge.sync(me,cookie);

--   cw_util.pageOpen('CareWeb Student Manager: All People');
   sch := cw_bridge.get_school;
   nur := cw_bridge.get_nurse;
   if sch.id is null then
	scope := 'Syracuse School District';
   else
	scope := sch.name||' '||sch.lev;
   end if;
   cw_util.iconPageOpen('CareWeb Student Manager: ',
	'All Students in '||scope,
	'http://www.npac.syr.edu/users/sangeeta/media_url/student.gif');
   htp.p('<center>');
   htp.p('<center>');

   htp.tableOpen(cattributes=>'border=5');
   htp.tableRowOpen;
   for j in 1..ncol loop
   htp.tableHeader('Name');
   htp.tableHeader('School');
   htp.tableHeader('Grade');
   if j < ncol then
	htp.tableHeader('   ');
   end if;
   end loop;
   htp.tableRowClose;

   htp.tableRowOpen;
   i := 1; 
   while(cw_student.next(stu)) loop
	per := cw_person.get(stu.person_id);
	sch := cw_school.get(stu.school_id);
	if i = 1 then
		htp.tableRowOpen;
	end if;
	htp.tableData(htf.anchor('cw_student_mgr.show_cmd?cookie='
		||cookie||chr(ascii('&'))||'iid='||stu.id,
		per.first_name||' '||per.middle_name||' '||per.last_name));
	htp.tableData(sch.name||' '||sch.lev);
	htp.tableData(stu.grade);
	if i < ncol then
		htp.tableData('');
		i := i + 1;
	else
		htp.tableRowOpen;
		i := 1;
	end if;
   end loop;
   htp.tableClose;
	
   htp.p('</center>');
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_list(cookie in varchar2) is
stu cw_student_table%rowtype;
nur cw_nurse_table%rowtype;
per cw_person_table%rowtype;
begin
  -- url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('list');
   cw_util.docWrite('list','<html><body bgcolor="cyan">');
   while(cw_student.next(stu)) loop
	per := cw_person.get(stu.person_id);
	cw_util.docWrite('list',
	'<a href="'||url||'cw_student_mgr.show_cmd?cookie='
	||cookie||chr(ascii('&'))||'iid='||stu.id||'" target="view">'||
	per.first_name||' '||per.last_name||'</a><br>');
   end loop;
   cw_util.docClose('list');
   cw_util.jsClose;
end;
-----------------------------------------------------------------------------
procedure dir_list(cookie in varchar2) is
sch cw_school_table%rowtype;
begin
  -- url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('list');
   cw_util.docWrite('list','<html><body bgcolor="cyan">');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_careinfo_mgr.home_cmd?cookie='
	||cookie||'" target="view">Base Care Information</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_visit_mgr.home_cmd?cookie='
	||cookie||'" target="view">Visit Logs</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_immun_mgr.home_cmd?cookie='
	||cookie||'" target="view">Immunizations</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_assess_mgr.home_cmd?cookie='
	||cookie||'" target="view">Assessment Forms</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_basescr_mgr.home_cmd?cookie='
	||cookie||'" target="view">Screening Tests</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_visit_mgr.home_cmd?cookie='
	||cookie||'" target="view">Progress Notes</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_physscr_mgr.home_cmd?cookie='
	||cookie||'" target="view">Physical Screenings</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_growth_mgr.home_cmd?cookie='
	||cookie||'" target="view">Growth Charts</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_develscr_mgr.home_cmd?cookie='
	||cookie||'" target="view">Developmental Screenings</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_hplan_mgr.home_cmd?cookie='
	||cookie||'" target="view">Health Plan</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_hhistory_mgr.home_cmd?cookie='
	||cookie||'" target="view">Health History</a><br>');
   cw_util.docWrite('list',
	'<a href="'||url||'cw_medicat_mgr.home_cmd?cookie='
	||cookie||'" target="view">Medications</a><br>');
   cw_util.docWrite('list','</body></html>');  
   cw_util.docClose('list');
   cw_util.jsClose;
end;
-----------------------------------------------------------------------------
procedure select_cmd(cookie in varchar2) is
begin
   me := 'cw_student_mgr.select_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure filter_cmd(cookie in varchar2) is
begin
   me := 'cw_student_mgr.filter_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_cmd(cookie in varchar2) is
sch cw_school_table%rowtype;
begin
   me := 'cw_student_mgr.create_cmd';
   cw_bridge.sync(me,cookie);


   sch := cw_bridge.get_school;
   if sch.id is null then
	raise no_current_school;
   end if;
   htp.formOpen('cw_person.make');
   cw_util.editPageOpen(' CareWeb Student Manager: Create ');
   htp.formHidden('cookie',cookie);
   htp.formHidden('handler','cw_student_mgr.create_action');
   htp.p('<CENTER>');
   cw_person_util.create_form;
   htp.p('</CENTER>');
   htp.formClose;
   cw_util.pageClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_action(cookie in varchar2, r in cw_person_table%rowtype) is
per cw_person_table%rowtype;
stu cw_student_table%rowtype;
sch cw_school_table%rowtype;
begin
   me := 'cw_student_mgr.create_action';
   cw_bridge.sync(me,cookie);

   per := r;
   per.id := null;
   cw_person.put(per);
   stu.person_id := per.id;
   sch := cw_bridge.get_school;
   stu.school_id := sch.id;
   stu.id := null;
   cw_student.put(stu);
   cw_bridge.set_student(stu);
   cw_util.pageOpen('CareWeb Student Manager: '||
	per.first_name||' '||per.middle_name||' '||per.last_name);
   htp.p('<CENTER>');
   cw_person_util.show_form(per);
   cw_student_util.record_table(cookie,stu);
   htp.p('</CENTER>');
   cw_util.pageClose;
end;
-----------------------------------------------------------------------------
procedure modify_cmd(cookie in varchar2) is
per cw_person_table%rowtype;
stu cw_student_table%rowtype;
sch cw_school_table%rowtype;
begin
   me := 'cw_student_mgr.modify_cmd';
   cw_bridge.sync(me,cookie);

   stu := cw_bridge.get_student;
   if stu.id is null then 
	raise no_current_student;
   end if;
   per := cw_person.get(stu.person_id);
   sch := cw_bridge.get_school;
   if sch.id is null then
	raise no_current_school;
   end if;
   htp.formOpen('cw_person.make');
   cw_util.editPageOpen(' CareWeb Student Manager: Modify ');
   htp.formHidden('cookie',cookie);
   htp.formHidden('handler','cw_student_mgr.modify_action');
   htp.p('<CENTER>');
   cw_person_util.modify_form(per);
   htp.p('</CENTER>');
   htp.formClose;
   cw_util.pageClose;
exception
   when no_current_student then
	cw_error.die(me,'No current student');
   when others then 
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure modify_action(cookie in varchar2, r in cw_person_table%rowtype) is
new_per cw_person_table%rowtype;
old_per cw_person_table%rowtype;
sch cw_school_table%rowtype;
stu cw_student_table%rowtype;
begin
   me := 'cw_student_mgr.modify_action';
   cw_bridge.sync(me,cookie);
 
   new_per := r;
   stu := cw_bridge.get_student;
   sch := cw_bridge.get_school;
   old_per := cw_person.get(stu.person_id);
   new_per.id := old_per.id;
   cw_person.put(new_per);

   cw_util.pageOpen('CareWeb Student: '||
	new_per.first_name||' '||new_per.middle_name||' '||new_per.last_name);
   htp.p('<CENTER>');
   cw_person_util.show_form(new_per);
   cw_student_util.record_table(cookie,stu);
   htp.p('</CENTER>');
   cw_util.pageClose;
end;
-----------------------------------------------------------------------------
procedure delete_cmd(cookie in varchar2) is
per cw_person_table%rowtype;
sch cw_school_table%rowtype;
stu cw_student_table%rowtype;
begin
   me := 'cw_student_mgr.delete_cmd';
   cw_bridge.sync(me,cookie);

   stu := cw_bridge.get_student;
   if stu.id is null then 
	raise no_current_student;
   end if;
   sch := cw_bridge.get_school;
   if sch.id is null then
	raise no_current_school;
   end if;
   per := cw_person.get(stu.person_id);

   cw_util.pageOpen('CareWeb Student: '||
        per.first_name||' '||per.middle_name||' '||per.last_name);
   htp.p('<CENTER>');
   cw_person_util.show_form(per);
   htp.para;
   htp.p('<font size=7 color="firebrick">DELETED</a>');
   htp.p('</CENTER>');

   cw_person.rm(per.id);
   cw_student.rm(stu.id);
   cw_bridge.unset_student;
   cw_bridge.unset_person;
   
exception
   when no_current_student then
	cw_error.die(me,'No current student');
   when no_current_school then
	cw_error.die(me,'No current school');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure save_cmd(cookie in varchar2) is
begin
   me := 'cw_student_mgr.save_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure load_cmd(cookie in varchar2) is
begin
   me := 'cw_student_mgr.load_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure help_cmd(cookie in varchar2) is
begin
   me := 'cw_student_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Student Manager: Help','crimson','ivory',7);

   htp.tableOpen(cattributes=>'border=5');

   htp.tableRowOpen;
	htp.tableHeader('Command','center');
	htp.tableHeader('Description','center');
	htp.tableheader('Access','center');
	htp.tableHeader('Status','center');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Out');
	htp.tableData('Exit the current space and move one step up');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Home');
	htp.tableData('Home Page for the CareWeb Student Manager');
	htp.tableData('DBA');
	htp.tableData('Now the same as [All]. Soon to include description '||
		'of the overall organization of the CareWeb database');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('All');
	htp.tableData('List all tables in CareWeb database '||
		'with hyperlinks to individual table spaces');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Select');
	htp.tableData('List all tables with the multiple choice '||
		'selection support');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Filter');
	htp.tableData('Restrict the list of analyzed records in terms '||
		'of a user-provided filter or query');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Create');
	htp.tableData('Create new record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Modify');
	htp.tableData('Modify current record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Delete');
	htp.tableData('Delete current selection (record or group).');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Save');
	htp.tableData('Save/dump the current selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Load');
	htp.tableData('Fetch the previously daved/dumped selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Help');
	htp.tableData('This page - includes short description of all commands');
	htp.tableData('DBA');
	htp.tabledata('Implemented');
   htp.tableRowClose;
   htp.tableClose;

   cw_util.pageClose;
exception

   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure err_notimpl(cookie in varchar2) is
begin
   me := 'cw_student_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Student Manager: ERROR','ivory','crimson',7);
   htp.p('<font size=5 color="ivory">');
   htp.para;
   htp.p('Command ['||curr_cmd||'] is not yet implemented for this space. '||
	'Click [Help] to get '||
	' the functionality, access rights and the implementation status '||
	' Not of the individual Student Manager commands.'); 
  exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
end;
/
show errors
