-----------------------------------------------------------------------------
create or replace package cw_table_mgr is
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2);
procedure bar_page(cookie in varchar2);
procedure bar_action(cookie in varchar2, cmd in varchar2);

procedure out_cmd(cookie in varchar2);
procedure home_cmd(cookie in varchar2);
procedure all_cmd(cookie in varchar2);
procedure all_list(cookie in varchar2);
procedure select_cmd(cookie in varchar2);
procedure filter_cmd(cookie in varchar2);
procedure create_cmd(cookie in varchar2);
procedure modify_cmd(cookie in varchar2);
procedure delete_cmd(cookie in varchar2);
procedure save_cmd(cookie in varchar2);
procedure load_cmd(cookie in varchar2);
procedure help_cmd(cookie in varchar2);

procedure err_notimpl(cookie in varchar2);

invalid_command exception;

end;
/
show errors
-----------------------------------------------------------------------------
create or replace package body cw_table_mgr is
-----------------------------------------------------------------------------
me varchar2(64);
url varchar2(64) := cw_util.getURL;
curr_cmd varchar2(32);
type keyvec_type is table of varchar2(64) index by binary_integer;
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.show_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_page(cookie in varchar2) is
begin
   me := 'cw_table_mgr.bar_page';
  -- url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';
   cw_util.jsOpen;
   cw_util.docOpen('cmd');
   cw_util.docWrite('cmd',
	'<html><body bgcolor="firebrick"><font size=5 color="ivory"><center>');
   cw_util.docWrite('cmd',
	'<form action= "'||url||'cw_table_mgr.bar_action" target="view">');
   cw_util.docWrite('cmd',
	'<input type="hidden" name="cookie" value="'||cookie||'">');
  cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Out">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Home">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="All">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Select">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Filter">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Create">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Modify">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Delete">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Save">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Load">');
   cw_util.docWrite('cmd',
	'<input type="submit" name="cmd" value="Help">');
    cw_util.docWrite('cmd',
	'</form></center></font></body></html>');
   cw_util.docClose('cmd');
   cw_util.jsClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_action(cookie in varchar2, cmd in varchar2) is
begin
   me := 'cw_table_mgr.bar_action';
   cw_bridge.sync(me,cookie);

   curr_cmd := cmd;

   if cmd = 'Out'  then
	out_cmd(cookie);
   elsif cmd = 'Home'  then
	home_cmd(cookie);
   elsif cmd = 'All' then
	all_cmd(cookie);
   elsif cmd = 'Select' then
	select_cmd(cookie);
   elsif cmd = 'Filter' then
	filter_cmd(cookie);
   elsif cmd = 'Create' then
	create_cmd(cookie);
   elsif cmd = 'Modify' then
	modify_cmd(cookie);
   elsif cmd = 'Delete' then
	delete_cmd(cookie);
   elsif cmd = 'Save' then
	save_cmd(cookie);
   elsif cmd = 'Load' then
	load_cmd(cookie);
   elsif cmd = 'Help' then
	help_cmd(cookie);
   else 
	raise invalid_command;
   end if;
exception
   when invalid_command then
	cw_error.die(me,'Invalid command = '||cmd||'.');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure out_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.out_cmd';
   cw_bridge.sync(me,cookie);

   cw_bridge.conn;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure home_cmd(cookie in varchar2) is
demo_url varchar2(128);
icon_url varchar2(128);
begin
   me := 'cw_table_mgr.home_cmd';
   cw_bridge.sync(me,cookie);

  -- demo_url := 'http://king.syr.edu:2006/WebMed/Demos/CareWeb/';
   demo_url := cw_util.getDemoURL;
   icon_url := 'http://www.npac.syr.edu/users/sangeeta/media_url/';
   cw_util.cntl_putimg(cookie,
        'http://www.npac.syr.edu/users/sangeeta/media_url/keys.gif',
        'cw_bridge.conn');
   htp.p('<script language="JavaScript">');
   htp.p('top.frames["list"].location = "'||demo_url||'List.html";');
   htp.p('</script>');
   bar_page(cookie);
   all_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.all_cmd';
   cw_bridge.sync(me,cookie);

--   cw_util.pageOpen('CareWeb Database Manager: All Tables');
   cw_util.iconPageOpen('CareWeb Database Manager: ',
	'All Tables for the School Nurse Demonstration',
	'http://www.npac.syr.edu/users/sangeeta/media_url/database.gif');
   htp.p('<center>');

   htp.tableOpen(cattributes=>'border=5');
   htp.tableRowOpen;
   htp.tableHeader('<font size=5>CareWeb Domains</font>');
   htp.tableHeader('<font size=5>Count</font>');
   htp.tableheader('	');
   htp.tableHeader('<font size=5>Record Components</font>');
   htp.tableHeader('<font size=5>Count</font>');
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_state_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Connection States</font>'));
   htp.tableData('<font size=5>'||to_char(cw_state.rowcount)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_careinfo_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Base Care Information</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_customer_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Customers</font>'));
   htp.tableData('<font size=5>'||to_char(cw_customer.rowcount)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_immun_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Immunizations</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_friend_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Friends</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_basescr_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Screenings</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_guest_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Guests</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_physscr_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Physicals</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_infopage_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Information Pages</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_labreport_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Laboratory Reports</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(
   htf.anchor('cw_npract_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Nurse Practitioners</font>')); 
   htp.tableData('<font size=5>'||to_char(cw_npract.rowcount)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_develscr_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Developmentals</font>'));
   htp.tableData('<font size=5>'||to_char(cw_develscr.rowcount)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_nurse_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Nurses</font>'));
   htp.tableData('<font size=5>'||to_char(cw_nurse.rowcount),'center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_history_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Health Histories</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_parent_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Parents</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_visit_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Visit Logs</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_doctor_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Doctors</font>'));
   htp.tableData('<font size=5>'||to_char(cw_doctor.rowcount)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_assessform_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Assessment Forms</font>'));
    htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_person_mgr.home_cmd?cookie='||cookie,
	'<font size=5>People</font>'));
   htp.tableData('<font size=5>'||to_char(cw_person.rowcount)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_prognote_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Progress Notes</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_school_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Schools</font>'));
   htp.tableData('<font size=5>'||to_char(cw_school.rowcount)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_growthchart_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Growth Charts</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_student_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Students</font>'));
   htp.tableData('<font size=5>'||to_char(cw_student.rowcount)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_plan_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Health Plans</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableRowOpen;
   htp.tableData(htf.anchor(
	'cw_tx_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Transactions</font>'));
   htp.tableData('<font size=5>'||to_char(cw_tx.rowcount)||'</font>','center'); 
   htp.tableData('');
   htp.tableData(htf.anchor(
	'cw_medication_mgr.home_cmd?cookie='||cookie,
	'<font size=5>Medications</font>'));
   htp.tableData('<font size=5>'||to_char(0)||'</font>','center'); 
   htp.tableRowClose;

   htp.tableClose;

   htp.p('</center>');
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_list(cookie in varchar2) is
kv keyvec_type;
pv keyvec_type;
begin
 --  url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/';

   kv(1) := 'Connection States';	pv(1) := 'state';	
   kv(2) := 'Customers';		pv(2) := 'customer';		
   kv(3) := 'Friends';			pv(3) := 'friend';
   kv(4) := 'Guests';			pv(4) := 'guest';
   kv(5) := 'Information Pages';	pv(5) := 'infopage';
   kv(6) := 'Nurse Practitioners';	pv(6) := 'npract';
   kv(7) := 'Nurses';			pv(7) := 'nurse';
   kv(8) := 'Parents';			pv(8) := 'parent';
   kv(9) := 'Doctors';			pv(9) := 'doctor';
   kv(10) := 'People';			pv(10) := 'person';
   kv(11) := 'Schools';			pv(11) := 'school';
   kv(12) := 'Students';		pv(12) := 'student';
   kv(13) := 'Transactions';		pv(13) := 'tx';
   kv(14) := 'Base Care Information';	pv(14) := 'careinfo';
   kv(15) := 'Immunizations';		pv(15) := 'immun';
   kv(16) := 'Screenings';		pv(16) := 'basescr';
   kv(17) := 'Physicals';		pv(17) := 'physscr';
   kv(18) := 'Laboratory Reports';	pv(18) := 'labrep';
   kv(19) := 'Developmentals';		pv(19) := 'develscr';
   kv(20) := 'Health Histories';	pv(20) := 'hhistory';
   kv(21) := 'Visit Logs';		pv(21) := 'visit';
   kv(22) := 'Assessment Forms';	pv(22) := 'assess';
   kv(23) := 'Progress Notes';		pv(23) := 'prognote';
   kv(24) := 'Growth Charts';		pv(24) := 'growth';
   kv(25) := 'Health Plans';		pv(25) := 'hplan';
   kv(26) := 'Medications';		pv(26) := 'medicat';
  
   cw_util.jsOpen;
   cw_util.docOpen('list');
   cw_util.docWrite('list','<html><body bgcolor="cyan">');
   for i in 1..13 loop
	cw_util.docWrite('list', 
	'<a href="'||url||'cw_'||pv(i)||'_mgr.home_cmd?cookie='||cookie||
	'" target="view">'||kv(i)||'</a><br>');
   end loop;
   cw_util.docWrite('list','<hr>');
   for i in 14..26 loop
	cw_util.docWrite('list', 
	'<a href="'||url||'cw_'||pv(i)||'_mgr.home_cmd?cookie='||cookie||
	'" target="view">'||kv(i)||'</a><br>');
   end loop;
   cw_util.docWrite('list','</body></html>');
   cw_util.docClose('list');
   cw_util.jsClose;
end;
-----------------------------------------------------------------------------
procedure select_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.select_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure filter_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.filter_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.create_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure modify_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.modify_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure delete_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.delete_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure save_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.save_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure load_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.load_cmd';
   cw_bridge.sync(me,cookie);

   err_notimpl(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure help_cmd(cookie in varchar2) is
begin
   me := 'cw_table_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Table Manager: Help','crimson','ivory',7);

   htp.tableOpen(cattributes=>'border=5 cellspacing=3 cellpadding=3');

   htp.tableRowOpen;
	htp.tableHeader('Command','center');
	htp.tableHeader('Description','center');
	htp.tableheader('Access','center');
	htp.tableHeader('Status','center');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Out');
	htp.tableData('Exit the current space and move up in the hierarchy');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Home');
	htp.tableData('Home Page for the CareWeb Table Manager');
	htp.tableData('DBA');
	htp.tableData('Now the same as [All]. Soon to include description '||
		'of the overall organization of the CareWeb database');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('All');
	htp.tableData('List all tables in CareWeb database '||
		'with hyperlinks to individual table spaces');
	htp.tableData('DBA');
	htp.tableData('Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Select');
	htp.tableData('List all tables with the multiple choice '||
		'selection support');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Filter');
	htp.tableData('Restrict the list of analyzed records in terms '||
		'of a user-provided filter or query');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Create');
	htp.tableData('Create new record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Modify');
	htp.tableData('Modify current record.');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Delete');
	htp.tableData('Delete current selection (record or group).');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Save');
	htp.tableData('Save/dump the current selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Load');
	htp.tableData('Fetch the previously daved/dumped selection');
	htp.tableData('DBA');
	htp.tabledata('Not Implemented');
   htp.tableRowClose;

   htp.tableRowOpen;
	htp.tableData('Help');
	htp.tableData('This page - includes short description of all commands');
	htp.tableData('DBA');
	htp.tabledata('Implemented');
   htp.tableRowClose;
   htp.tableClose;

   cw_util.pageClose;
exception

   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure err_notimpl(cookie in varchar2) is
begin
   me := 'cw_table_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Table Manager: ERROR','ivory','crimson',7);
   htp.p('<font size=5 color="ivory">');
   htp.para;
   htp.p('Command ['||curr_cmd||'] is not yet implemented for this space. '||
	'Click [Help] to get '||
	' the functionality, access rights and the implementation status '||
	' Not of the individual Table Manager commands.'); 
  exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
end;
/
show errors
