--------------------------------------------------------------------
create or replace package cw_xxx is
--------------------------------------------------------------------
procedure put(r in out cw_xxx_table%rowtype);
function get(iid in number) return cw_xxx_table%rowtype;
function next(n in out cw_xxx_table%rowtype) return boolean;
function new return cw_xxx_table%rowtype;
end;
/
show errors
--------------------------------------------------------------------
create or replace package body cw_xxx is
--------------------------------------------------------------------
this cw_xxx_table%rowtype;

cursor nrow is
   select * from cw_xxx_table;
--------------------------------------------------------------------
procedure put(r in out cw_xxx_table%rowtype) is
   cursor c (this_id in number) is
   select * from cw_xxx_table
   where id = this_id;

   begin
	if r.id is null then
	   select cw_xxx_seq.nextval into r.id
	   from dual;
	   insert into cw_xxx_table
	   (id)
	   values
	   (r.id);
	else
	   open c (r.id);
	   fetch c into this;
	   if c%found then
		update cw_xxx_table set
		   id		= r.id
		where current of c;
	   else
		raise no_data_found;
	   end if;
	   close c;
	end if;
   exception	   
	when others then
	   cw_error.panic('cw_xxx.put id='||to_char(r.id),sqlerrm);
end;
---------------------------------------------------------------------
function get(iid in number) return cw_xxx_table%rowtype is
cursor c (this_id number) is
   select * from cw_xxx_table
   where id = this_id;
begin
   open c(iid);
   fetch c into this;
   if c%notfound then
        raise no_data_found;
   end if;
   close c;
   return this;
exception
   when no_data_found then
        raise;
   when others then
        cw_error.panic('cw_xxx.get id='||to_char(iid),sqlerrm);
end;
---------------------------------------------------------------------
function next(n in out cw_xxx_table%rowtype) return boolean is
begin
   if not nrow%isopen then
        open nrow;
   end if;
   fetch nrow into n;
   if nrow%notfound then
        close nrow;     
        return false;
   else
        return true;
   end if;
exception
   when others then
        cw_error.panic('cw_xxx.next',sqlerrm);

end;
---------------------------------------------------------------------
function new return cw_xxx_table%rowtype is
begin
   this.id := null;
   put(this);
   return this;
end;
---------------------------------------------------------------------
end;
/
show errors
