-----------------------------------------------------------------------------
create or replace package cw_tx_mgr is
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2);
procedure bar_page(cookie in varchar2);
procedure bar_action(cookie in varchar2, cmd in varchar2);

procedure home_cmd(cookie in varchar2);
procedure all_cmd(cookie in varchar2);
procedure select_cmd(cookie in varchar2);
procedure filter_cmd(cookie in varchar2);
procedure create_cmd(cookie in varchar2);
procedure modify_cmd(cookie in varchar2);
procedure delete_cmd(cookie in varchar2);
procedure save_cmd(cookie in varchar2);
procedure load_cmd(cookie in varchar2);
procedure help_cmd(cookie in varchar2);

invalid_command exception;

end;
/
show errors
-----------------------------------------------------------------------------
create or replace package body cw_tx_mgr is
-----------------------------------------------------------------------------
me varchar2(64);
-----------------------------------------------------------------------------
procedure show_cmd(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.show_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_page(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.show';
   cw_bridge.sync(me,cookie);
   
   htp.htmlOpen;
   htp.bodyOpen(cattributes=>'bgcolor="firebrick"');
   htp.p('<font size=5 color="ivory"');
   htp.formOpen('cw_tx_mgr.bar_action');
	htp.formHidden('cookie',cookie);
	htp.formSubmit('cmd','Home');
	htp.formSubmit('cmd','All');
	htp.formSubmit('cmd','Select');
	htp.formSubmit('cmd','Filter');
	htp.formSubmit('cmd','Create');
	htp.formSubmit('cmd','Modify');
	htp.formSubmit('cmd','Delete');
	htp.formSubmit('cmd','Save');
	htp.formSubmit('cmd','Load');
	htp.formSubmit('cmd','Help');
   htp.formClose;
   htp.p('</font>');
   htp.bodyClose;
   htp.htmlClose;
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure bar_action(cookie in varchar2, cmd in varchar2) is
begin
   me := 'cw_tx_mgr.show';
   cw_bridge.sync(me,cookie);

   if(cmd = 'Home') then
	home_cmd(cookie);
   elsif cmd = 'All' then
	all_cmd(cookie);
   elsif cmd = 'Select' then
	select_cmd(cookie);
   elsif cmd = 'Filter' then
	filter_cmd(cookie);
   elsif cmd = 'Create' then
	create_cmd(cookie);
   elsif cmd = 'Modify' then
	modify_cmd(cookie);
   elsif cmd = 'Delete' then
	delete_cmd(cookie);
   elsif cmd = 'Save' then
	save_cmd(cookie);
   elsif cmd = 'Load' then
	load_cmd(cookie);
   elsif cmd = 'Help' then
	help_cmd(cookie);
   else 
	raise invalid_command;
   end if;
exception
   when invalid_command then
	cw_error.die(me,'Invalid command = '||cmd||'.');
   when others then
	cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure home_cmd(cookie in varchar2) is
url varchar2(128) := cw_util.getURL;
begin
   me := 'cw_tx_mgr.home_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.jsOpen;
   htp.p('top.frames["cmd"].location =
   "'||url||'cw_tx_mgr.bar_page?cookie='||cookie||'";');
   cw_util.jsClose;
   all_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure all_cmd(cookie in varchar2) is
r cw_tx_table%rowtype;
begin
   me := 'cw_tx_mgr.all_cmd';
   cw_bridge.sync(me,cookie);

   cw_util.pageOpen('CareWeb Transaction Manager: All Transactions');
   htp.p('<center>');
   htp.tableOpen(1);
   htp.tableRowOpen;
        htp.tableHeader('id');
        htp.tableHeader('timestamp');
        htp.tableHeader('cust_id');
        htp.tableHeader('url');
        htp.tableHeader('target');
        htp.tableHeader('action');
        htp.tableHeader('http_user_agent');
        htp.tableHeader('remote_host');
   htp.tableRowClose;
   while (cw_tx.next(r)) loop
        htp.tableRowOpen;
           htp.tableData(to_char(r.id));
           htp.tableData(to_char(r.timestamp,'dd-Mon-yy hh24:mi:ss'));
           htp.tableData(to_char(r.cust_id));
           htp.tableData(r.url);
           htp.tableData(cw_tx.t_name(r.target));
           htp.tableData(cw_tx.a_name(r.action));
           htp.tableData(r.http_user_agent);
           htp.tableData(r.remote_host);
        htp.tableRowClose;
   end loop;
   htp.tableClose;

   htp.p('</center>');
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure select_cmd(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.select_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure filter_cmd(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.filter_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure create_cmd(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.create_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure modify_cmd(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.modify_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure delete_cmd(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.delete_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure save_cmd(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.save_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure load_cmd(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.load_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
procedure help_cmd(cookie in varchar2) is
begin
   me := 'cw_tx_mgr.help_cmd';
   cw_bridge.sync(me,cookie);

   cw_error.msg(me||': procedure not implemented');
   home_cmd(cookie);
exception
   when others then
   cw_error.die(me,sqlerrm);
end;
-----------------------------------------------------------------------------
end;
/
show errors
