-------------------------------------------------------
-- all accomplished CareWeb transactions
-------------------------------------------------------

drop sequence cw_tx_seq;
drop table cw_tx_table;

create table cw_tx_table (
--------------------------------General information
id              number(9)       primary key,
timestamp       date,           -- creation time
cust_id         number(6),      -- customer (foreign) key
url		varchar2(64),	-- transaction page/procedure
target		number(2),	-- e.g. t_login, t_nurse, t_medication
action		number(2),	-- e.g. a_accept, a_create, a_modify
------------------------------- CGI env variables
auth_type       varchar2(32),   -- AUTH_TYPE
gateway_interf	varchar2(32),   -- GATEWAY_INTERFACE
http_user_agent varchar2(255),  -- USER_AGENT
path_info       varchar2(255),  -- PATH_INFO
path_translated varchar2(255),  -- PATH_TRANSLATED
remote_host     varchar2(80),   -- REMOTE_HOST
remote_addr     varchar2(16),   -- REMOTE_ADDR
remote_user     varchar2(32),   -- REMOTE_USER
remote_ident    varchar2(32),   -- REMOTE_IDENT
remote_protocol varchar2(32),   -- REMOTE_PROTOCOL
server_software varchar2(64),   -- SERVER_SOFTWARE
server_name     varchar2(64),   -- SERVER_NAME
server_port     varchar2(8),    -- SERVER_PORT
--------------------------------Auxiliary number registers
nr1		number(6),	-- number register 1
nr2		number(6),	-- number register 2
nr3		number(6),	-- number register 3
nr4		number(6),	-- number register 4
--------------------------------Auxiliary string registers
sr1		varchar2(32),	-- string register 1
sr2		varchar2(32),	-- string register 2
sr3		varchar2(32),	-- string register 3
sr4		varchar2(32)	-- string register 4
);

create sequence cw_tx_seq;
