--------------------------------------------------------------------------
create or replace package cw_util is
--------------------------------------------------------------------------
procedure pageOpen(title in varchar2);
procedure pageOpen(title in varchar2, fgcolor in varchar2, 
   bgcolor in varchar2, fontsize in number);
procedure iconPageOpen(title1 in varchar2, title2 in varchar2, 
   icon in varchar2, fgcolor in varchar2, bgcolor in varchar2, 
   fontsize in number);
procedure iconPageOpen(title1 in varchar2, title2 in varchar2, 
   icon in varchar2);
procedure editPageOpen(title in varchar2);
procedure editPageOpen(title in varchar2,
   left in varchar2,right in varchar2);
procedure editPageOpen(title in varchar2,
   left in varchar2,right in varchar2, fgcolor in varchar2, 
   bgcolor in varchar2, fontsize in number);
procedure pageClose;
procedure editPageClose;
procedure jsOpen;
procedure jsClose;
procedure docOpen(iname in varchar2);
procedure docWrite(iname in varchar2, iscript in varchar2);
procedure docClose(iname in varchar2);
procedure cntl_putimg(cookie in varchar2, src in varchar2, dst in varchar2);
procedure cntl_putimg(src in varchar2, dst in varchar2);
procedure login_form(cookie in varchar2);
procedure select_date(name in varchar2, iday in date,
   year_start in varchar2, year_end in varchar2);
function getURL return varchar2;
function getDemoURL return varchar2;
end;
/
show errors
--------------------------------------------------------------------------
create or replace package body cw_util is
url varchar2(64) := 'http://clarissa.npac.syr.edu:8080/owa_careweb/owa/';
demourl varchar2(64) := 'http://clarissa.npac.syr.edu:8080/careweb/';
--------------------------------------------------------------------------
procedure pageOpen(title in varchar2, fgcolor in varchar2,
   bgcolor in varchar2, fontsize in number) is
begin
   htp.htmlOpen;
   htp.headOpen;
   htp.title(title);
   htp.headClose;
   htp.bodyOpen(cattributes=>'bgcolor="'||bgcolor||'"');
   htp.hr;
   htp.p('<font color="'||fgcolor||'" size='||to_char(fontsize)||'><center>');
   htp.p(title);
   htp.p('</font></center>');
   htp.hr;
end;
--------------------------------------------------------------------------
procedure pageOpen(title in varchar2) is
begin
  pageOpen(title,'crimson','salmon',7);
end;
--------------------------------------------------------------------------
procedure pageClose is
begin
   htp.bodyClose;
   htp.htmlClose;
end;
--------------------------------------------------------------------------
procedure iconPageOpen(title1 in varchar2, title2 in varchar2, 
   icon in varchar2, fgcolor in varchar2, bgcolor in varchar2, 
   fontsize in number) is
begin
   htp.htmlOpen;
   htp.headOpen;
   htp.title(title1||' '||title2);
   htp.headClose;
   htp.bodyOpen(cattributes=>'bgcolor="'||bgcolor||'"');
   htp.p('<center>');
   htp.tableOpen;
   htp.tableRowOpen;
   htp.tableData(htf.img(icon));
   htp.tableData(' '); htp.tableData(' ');
   htp.tableData('<font color="'||fgcolor||'" size='||to_char(fontsize)||'>'||
	title1||'<hr>'||title2||'</font>','CENTER');
   htp.tableRowClose;
   htp.tableClose;
   htp.p('</center><hr>');
end;
--------------------------------------------------------------------------
procedure iconPageOpen(title1 in varchar2, title2 in varchar2, 
   icon in varchar2) is
begin
   iconPageOpen(title1,title2,icon,'crimson','salmon',7);
end;
---------------------------------------------------------------------------
procedure editPageOpen(title in varchar2,
   left in varchar2, right in varchar2, 
   fgcolor in varchar2, bgcolor in varchar2, fontsize in number) is
begin
   htp.htmlOpen;
   htp.headOpen;
   htp.title(title);
   htp.headClose;
   htp.bodyOpen(cattributes=>'bgcolor="'||bgcolor||'"');
   htp.hr;
   htp.p('<font color="'||fgcolor||'" size='||to_char(fontsize)||'><center>');
   htp.formReset(left);
   htp.p('  '||title||'  ');
   htp.formSubmit(null,right);
   htp.p('</font></center>');
   htp.hr;
end;
--------------------------------------------------------------------------
procedure editPageOpen(title in varchar2, 
left in varchar2, right in varchar2) is
begin
   editPageOpen(title,left,right,'crimson','salmon',7);
end;
--------------------------------------------------------------------------
procedure editPageOpen(title in varchar2) is
begin
  editPageOpen(title,'Reset','Submit','crimson','salmon',7);
end;
--------------------------------------------------------------------------
procedure editPageClose is
begin
   htp.bodyClose;
   htp.htmlClose;
end;
--------------------------------------------------------------------------
procedure jsOpen is
begin
   htp.p('<script language="JavaScript">');
end;
--------------------------------------------------------------------------
procedure jsClose is
begin
   htp.p('</script>');
end;
--------------------------------------------------------------------------
procedure docOpen(iname in varchar2) is
begin
   htp.p('top.frames["'||iname||'"].document.open();');
end;
---------------------------------------------------------------------------
procedure docWrite(iname in varchar2,iscript in varchar2) is
begin
   htp.p('top.frames["'||iname||'"].document.write('''||iscript||''');');
end;
---------------------------------------------------------------------------
procedure docClose(iname in varchar2) is
begin
   htp.p('top.frames["'||iname||'"].document.close();'); 
end;
---------------------------------------------------------------------------
procedure cntl_putimg(cookie in varchar2, 
src in varchar2, dst in varchar2) is
url varchar2(128) := cw_util.getURL;
begin
   --url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/'||dst;
--  htp.p('URL is : '|| url);
   url := url || dst ;
   jsOpen;
   docOpen('cntl');
   docWrite('cntl',
	'<html><a href="'||url||'?cookie='||cookie||
	'" target="view"><img src="'||src||'"></a>');
   docClose('cntl');
   jsClose;
end;
----------------------------------------------------------------------------
procedure cntl_putimg(src in varchar2, dst in varchar2) is
url varchar2(128) := cw_util.getURL;
begin
   --url := 'http://kayak.npac.syr.edu:9602/cgi-bin/wow/'||dst;
   url := url || dst;
   jsOpen;
   docOpen('cntl');
   docWrite('cntl',
	'<html><a href="'||url||'" target="view"><img src="'||src||'"></a>');
   jsClose;   
end;
-----------------------------------------------------------------------------
procedure login_form(cookie in varchar2) is
begin
	htp.formOpen('cw_bridge.auth');
	htp.formHidden('cookie',cookie);

	htp.p('<center>');
	htp.tableOpen;
	htp.tableRowOpen;
	   htp.tableData('Username:','right');
	   htp.tableData(htf.formText('iuser',32));
	htp.tableRowClose;
	htp.tableRowOpen;
	   htp.tableData('Password:','right');
	   htp.tableData(htf.formPassword('ipasswd',32));
	htp.tableRowClose;
	htp.tableClose;

	htp.para;

	htp.tableOpen(cattributes=>'border=5');
	htp.tableRowOpen;
	   htp.tableData(htf.formSubmit('iaction',' Login '),'center');
	   htp.tableData('Entry for certified CareWeb customers.
			  Please type-in your username and password
			  and then press the [Login] button.
			  For information on how to join the CareWeb
			  community, please send e-mail to 
			  careweb@npac.syr.edu.');
	htp.tableRowClose;
	htp.tableRowOpen;
	   htp.tableData(htf.formSubmit('iaction',' Register '),'center');
	   htp.tableData('Entry for Internet visitors who want to register 
			  as CareWeb friends with limited access to the database.
			  Please specify your username and password you want 
			  to use when connecting to CareWeb and then press
			  the [Register] button.');
        htp.tableRowClose;
	htp.tableRowOpen;
	   htp.tableData(htf.formSubmit('iaction',' Visit '),'center');
	   htp.tableData('Entry for Internet visitors who want to 
			  inspect the CareWeb space and remain anonymous.
			  No contact information will be requested but 
			  access to the database will be further 
			  limited.
			  Just press the [Visit] button to connect.');
	htp.tableRowClose;
	htp.tableClose;
	htp.para;
	htp.img('/careweb/img/careweb2.gif');
	htp.p('</center>');

	htp.formClose;
end;
-------------------------------------------------------------------------	   
procedure select_date(name in varchar2, iday in date, 
   year_start in varchar2, year_end in varchar2) is 

  the_month varchar2(8);
  the_day varchar2(2);
  the_year varchar2(4);
   select_flag varchar2(16); 
  yr_start number(8) := to_number(year_start);
  yr_end number(8) := to_number(year_end);
begin  
   htp.formSelectOpen(name||'m', '', 1, 'onChange=""');
   for i in 1..12 loop 
     the_month := to_char(to_date(lpad(i, 2, '0'), 'MM'), 'MON');
     if (to_char(iday, 'MM') = lpad(i, 2, '0')) then
       select_flag := 'SELECTED';
     else 
       select_flag := null;
     end if;
     htp.formSelectOption(the_month, select_flag, 'value="'||the_month||'"');
   end loop;
   htp.formSelectClose;
   htp.formSelectOpen(name||'d', '', 1, 'onChange=""');
   for i in 1..31 loop 
     the_day := to_char(to_date('01'||i, 'MMDD'), 'DD');
     if (to_char(iday, 'DD') = i) then
       select_flag := 'SELECTED';
     else 
       select_flag := null;
     end if;
     htp.formSelectOption(the_day, select_flag, 'value="'||the_day||'"');
   end loop;
   htp.formSelectClose;
   htp.formSelectOpen(name||'y', '', 1, 'onChange=""');
   for i in yr_start..yr_end loop
     the_year := to_char(to_date(i, 'YYYY'), 'YYYY');
     if (to_char(iday, 'YYYY') = i) then
       select_flag := 'SELECTED';
     else 
       select_flag := null;
     end if;
     htp.formSelectOption(the_year, select_flag, 'value="'||the_year||'"');
   end loop;
   htp.formSelectClose;
end;
-------------------------------------------------------------------------
function getURL return varchar2 is

begin
   return url;
end;

----------------------------------------------------------------------------
function getDemoURL return varchar2 is

begin
   return demourl;
end;

----------------------------------------------------------------------------

end;
/
show errors
