drop package cw_util_jguo;

--------------------------------------------------------------------------
create or replace package cw_util_jguo is
procedure pageOpen(title in varchar2);
procedure pageOpen(title in varchar2, fgcolor in varchar2, 
   bgcolor in varchar2, fontsize in number);
procedure editPageOpen(title in varchar2);
procedure editPageOpen(title in varchar2,
   left in varchar2,right in varchar2);
procedure editPageOpen(title in varchar2,
   left in varchar2,right in varchar2, fgcolor in varchar2, 
   bgcolor in varchar2, fontsize in number);
procedure pageClose;
procedure editPageClose;
procedure jsOpen;
procedure jsClose;
procedure docOpen(iname in varchar2);
procedure docWrite(iname in varchar2, iscript in varchar2);
procedure docClose(iname in varchar2);
   procedure login_form(cookie in varchar2);

  procedure selectoption3(name in varchar2, str1 in varchar2, str2 in varchar2, str3 in varchar2);  
  function equalto(str1 in varchar2, str2 in varchar2) return varchar2;
  procedure select_colomns(column_num in number);  
  procedure select_colomns_javascript(cookie in varchar2);  
  procedure text_insertrow(name in varchar2); 
  procedure text_updaterow(name in varchar2, value in varchar2);  
  procedure text_searchrow(name in varchar2, column_num in number, value in varchar2);
  procedure date_insertrow(name in varchar2); 
  procedure date_updaterow(name in varchar2, value in varchar2);  
  procedure date_searchrow(name in varchar2, column_num in number, value in varchar2);
  procedure select_date(name in varchar2, iday in date, year_start in varchar2, year_end in varchar2); 
  procedure titleCenter(title in varchar2, color in varchar2, fontsize in varchar2);
  function get_value(name in varchar2, which in number) return varchar2;
  function get_length(name in varchar2) return number;
  function get_next(name in out varchar2) return number;

  today date;
  select_flag varchar2(8);
end;
/
show errors
--------------------------------------------------------------------------
create or replace package body cw_util_jguo is
--------------------------------------------------------------------------
me varchar2(128);
-- *************************************************** --
--    Jiangang's Stuff
-- *************************************************** --
procedure selectoption3(name in varchar2, str1 in varchar2, str2 in varchar2, str3 in varchar2) is
begin
   htp.p('<td>');
   htp.formSelectOpen(name, '', 1);
   htp.formSelectOption(str1, '');
   htp.formSelectOption(str2, '');
   htp.formSelectOption(str3, '');
   htp.formSelectClose;
   htp.p('</td>');
end;
 
--------------------------------------------------------- 
function equalto(str1 in varchar2, str2 in varchar2) return varchar2 is 
--------------------------------------------------------- 
begin  
  if ( str2 like '%'||str1||'%') then
    return 'SELECTED';
  else 
    return null;
  end if;
end;

--------------------------------------------------------- 
procedure select_date(name in varchar2, iday in date, year_start in varchar2, year_end in varchar2) is 
---------------------------------------------------------  
  the_month varchar2(8);
  the_day varchar2(2);
  the_year varchar2(4);
  yr_start number(8) := to_number(year_start);
  yr_end number(8) := to_number(year_end);
begin  
   htp.formSelectOpen(name||'m', '', 1, 'onChange=""');
   for i in 1..12 loop 
     the_month := to_char(to_date(lpad(i, 2, '0'), 'MM'), 'MON');
     if (to_char(iday, 'MM') = lpad(i, 2, '0')) then
       select_flag := 'SELECTED';
     else 
       select_flag := null;
     end if;
     htp.formSelectOption(the_month, select_flag, 'value="'||the_month||'"');
   end loop;
   htp.formSelectClose;
   htp.formSelectOpen(name||'d', '', 1, 'onChange=""');
   for i in 1..31 loop 
     the_day := to_char(to_date('01'||i, 'MMDD'), 'DD');
     if (to_char(iday, 'DD') = i) then
       select_flag := 'SELECTED';
     else 
       select_flag := null;
     end if;
     htp.formSelectOption(the_day, select_flag, 'value="'||the_day||'"');
   end loop;
   htp.formSelectClose;
   htp.formSelectOpen(name||'y', '', 1, 'onChange=""');
   for i in yr_start..yr_end loop
     the_year := to_char(to_date(i, 'YYYY'), 'YYYY');
     if (to_char(iday, 'YYYY') = i) then
       select_flag := 'SELECTED';
     else 
       select_flag := null;
     end if;
     htp.formSelectOption(the_year, select_flag, 'value="'||the_year||'"');
   end loop;
   htp.formSelectClose;
end;

--------------------------------------------------------- 
procedure select_colomns(column_num in number) is  
---------------------------------------------------------  
begin  
   htp.p('most recent');
   htp.formSelectOpen('column_num', '', 1, 'onChange=""');
   htp.formSelectOption('--', '', 'value ="1"');
   for i in 1..column_num loop
     htp.formSelectOption(i, '', 'value='||i);
   end loop;
   htp.formSelectClose;
   htp.p('record(s)');
end;
--------------------------------------------------------- 
procedure select_colomns_javascript(cookie in varchar2) is  
---------------------------------------------------------  
begin  
   cw_util_jguo.jsOpen;
   htp.p('var xcolumn_num=3;');
   htp.p('var xselectedIndex;');
   htp.p('var visit_num=0;');
   htp.p('
     function set_columns() {
       if (visit_num != 0) { ');
         htp.p('xselectedIndex = document.forms[0].column_num.selectedIndex;
         top.xcolumn_num = document.forms[0].column_num.options[xselectedIndex].value;
        } ');
   htp.p('else { top.xcolumn_num = 3; } ');
--       htp.p('alert("It will always show 1 tests, but I can fix this if I can 
--             put a invisible column_num variable in your top frame."); ');
       htp.p('document.location = "/cgi-bin/jguo/wow/'||me||'?cookie='||cookie||chr(ascii('&'))||'column_num=top.xcolumn_num"');
       htp.p('top.visit_num = 1;');
   htp.p('} ');
   cw_util_jguo.jsClose;
end;
--------------------------------------------------------- 
procedure text_insertrow(name in varchar2) is  
---------------------------------------------------------  
begin  
   htp.tableRowOpen;
   htp.tableHeader(name);
--    for i in 1..TO_NUMBER(column_num) loop
     htp.tableData(htf.formText(name, '10', '10', ''));
--   end loop;
  htp.tableRowClose;
end;
--------------------------------------------------------- 
procedure text_updaterow(name in varchar2, value in varchar2) is  
---------------------------------------------------------  
begin  
   htp.tableRowOpen;
   htp.tableHeader(name);
   htp.tableHeader(name);
--    for i in 1..TO_NUMBER(column_num) loop
     htp.tableData(htf.formText(name, '10', '10', value));
--   end loop;
  htp.tableRowClose;
end;
--------------------------------------------------------- 
procedure text_searchrow(name in varchar2, column_num in number, value in varchar2) is  
---------------------------------------------------------  
begin  
   htp.tableRowOpen;
   htp.tableHeader(name);
    for i in 1..TO_NUMBER(column_num) loop
--     htp.tableData(value);
     htp.tableData('value');
   end loop;
  htp.tableRowClose;
end;

--------------------------------------------------------- 
procedure date_insertrow(name in varchar2) is  
---------------------------------------------------------  
begin  
   htp.tableRowOpen;
   htp.tableHeader(name);
--    for i in 1..TO_NUMBER(column_num) loop
     htp.tableData(htf.formText(name, '10', '10', ''));
--   end loop;
  htp.tableRowClose;
end;
--------------------------------------------------------- 
procedure date_updaterow(name in varchar2, value in varchar2) is  
---------------------------------------------------------  
begin  
   htp.tableRowOpen;
   htp.tableHeader(name);
--    for i in 1..TO_NUMBER(column_num) loop
     htp.tableData(htf.formText(name, '10', '10', value));
--   end loop;
  htp.tableRowClose;
end;
--------------------------------------------------------- 
procedure date_searchrow(name in varchar2, column_num in number, value in varchar2) is  
---------------------------------------------------------  
begin  
   htp.tableRowOpen;
   htp.tableHeader(name);
    for i in 1..TO_NUMBER(column_num) loop
     htp.tableData(htf.formText(name, '10', '10', value));
   end loop;
  htp.tableRowClose;
end;


--------------------------------------------------------- 
   procedure titleCenter(title in varchar2, color in varchar2, fontsize in varchar2) is
--------------------------------------------------------- 
   begin
	htp.hr;
	htp.p('<font color="'||color||'" size='||fontsize||'><center>');
	htp.p(title);
	htp.p('</font></center>');
	htp.hr;
   end;


--------------------------------------------------------------------------
  function get_value(name in varchar2, which in number) return varchar2 is
--------------------------------------------------------------------------
    value varchar2(100);
    a number;
    b number;
  begin
    if (which=1) then
      a := 0;
      b := instr(name, '&', 1, which);
      value := substr(name, a+1, b-a-1);
    elsif (which = get_length(name)) then
      a := instr(name, '&', 1, which-1);
      value := substr(name, a+1);
    else
      a := instr(name, '&', 1, which-1);
      b := instr(name, '&', 1, which);
      value := substr(name, a+1, b-a-1);
    end if;
    return value;    
  end;
 
--------------------------------------------------------------------------
  function get_length(name in varchar2) return number is
--------------------------------------------------------------------------
    length number :=1;
    para_counter number :=1;
  begin
    while (instr(name, '&', 1, para_counter) != 0) loop
      para_counter := para_counter +1;
      length := length +1;
    end loop;
    return length;
  end;

--------------------------------------------------------------------------
  function get_next(name in out varchar2) return number is
--------------------------------------------------------------------------
    next varchar2(100);
    a number;
  begin
    a := instr(name, '&', 1, 1);
    next := substr(name, 1, a-1);
    name := substr(name, a+1);
    return next;    
  end;

-- *************************************************** --
--    Wojtek's Stuff
-- *************************************************** --

procedure pageOpen(title in varchar2, fgcolor in varchar2,
   bgcolor in varchar2, fontsize in number) is
begin
   htp.htmlOpen;
   htp.headOpen;
   htp.title(title);
   htp.headClose;
   htp.bodyOpen(cattributes=>'bgcolor="'||bgcolor||'"');
   htp.hr;
   htp.p('<font color="'||fgcolor||'" size='||to_char(fontsize)||'><center>');
   htp.p(title);
   htp.p('</font></center>');
   htp.hr;
end;
--------------------------------------------------------------------------
procedure pageOpen(title in varchar2) is
begin
  pageOpen(title,'crimson','salmon',7);
end;
--------------------------------------------------------------------------
procedure pageClose is
begin
   htp.bodyClose;
   htp.htmlClose;
end;
--------------------------------------------------------------------------
procedure editPageOpen(title in varchar2,
   left in varchar2, right in varchar2, 
   fgcolor in varchar2, bgcolor in varchar2, fontsize in number) is
begin
   htp.htmlOpen;
   htp.headOpen;
   htp.title(title);
   htp.headClose;
   htp.bodyOpen(cattributes=>'bgcolor="'||bgcolor||'"');
   htp.hr;
   htp.p('<font color="'||fgcolor||'" size='||to_char(fontsize)||'><center>');
   htp.formReset(left);
   htp.p('  '||title||'  ');
   htp.formSubmit(null,right);
   htp.p('</font></center>');
   htp.hr;
end;
--------------------------------------------------------------------------
procedure editPageOpen(title in varchar2, 
left in varchar2, right in varchar2) is
begin
   editPageOpen(title,left,right,'crimson','salmon',7);
end;
--------------------------------------------------------------------------
procedure editPageOpen(title in varchar2) is
begin
  editPageOpen(title,'Reset','Submit','crimson','salmon',7);
end;
--------------------------------------------------------------------------
procedure editPageClose is
begin
   htp.bodyClose;
   htp.htmlClose;
end;
--------------------------------------------------------------------------
procedure jsOpen is
begin
   htp.p('<script language="JavaScript">');
end;
--------------------------------------------------------------------------
procedure jsClose is
begin
   htp.p('</script>');
end;
--------------------------------------------------------------------------
procedure docOpen(iname in varchar2) is
begin
   htp.p('top.frames["'||iname||'"].document.open();');
end;
---------------------------------------------------------------------------
procedure docWrite(iname in varchar2,iscript in varchar2) is
begin
   htp.p('top.frames["'||iname||'"].document.write('''||iscript||''');');
end;
---------------------------------------------------------------------------
procedure docClose(iname in varchar2) is
begin
   htp.p('top.frames["'||iname||'"].document.close();'); 
end;
---------------------------------------------------------------------------
procedure login_form(cookie in varchar2) is
begin
	htp.formOpen('cw_bridge_jguo.auth');
	htp.formHidden('cookie',cookie);

	htp.p('<center>');
	htp.tableOpen;
	htp.tableRowOpen;
	   htp.tableData('Username:','right');
	   htp.tableData(htf.formText('iuser',32));
	htp.tableRowClose;
	htp.tableRowOpen;
	   htp.tableData('Password:','right');
	   htp.tableData(htf.formPassword('ipasswd',32));
	htp.tableRowClose;
	htp.tableClose;

	htp.para;

	htp.tableOpen(cattributes=>'border=5');
	htp.tableRowOpen;
	   htp.tableData(htf.formSubmit('iaction',' Login '),'center');
	   htp.tableData('Entry for certified CareWeb customers.
			  Please type-in your username and password
			  and then press the [Login] button.
			  For information on how to join the CareWeb
			  community, please send e-mail to 
			  careweb@npac.syr.edu.');
	htp.tableRowClose;
	htp.tableRowOpen;
	   htp.tableData(htf.formSubmit('iaction',' Register '),'center');
	   htp.tableData('Entry for Internet visitors who want to register 
			  as CareWeb friends with limited access to the database.
			  Please specify your username and password you want 
			  to use when connecting to CareWeb and then press
			  the [Register] button.');
        htp.tableRowClose;
	htp.tableRowOpen;
	   htp.tableData(htf.formSubmit('iaction',' Visit '),'center');
	   htp.tableData('Entry for Internet visitors who want to 
			  inspect the CareWeb space and remain anonymous.
			  No contact information will be requested but 
			  access to the database will be further 
			  limited.
			  Just press the [Visit] button to connect.');
	htp.tableRowClose;
	htp.tableClose;
	htp.para;
	htp.img('/hpfi/img/careweb2.gif');
	htp.p('</center>');

	htp.formClose;
  end;

-------------------------------------------------------------------------	   
end;
-------------------------------------------------------------------------	   
/
show errors
