---@ Furm 04 19 96
--Modified
--      Added the function for select_date
--      Added the function select_check
--      Added select_age and the select_flag
--      Added select_date for modify
--      Added select_age for modify
--      Added show_tick for show  form  Devel
                                  ------
--      Added show_tick for show_form asthma
--      Added select_onset for asthma
--      Added radio_check   for asthma modify
--------------------------------------------------------------------------
create or replace package cw_tom_util is
--------------------------------------------------------------------------
procedure pageOpen(title in varchar2);
procedure pageOpen(title in varchar2, fgcolor in varchar2, 
   bgcolor in varchar2, fontsize in number);
procedure editPageOpen(title in varchar2);
procedure editPageOpen(title in varchar2,
   left in varchar2,right in varchar2);
procedure editPageOpen(title in varchar2,
   left in varchar2,right in varchar2, fgcolor in varchar2, 
   bgcolor in varchar2, fontsize in number);
procedure pageClose;
procedure editPageClose;
procedure jsOpen;
procedure jsClose;
procedure docOpen(iname in varchar2);
procedure docWrite(iname in varchar2, iscript in varchar2);
procedure docClose(iname in varchar2);
procedure login_form(cookie in varchar2);
procedure select_date(name in varchar2, year_start in varchar2, year_end in varchar2);
procedure select_age(startnum in number,endnum in number); 
function select_check(name in varchar2) return varchar2;
procedure select_date(iday in date, year_start in varchar2, year_end in varchar2);
procedure select_age(val in number,startnum in number,endnum in number); 
function select_check(name in varchar2,val in varchar2) return varchar2;
function show_tick(val in varchar2) return varchar2;
function show_tick(val in varchar2,rval in varchar2) return varchar2; 
today date;
select_flag varchar2(8);
function select_onset(val in varchar2,rval in varchar2) return varchar2;
function radio_check(val in varchar2,rval in varchar2) return varchar2;
end;
/
show errors
--------------------------------------------------------------------------
create or replace package body cw_tom_util is
--------------------------------------------------------------------------
procedure pageOpen(title in varchar2, fgcolor in varchar2,
   bgcolor in varchar2, fontsize in number) is
begin
   htp.htmlOpen;
   htp.headOpen;
   htp.title(title);
   htp.headClose;
   htp.bodyOpen(cattributes=>'bgcolor="'||bgcolor||'"');
   htp.hr;
   htp.p('<font color="'||fgcolor||'" size='||to_char(fontsize)||'><center>');
   htp.p(title);
   htp.p('</font></center>');
   htp.hr;
end;
--------------------------------------------------------------------------
procedure pageOpen(title in varchar2) is
begin
  pageOpen(title,'crimson','salmon',7);
end;
--------------------------------------------------------------------------
procedure pageClose is
begin
   htp.bodyClose;
   htp.htmlClose;
end;
--------------------------------------------------------------------------
procedure editPageOpen(title in varchar2,
   left in varchar2, right in varchar2, 
   fgcolor in varchar2, bgcolor in varchar2, fontsize in number) is
begin
   htp.htmlOpen;
   htp.headOpen;
   htp.title(title);
   htp.headClose;
   htp.bodyOpen(cattributes=>'bgcolor="'||bgcolor||'"');
   htp.hr;
   htp.p('<font color="'||fgcolor||'" size='||to_char(fontsize)||'><center>');
   htp.formReset(left);
   htp.p('  '||title||'  ');
   htp.formSubmit(null,right);
   htp.p('</font></center>');
   htp.hr;
end;
--------------------------------------------------------------------------
procedure editPageOpen(title in varchar2, 
left in varchar2, right in varchar2) is
begin
   editPageOpen(title,left,right,'crimson','salmon',7);
end;
--------------------------------------------------------------------------
procedure editPageOpen(title in varchar2) is
begin
  editPageOpen(title,'Reset','Submit','crimson','salmon',7);
end;
--------------------------------------------------------------------------
procedure editPageClose is
begin
   htp.bodyClose;
   htp.htmlClose;
end;
--------------------------------------------------------------------------
procedure jsOpen is
begin
   htp.p('<script language="JavaScript">');
end;
--------------------------------------------------------------------------
procedure jsClose is
begin
   htp.p('</script>');
end;
--------------------------------------------------------------------------
procedure docOpen(iname in varchar2) is
begin
   htp.p('top.frames["'||iname||'"].document.open();');
end;
---------------------------------------------------------------------------
procedure docWrite(iname in varchar2,iscript in varchar2) is
begin
   htp.p('top.frames["'||iname||'"].document.write('''||iscript||''');');
end;
---------------------------------------------------------------------------
procedure docClose(iname in varchar2) is
begin
   htp.p('top.frames["'||iname||'"].document.close();'); 
end;
---------------------------------------------------------------------------
procedure login_form(cookie in varchar2) is
begin
	htp.formOpen('cw_bridge.auth');
	htp.formHidden('cookie',cookie);

	htp.p('<center>');
	htp.tableOpen;
	htp.tableRowOpen;
	   htp.tableData('Username:','right');
	   htp.tableData(htf.formText('iuser',32));
	htp.tableRowClose;
	htp.tableRowOpen;
	   htp.tableData('Password:','right');
	   htp.tableData(htf.formPassword('ipasswd',32));
	htp.tableRowClose;
	htp.tableClose;

	htp.para;

	htp.tableOpen(cattributes=>'border=5');
	htp.tableRowOpen;
	   htp.tableData(htf.formSubmit('iaction',' Login '),'center');
	   htp.tableData('Entry for certified CareWeb customers.
			  Please type-in your username and password
			  and then press the [Login] button.
			  For information on how to join the CareWeb
			  community, please send e-mail to 
			  careweb@npac.syr.edu.');
	htp.tableRowClose;
	htp.tableRowOpen;
	   htp.tableData(htf.formSubmit('iaction',' Register '),'center');
	   htp.tableData('Entry for Internet visitors who want to register 
			  as CareWeb friends with limited access to the database.
			  Please specify your username and password you want 
			  to use when connecting to CareWeb and then press
			  the [Register] button.');
        htp.tableRowClose;
	htp.tableRowOpen;
	   htp.tableData(htf.formSubmit('iaction',' Visit '),'center');
	   htp.tableData('Entry for Internet visitors who want to 
			  inspect the CareWeb space and remain anonymous.
			  No contact information will be requested but 
			  access to the database will be further 
			  limited.
			  Just press the [Visit] button to connect.');
	htp.tableRowClose;
	htp.tableClose;
	htp.para;
	htp.img('/hpfi/img/careweb2.gif');
	htp.p('</center>');

	htp.formClose;
end;
----------------------------------------------------------------------------------	   
procedure select_date(name in varchar2, year_start in varchar2, year_end in varchar2) is 
--------------------------------------------------------- ---------------------- 
  current_month varchar2(8);
  current_day varchar2(2);
  current_year varchar2(4);
  yr_start number(8) := to_number(year_start);
  yr_end number(8) := to_number(year_end);
begin  
   today := sysdate;
   htp.formSelectOpen('idaym', '', 1, 'onChange=""');
   for i in 1..12 loop 
     current_month := to_char(to_date(lpad(i, 2, '0'), 'MM'), 'MON');
     if (to_char(today, 'MM') = lpad(i, 2, '0')) then
       select_flag := 'SELECTED';
     else 
       select_flag := null;
     end if;
     htp.formSelectOption(current_month, select_flag, 'value="'||current_month||'"');
   end loop;
   htp.formSelectClose;
   htp.formSelectOpen('idayd', '', 1, 'onChange=""');
   for i in 1..31 loop 
     current_day := to_char(to_date('01'||i, 'MMDD'), 'DD');
     if (to_char(today, 'DD') = i) then
       select_flag := 'SELECTED';
     else 
       select_flag := null;
     end if;
     htp.formSelectOption(current_day, select_flag, 'value="'||current_day||'"');
   end loop;
   htp.formSelectClose;
   htp.formSelectOpen('idayy', '', 1, 'onChange=""');
   for i in yr_start..yr_end loop
     current_year := to_char(to_date(i, 'YYYY'), 'YYYY');
     if (to_char(today, 'YYYY') = i) then
       select_flag := 'SELECTED';
     else 
       select_flag := null;
     end if;
     htp.formSelectOption(current_year, select_flag, 'value="'||current_year||'"');
   end loop;
   htp.formSelectClose;
--   htp.tableRowClose;
--   htp.tableClose;
end;
------------------------------------------------------------------------------------
procedure select_age(startnum in number,endnum in number) is
begin
  htp.formSelectOpen('age',null,1);
  for i in startnum..endnum loop
  if (i = 16) then
      htp.formSelectOption(i,'SELECTED','value="'||i||'"');
   else
      htp.formSelectOption(i,null,'value="'||i||'"');
   end if;
   end loop;
   htp.formSelectClose;
end;   
---------------------------------------------------------------------------------
function select_check(name in varchar2) return varchar2 is
begin return('<SELECT NAME="'||name||'"> 
              <OPTION value="Yes">Yes
              <OPTION value="No" SELECTED>No
              </SELECT>');
              
  -- htf.formSelectOpen(name);
--   htf.formSelectOption('Yes',null,'value="Yes"');
 --  htf.formSelectOption('No','SELECTED','value="No"');
 --  htf.formSelectClose);
end;
-------------------------------------------------------------------------------------
procedure select_date(iday in date, year_start in varchar2, year_end in varchar2) is
-------------------------------------------------------------------------------------
  the_month varchar2(8);
  the_day varchar2(2);
  the_year varchar2(4);
  yr_start number(8) := to_number(year_start);
  yr_end number(8) := to_number(year_end);
begin
   htp.formSelectOpen('idaym', '', 1, 'onChange=""');
   for i in 1..12 loop
     the_month := to_char(to_date(lpad(i, 2, '0'), 'MM'), 'MON');
     if (to_char(iday, 'MM') = lpad(i, 2, '0')) then
       select_flag := 'SELECTED';
     else
       select_flag := null;
     end if;
     htp.formSelectOption(the_month, select_flag, 'value="'||the_month||'"');
   end loop;
   htp.formSelectClose;
   htp.formSelectOpen('idayd', '', 1, 'onChange=""');
   for i in 1..31 loop
     the_day := to_char(to_date('01'||i, 'MMDD'), 'DD');
     if (to_char(iday, 'DD') = i) then
       select_flag := 'SELECTED';
     else
       select_flag := null;
     end if;
     htp.formSelectOption(the_day, select_flag, 'value="'||the_day||'"');
   end loop;
   htp.formSelectClose;
   htp.formSelectOpen('idayy', '', 1, 'onChange=""');
   for i in yr_start..yr_end loop
     the_year := to_char(to_date(i, 'YYYY'), 'YYYY');
     if (to_char(iday, 'YYYY') = i) then
       select_flag := 'SELECTED';
     else
       select_flag := null;
     end if;
     htp.formSelectOption(the_year, select_flag, 'value="'||the_year||'"');
   end loop;
   htp.formSelectClose;
end;

---------------------------------------------------------------------------------------
procedure select_age(val in number,startnum in number,endnum in number) is
begin
  htp.formSelectOpen('age',null,1);
  for i in startnum..endnum loop
  if (i = val) then
      htp.formSelectOption(i,'SELECTED','value="'||i||'"');
   else
      htp.formSelectOption(i,null,'value="'||i||'"');
   end if;
   end loop;
   htp.formSelectClose;
end;   
------------------------------------------------------------------------------------
function select_check(name in varchar2,val in varchar2) return varchar2 is
SELECTED1 varchar2(10);
SELECTED2 varchar2(10);
begin 
     if (val = 'Yes') then
                 SELECTED1 := 'SELECTED';
                 SELECTED2 := null;
     else 
                 SELECTED1 := null;
                 SELECTED2 := 'SELECTED';
     end if;
    return('<SELECT NAME="'||name||'"> 
              <OPTION value="Yes" '||SELECTED1||'>Yes
              <OPTION value="No" '||SELECTED2||'>No
              </SELECT>');
end;
------------------------------------------------------------------------------------
function show_tick(val in varchar2) return varchar2 is
begin
    if (val = 'Yes') then
             return(htf.img('http://nova.npac.syr.edu:8110/check.gif'));
    else 
             return null;
    end if;
exception
    when others then
     cw_error.panic('cw_util_tom.show_tick', sqlerrm);
end;
-----------------------------------------------------------------------------
function show_tick(val in varchar2,rval in varchar2) return varchar2 is
begin
    if (val = rval) then
                      return(htf.img('http://nova.npac.syr.edu:8110/check.gif',cattributes=>'ALIGN="LEFT" VALIGN="MIDDLE"')||rval);
    else
           return (rval);
    end if;
exception
      when others then
      cw_error.panic('cw_util_tom.show_tick', sqlerrm);
end;

-----------------------------------------------------------------------------
function select_onset(val in varchar2,rval in varchar2) return varchar2 is
begin
    if (val = rval) then
              return (val ||', '||'SELECTED');
     else 
          return (val ||'  '||null);
    end if;
exception
      when others then
      cw_error.panic('cw_util_tom.select_onset', sqlerrm);
end;
-----------------------------------------------------------------------------
function radio_check(val in varchar2,rval in varchar2) return varchar2 is
begin
    if (val like rval) then
                    return('CHECKED');
    else
        return (null);
    end if;
exception
       when others then
      cw_error.panic('cw_util_tom.radio_check', sqlerrm);
end;
----------------------------------------------------------------------------------
end;
/
show errors
