-----------------------------------------------------------------------------
create or replace package cw_visit_util is
-----------------------------------------------------------------------------
procedure create_form;
procedure modify_form(r in cw_visit_table%rowtype);
procedure show_form(r in cw_visit_table%rowtype);
procedure select_reason(ikey in varchar2, ivalue in varchar2);
procedure actbar_form(r in cw_visit_table%rowtype);
procedure infopage_directory(cookie in varchar2, r in cw_visit_table%rowtype);
end;
/
show errors
------------------------------------------------------------------------------
create or replace package body cw_visit_util is
type keyvec_type is table of varchar2(64) index by binary_integer;
------------------------------------------------------------------------------
procedure create_form is
begin
         htp.tableOpen('BORDER',null,null,null,'CELLSPACING=3 CELLPADDING=3');

           htp.tableRowOpen;
                htp.tableHeader('Date','RIGHT');
		htp.p('<TD>');
                cw_util.select_date('day',sysdate,'1980','2010');
		htp.p('</TD>');
           htp.tableRowClose; 

           htp.tableRowOpen;
                htp.tableHeader('Reason','RIGHT');
		htp.p('<TD>');
                select_reason('reason',null);
		htp.p('</TD>');
           htp.tableRowClose;   

           htp.tableRowOpen;
                htp.tableHeader('Diagnosis','RIGHT');
                htp.tableData(htf.formTextarea('diagnosis',2,50)); 
           htp.tableRowClose; 

           htp.tableRowOpen;
                htp.tableHeader('Resolution','RIGHT');
                htp.tableData(htf.formTextarea('resolution',8,50)); 
           htp.tableRowClose;
             
           htp.tableRowOpen;
                htp.tableHeader('Comments','RIGHT');
		htp.tableData(htf.formTextarea('comments',2,50));
           htp.tableRowClose;

        htp.tableClose;
end;
-------------------------------------------------------------------------------
procedure modify_form(r in cw_visit_table%rowtype) is
begin

         htp.tableOpen('BORDER',null,null,null,'CELLSPACING=3 CELLPADDING=3');

           htp.tableRowOpen;
                htp.tableHeader('Date','RIGHT');
		htp.p('<TD>');
                cw_util.select_date('day',r.day,'1980','2010');
		htp.p('</TD>');
           htp.tableRowClose; 

           htp.tableRowOpen;
                htp.tableHeader('Reason','RIGHT');
		htp.p('<TD>');
                select_reason('reason',r.reason);
		htp.p('</TD>');
           htp.tableRowClose;   

           htp.tableRowOpen;
                htp.tableHeader('Diagnosis','RIGHT');
                 htp.tableData(htf.formTextareaOpen('diagnosis',2,50)||
			r.diagnosis||htf.formTextareaClose);
           htp.tableRowClose; 

           htp.tableRowOpen;
                htp.tableHeader('Resolution','RIGHT');
                htp.tableData(htf.formTextareaOpen('resolution',8,50)||
			r.resolution||htf.formTextareaClose);
           htp.tableRowClose;
             
           htp.tableRowOpen;
                htp.tableHeader('Comments','RIGHT');
                htp.tableData(htf.formTextareaOpen('comments',2,50)||
			r.comments||htf.formTextareaClose);
           htp.tableRowClose;

	htp.tableClose;
end;
-------------------------------------------------------------------------------

procedure show_form(r in cw_visit_table%rowtype) is
begin
        htp.tableOpen('BORDER',null,null,null,'CELLSPACING=6 CELLPADDING=6');

           htp.tableRowOpen;
                htp.tableHeader('Date','LEFT');
  		htp.tableData(to_char(r.day,'dd-Mon-yy'));              
           htp.tableRowClose; 

           htp.tableRowOpen;
                htp.tableHeader('Reason','LEFT');
		htp.tableData(r.reason);               
           htp.tableRowClose;   

           htp.tableRowOpen;
                htp.tableHeader('Diagnosis','LEFT');
		htp.tableData(r.diagnosis);
           htp.tableRowClose; 

           htp.tableRowOpen;
                htp.tableHeader('Resolution','LEFT');
                htp.tableData(r.resolution);
           htp.tableRowClose;
             
           htp.tableRowOpen;
                htp.tableHeader('Comments','LEFT');
                htp.tableData(r.comments);
           htp.tableRowClose;

	htp.tableClose;
end;   
------------------------------------------------------------------------------
procedure select_reason(ikey in varchar2, ivalue in varchar2) is
kv keyvec_type;
selected varchar2(16);
begin
   kv(1) := '----------------------';
   kv(2) := 'Pharyngitis';
   kv(3) := 'Asthma';
   kv(4) := 'Headache';
   kv(5) := 'First Aid (lacerations, bruises)';
   kv(6) := 'Ear pain';
   kv(7) := 'Rhinorrhea';
   kv(8) := 'Skin Conditions';
   kv(9) := 'Dysmmenorhea';
   kv(10) := 'Muscular/Skeletal Injury';
   kv(11) := 'Medications/Procedures';
   kv(12) := 'Psychosocial';
   kv(13) := 'Ammenorhea';
   kv(14) := 'Vomiting';
   kv(15) := 'Diarrhea';
   kv(16) := 'Constipation';
   kv(17) := 'Cough';
   kv(18) := 'Chest pain';
   kv(19) := 'Genital Discharge';
   kv(20) := 'Human/Animal Bites';
   kv(21) := 'Head Injury';

   htp.formSelectOpen('reason');
	for i in 1..21 loop
		if kv(i) = ivalue then
			selected := 'SELECTED';
		else
			selected := null;
		end if;
	htp.formSelectOption(kv(i),selected);
	end loop;
   htp.formSelectClose;	  
end;
------------------------------------------------------------------------------
procedure actbar_form(r in cw_visit_table%rowtype) is
begin
   htp.p('<font size=5>');
   htp.formSubmit('act',' Fill Assessment Form ');
   htp.formSubmit('act',' Contact NP ');
   htp.formSubmit('act',' Contact MD ');
   htp.formSubmit('act',' Consult WebMed Pages ');
   htp.formSubmit('act',' Assign Classifier ');
   htp.para; htp.hr; htp.para;
   htp.formSubmit('act',' Sign and File this Progress Note ');
   htp.formPassword('sign',32);
   htp.p('</font>');
end;
------------------------------------------------------------------------------
procedure infopage_directory(cookie in varchar2, r in cw_visit_table%rowtype) is
url varchar2(128) := cw_util.getURL;
begin
  
   cw_util.pageOpen(r.reason||': Information Pages','crimson','ivory',8);
   htp.p('<font size=7>');
   if r.reason = 'Pharyngitis' then
	htp.ulistOpen;
	htp.listItem(htf.anchor(
	   url||'Pharyntest',
	   'Pharyngitis - Educational Materials'));
	htp.p(' by Maureen Thompson, Syracuse University');
	htp.para;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/sangeeta/maureen_dsk/pharyn_mgmt.html',
	   'Pharyngitis - Management Algorithm'));
 	htp.para;
	htp.listItem(htf.anchor(
	   url||'pediatric_diagnosis',
	   'Pharyngitis - Pediatric Differential Diagnosis'));
	htp.para;
	htp.listItem(htf.anchor(
	   url||'sore_throat_page',
	   'Note to Parents - Sore Throat'));
	htp.para;
	htp.listItem(htf.anchor(
	   url||'throat_culture_page',
	   'Note to Farents - Throat Culture'));
	htp.para; 
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/projects/careweb/sites.html',
	   'Web Sites'));	   	
	 htp.ulistClose;
   elsif r.reason = 'Asthma' then
	htp.ulistOpen;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/users/sangeeta/maureen_dsk/asthma.html',
	   'Executive Sumary: 
		Guidelines for the Diagnosis and Management of Asthma'));
	htp.p(' by National Institute of Health');

	htp.para;
	htp.listItem(htf.anchor(
	'http://www.npac.syr.edu/users/sangeeta/maureen_dsk/sn_asthma_trt.html',
	   'School Nurse Asthma Treatment Protocol'));
	htp.para;
	htp.listItem(htf.anchor(
	'http://www.npac.syr.edu/users/sangeeta/maureen_dsk/np_asthma_trt.html',
	   'Nurse Practitioner Asthma Treatment Protocol'));
	htp.para;
	htp.listItem(htf.anchor(
	   'http://www.npac.syr.edu/projects/careweb/sites.html',
	   'Web Sites'));	   
	 htp.ulistClose;
   else
	htp.p('Not Implemented Reason = '||r.reason);
   end if;
   htp.p('</font>');

end;
-------------------------------------------------------------------------------
end;
/
show errors
